//=================================================================================================
//            Тест выводит параметры платы в консоль (монитор порта)
// (тест включает опцию сканирования шины i2c - если на шине нет устройств,
//                  sda,scl следует подтянуть к Vcc через R=10-47кОм)
//=================================================================================================
#include "RT_HW_BASE.h"
char modePin='A'; //--Формат вывода пинов  [D-десятичный,T-текстовый,        A-комбинированный]
char modeAdr='A'; //--Формат вывода адресов[D-десятичный,H-шестнадцатеричный,A-комбинированный]
bool blink;
RT_HW_PIN_DIR_ID idPinControl, idPinLed;  //--id для работы с пинами;
RT_HW_GENERATOR_EVENT_ID idGen;           //--id для генератор событий (return+id.event), меандров(id.meander);
#include "Util_i2c.hpp"   //--Локальная функция сканирования i2c;
//-------------------------------------------------------------------------------------------------
void setup() {}
//-------------------------------------------------------------------------------------------------
void loop() {
RT_HW_Base.consoleBegin();
if(RT_HW_Base.console.head){
//-------------------------------------------------------------------------------------------------
RT_HW_Base.console.alig='R'; RT_HW_Base.console.blank=' ';
RT_HW_Base.console.modePin=modePin;
RT_HW_Base.console.modeAdr=modeAdr;
//RT_HW_Base.device.pin.control=10;     //--Изменение пина control, установленный библиотекой под используемый контроллер;
//RT_HW_Base.device.pin.led=10;         //--Изменение пина led,     установленный библиотекой под используемый контроллер;RT_HW_BOARD_PI_PICO
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<3; i++) {RT_HW_Base.consoleCR();}                   
RT_HW_Base.consoleHead(String(F("Test board")),'=',80);
//-------------------------------------------------------------------------------------------------
RT_HW_Base.consoleHead(String(F("Main parameters")));       RT_HW_Base.consoleBoardGeneral();
                                                            RT_HW_Base.consoleBoardAdd();        
RT_HW_Base.consoleHead(String(F("Task parameters")));       RT_HW_Base.consoleShedulerParameters();          
RT_HW_Base.consoleHead(String(F("Available pins")));        RT_HW_Base.consolePinsAll();
RT_HW_Base.consoleHead(String(F("Interface")));             RT_HW_Base.consoleInterface(); 
RT_HW_Base.consoleHead(String(F("Array PROGMEM")));         RT_HW_Base.consoleFromPGM();  
RT_HW_Base.consoleHead(String(F("Scan i2c")));                       
RT_HW_Base.consoleScanWire(0);                              //--Сканирование шины i2c0;
//RT_HW_Base.consoleScanWire(1);                            //--Сканирование шины i2c1;
//--------------------------------------------------------------------------------------------------
//RT_HW_Base.device.pin.control=10;     //--Изменение пина control, установленный библиотекой под используемый контроллер;
//RT_HW_Base.device.pin.led=10;         //--Изменение пина led,     установленный библиотекой под используемый контроллер;RT_HW_BOARD_PI_PICO
RT_HW_Base.consoleHead(String(F("Pins used in the test"))); 
RT_HW_Base.consoleVar(String(F("Pin control=")));           RT_HW_Base.consoleVar(RT_HW_Base.device.pin.control,'E',0,'P');
RT_HW_Base.consoleVar(String(F("Pin Led on the board ="))); RT_HW_Base.consoleVar(RT_HW_Base.device.pin.led,    'E',0,'P');
RT_HW_Base.consoleLine('-',80);
i2cScanNum(0);                          //--Сканирование шины i2c0 встроенныый в тест утилитой;                                        
i2cScanNum(1);                          //--Сканирование шины i2c1 встроенныый в тест утилитой;   
//-------------------------------------------------------------------------------------------------
RT_HW_Base.consoleLine('+',80);
//------------------------------------------------------------------------------------------------- 
} //--END console.head
//-------------------------------------------------------------------------------------------------
blink=!blink;
                                           RT_HW_Base.pinDigitalWrite(idPinControl,RT_HW_Base.device.pin.control,'N',blink);
if(RT_HW_Base.generatorEvent(idGen,1,500)){RT_HW_Base.pinDigitalWrite(idPinLed,    RT_HW_Base.device.pin.led,    'N',idGen.meander);}
//-------------------------------------------------------------------------------------------------
} //--END loop();
