

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Библиотеки привязки к Arduino
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(ARDUINO) && (ARDUINO >= 100) 
#include <Arduino.h>
#else
#include <WProgram.h>
#endif
#include <stdint.h>
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							1.Макросы для RT_HW_BASE
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_MICROS				micros()				//--Макрос измерения времени в mcs;
#define RT_HW_MILLIS				millis()				//--Макрос измерения времени в ms;
#define RT_HW_BREAK_CHAR			'~'						//--Блокирующий символ для работы со строками;
#define RT_HW_BLANK_CHAR			' '						//--Cимвол для заполнения своюбодного поля;
#define RT_HW_READ_BYTE_PGM(arr,n) 	pgm_read_byte(&arr[n])	//--Чтение из массива arr n байта;

#define RT_HW_DEFAULT_T_NAN -1
#define RT_HW_DEFAULT_H_NAN  1

#define RT_HW_DELAY(x) if(x>0){do{for(int i=0;i<x;i++) {asm volatile("nop");}}while(0);}  //--Задержка в у.е.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							2.Макросы для ускоренных битовых операций
// code для битов 0-7->1,2,4,6,8,16,32,64,128
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_BIT_SET(state,code)               (state) |= (code)			//--Установка бита;
#define RT_HW_BIT_CLEAR(state,code)             (state) &=~(code)			//--Очистка бита;			
#define RT_HW_BIT_BLINK(state,code)             (state) ^= (code)			//--Инверсия бита;
#define RT_HW_BIT_READ(state,code)        (bool((state) &  (code)))			//--Чтение бита;
#define RT_HW_BIT_WRITE(state,code,val) if(val){(state) |= (code);}\
                                          else {(state) &=~(code);} 		//--Запись бита;									  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define  RT_HW_BIT_QUICK_NUM_0 	1
#define  RT_HW_BIT_QUICK_NUM_1 	2
#define  RT_HW_BIT_QUICK_NUM_2 	4
#define  RT_HW_BIT_QUICK_NUM_3 	8
#define  RT_HW_BIT_QUICK_NUM_4 	16
#define  RT_HW_BIT_QUICK_NUM_5 	32
#define  RT_HW_BIT_QUICK_NUM_6 	64
#define  RT_HW_BIT_QUICK_NUM_7 	128
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							3.Макросы для поиска на шине i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++;
#define RT_HW_I2C_FIND_QNT    		 3   	//--Кол-во повторений при поиске адреса;
#define RT_HW_I2C_FIND_PERIOD_CUR   20   	//--Штатный период(ms) при нормальном поиске адреса;
#define RT_HW_I2C_FIND_PERIOD_MAX 2000    	//--Кол-во повторений при поиске адреса;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							4.Макросы для SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++;
#define RT_HW_SPI_MSBFIRST 1
#define RT_HW_SPI_LSBFIRST 0
#define RT_HW_SPI_MODE0    0
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++