 #include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структуры системных параметров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++				  
struct RT_HW_STRUCT_BUFF	{uint8_t vu8; int8_t vi8; uint16_t vu16; uint32_t vu32;};
struct RT_HW_STRUCT_BOARD   {uint8_t  codeArch, codeBoard;};			//--Параметры контр.(архитектура и пр.);
struct RT_HW_STRUCT_PIN   	{uint8_t  control,led,button,ws;};			//--Структура для пинов платы;  
struct RT_HW_STRUCT_DEPTH 	{uint8_t  sys,adc,pwm,dac,tch,vNull,drift;};//--Разрешения устройств и дрейфы ADC; 
struct RT_HW_STRUCT_PWM   	{uint16_t channel; uint16_t freq;};			//--PWM; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Обобщенная структура для работы с устройствами контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_DEVICE{
RT_HW_STRUCT_BOARD  board;	//--Данные для работы с общими параметрами контроллера (архитектура и пр.);
RT_HW_STRUCT_PIN  	pin;	//--Данные для работы с системными пинами control,led;
RT_HW_STRUCT_DEPTH	depth;	//--Данные для работы с разрядностью (разрешениями) устройств;
RT_HW_STRUCT_PWM 	pwm;	//--Данные для работы с PWM;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Структуры для работы с консолью
// dir  - этапы настройки консоли;
// ok 	- флаг готовности консоли;
// head - флаг разрешения вывода заголовков (включается на один цикл вместе с готовностью консоли); 
// numUart	 -номер Uart(0-8) - аппаратные UART; Uart=9 -программный UART;  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_CONSOLE {uint8_t dir=0; uint8_t ok=0; uint8_t head=0; uint8_t all=0; uint8_t numUart=0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

