//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структуры работы с UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_UART_RXTX{uint16_t begin=0;   uint16_t ready=0;};	
struct RT_HW_STRUCT_UART_USB {uint32_t timeBegin; uint16_t dir=0;};
struct RT_HW_STRUCT_UART     {
	uint8_t  state=0;
	uint32_t speed=115200;
#if defined(SERIAL_8N1)
	uint32_t config=SERIAL_8N1;
#else 
	uint32_t config=0x800001C;
#endif	
	uint8_t  rx=255; 
	uint8_t  tx=255;
	uint8_t  dir=0;
//	uint8_t  mode=0; // =0 - UART; =2 -USB;
	//uint8_t ready=0;
};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структуры работы с i2с
// status: =0-No init; =1 -Master; =2 -Slave;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_I2C {
	uint8_t  sda=255; 
	uint8_t  scl=255;  
	uint8_t  adr=255; 
	uint32_t speed=400000UL; 
	uint8_t  state=0; 
	uint8_t  codeErr=0; 
	uint8_t  status=0;
}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Структуры работы с SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_SPI {
	uint8_t sck=255; 
	uint8_t mosi=255; 
	uint8_t miso=255; 
	uint8_t ss=0; 
	uint8_t cs=255;
	uint32_t speed=RT_HW_SPI_SPEED*1000UL;	
	//uint8_t  delaySPN=RT_HW_SPN_DELAY;
	uint8_t  bitOrder=MSBFIRST; 
	uint8_t  dataMode=SPI_MODE0; 
	uint8_t  interruptMode=0;
	uint8_t  state=0;  
	uint8_t  codeErr=0; 
	uint8_t  status=0;
};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Структуры работы с 1-WIRE
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_ONE_WIRE {
	RT_HW_PIN_DIR_ID dd; 
	uint8_t custom=0; 
	uint8_t dir=0; 
	uint8_t step=0; 
	uint8_t state; 
	uint8_t bus; 
	uint32_t timeDelay; 
	uint8_t stepDelay=0;
	unsigned char ROM_NO[8];
	uint8_t LastDiscrepancy;
	uint8_t LastFamilyDiscrepancy;
	bool    LastDeviceFlag;	
};
//=================================================================================================
