//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для DHT22
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_DHT22_ID{
uint8_t  dir=0;					//--Управление этапами управления в функции direct();
uint8_t  step;					//--Управление этапами управления во внешней функции;
uint8_t  extPin=255; 			//--Значение пина из внешнего блока;
uint8_t  pin=255;				//--Текущий номер пина;
uint8_t  codeErr;				//--Код ошибки;
uint8_t  qntMaxErr=3;			//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;					//--Рабочий счетчик;
uint32_t timeBegin;				//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;			//--Используется функцией timeDelay();
uint16_t sizeDelay;				//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;	
uint32_t timeStart;				//--Используется функцией измерения;
uint8_t  run=0;					//--Флаг запуска измерения;
uint8_t  fresh:1,ok:1,err:1,action:1,blockInterrupts:1,modeDelay:1;	//--Флаги;
float    vTemp,vHum;						//--Измеренные параметры;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для DS1820
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_DS1820_ID{
uint8_t  dir=0;					//--Этапы основной программы управления устройствами;
uint8_t  step=0;				//--Управление этапами управления во внешней функции;
uint8_t  extPin=255; 			//--Новое значение пина (можно считать перед началом измерения);
uint8_t  pin=255;				//--Номер пина;
uint8_t  maxQntErr;				//--Максимальное допустимое подряд кол-во ошибочных измерений;
uint8_t  ok;					//--Флаг устойчивой работоспособности сенсора;
uint8_t  fresh;					//--Готовность данных;
uint8_t  run;					//--Флаг "Команда на запуск измерения;
uint8_t  codeErr;				//--Код последней ошибки измерения;
uint8_t  cntErrCur; 			//--Cчетчик ошибок;
uint32_t timeBegin;				//--Рабочий регистр;
uint16_t cntOk;					//--Счетчик успешных измерений;
uint8_t  cntErr;				//--Счетчик ошибочных измерений;
//-------------------------------------------------------------------------------------------------
uint8_t  blockInterrupts;		//--Флаг разрешения блокировки прерываний;
uint8_t  typeSensor=0;			//--Модификация сенсора: =0 новая, =1 старая;
int16_t  vT;					//--Температура;	
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Структура для сенсора HC-SR04 (32 байта)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_HC_SR04_ID{
RT_HW_PIN_DIR_ID ddPin;
uint8_t  dir=0;					//--Этапы управления основной программы;
uint8_t	 extPinEcho=255;		//--Новое значение пина Echo(можно считать перед началом измерения);
uint8_t  extPinTrig=255;		//--Новое значение пина Trig(можно считать перед началом измерения);
uint8_t	 pinEcho=255;			//--Номер пина Echo;
uint8_t  pinTrig=255;			//--Номер пина Trig;
uint8_t  maxQntErr;				//--Максимальное допустимое подряд кол-во ошибочных измерений;
uint8_t  ok;					//--Флаг устойчивой работоспособности сенсора;
uint8_t  fresh;					//--Готовность данных;
uint8_t  run;					//--Флаг "Команда на запуск измерения;
uint8_t  codeErr;				//--Код последней ошибки измерения;
uint8_t  cntErrCur; 			//--Cчетчик ошибок;
uint16_t cntOk;					//--Счетчик успешных измерений;
uint8_t  cntErr;				//--Счетчик ошибочных измерений;
//---------------------------------------------------------------------------------------------------
uint16_t maxLen=400;			//--Максимальное расстояние измерения;
int8_t   tmpAir=-100;			//--Температура воздуха;
int8_t   extAir=23;				//--Внешнее значение температуры воздуха
//---------------------------------------------------------------------------------------------------
uint8_t	 enableIRQ=1;			//--Разрешение режима с прерываниями;
int8_t 	 numIRQ;				//--Номер аппаратного прерывания;
uint8_t  modeIRQ;				//--Режим работы: =0 -без прерываний; =1 -с прерываниями на пине Echo; 
uint8_t  begin,end;				//--Флаги для отслеживания прерываний;
uint8_t  modeFilter=3;			//--Тип фильтра;
float    speedSoundAir;			//--Скорость звука (функция от температуры);
uint16_t echoMcs, LenMcs;		//--Расстояние в mcs от сенсора и с фильтром(внешним); 
volatile uint8_t  state;
volatile uint32_t timeStart;
volatile uint32_t timeCur;
volatile uint32_t timeBegin;
volatile uint32_t timeEnd;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для MAX6675
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_MAX6675_ID{ 
uint8_t  dir=0;								//--Управление этапами управления в функции direct();
uint8_t  step;								//--Управление этапами управления во внешней функции;
uint32_t clock=4000000;		//--
uint8_t  time=0;
uint8_t	 bus=0;				//--SPI->номер шины SPI;
uint8_t  sck=255;			//--Номер пина sck;
uint8_t  cs=255;			//--Номер пина cs;
uint8_t  so=255;			//--Номер пина so;
uint8_t	 codeErr;			//--Код ошибки;
uint8_t  qntMaxErr=5;						//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt=0;								//--Рабочий счетчик;
uint32_t timeBegin;							//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;						//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;
uint16_t sizeDelay;							//--Вычисляемая задержка для функции timeDelay();
uint8_t  mi:1,run:1,fresh:1,ok:1,action:1,err:1,blockIntterrupt:1;	//--Тип интерфейса: =0-SPI,=1-SSPI;
uint16_t rawData;			//--Регистр для чтения данных;
float 	 vTemp;				//--Измеренная температура;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для HTU21
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  													 
struct RT_HW_STRUCT_HTU21_ID { 		  
uint8_t  custom=0;					//--Состояние настройки ID: 0-нет,1-успешно, >1-ошибки;
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  step=0;					//--Управление этапами управления в функциях измерения;
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x40;					//--Адрес i2c по  умолчанию; 
uint32_t speed=400000UL;			//--Скорость шины;
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint8_t  cntStatus;					//--Счетчик для повторной проверки статуса сенсора;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay();
uint8_t  runTemp:1,   runHum:1,		//--Флаги запуска чтения Temp,Hum;
		 freshTemp:1, freshHum:1;	//--Флаги готовности Temp,Hum;
uint8_t  run:1,fresh:1,ok:1,action:1,err:1;	//--Флаги;		 
float    vTemp,vHum;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для AHT20
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_AHTXX_ID{ 
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  step;						//--Управление этапами управления в функциях измерения;
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x38;					//--Адрес i2c по умолчанию;
uint32_t speed=400000UL;			//--Скорость шины;
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint8_t  cntStatus;					//--Счетчик для повторной проверки статуса сенсора;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay();
uint8_t  run:1,fresh:1,ok:1,action:1,err:1;	//--Флаги;
float    vTemp, vHum;				//--Измеренные значения;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для BH1750 (сенсор освещенности)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_BH1750_ID{ 
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x23;					//--Адрес i2c по умолчанию;
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;
uint8_t  run:1,fresh:1,ok:1,action:1,err:1;	//--Флаги;
uint32_t vLux;						//--Измеренное значения;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для BMP180/085
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_BMP180_ID{ 
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  step;						//--Управление этапами управления в функциях измерения;
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x77;					//--Адрес i2c по умолчанию;
uint32_t speed=400000UL;			//--Скорость шины;
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;	
uint8_t  runTemp:1,runPress:1,fresh:1,ok:1,action:1,err:1;	//--Флаги;
uint8_t  OverPress=1;				//--Скорость вывода давления:0,1,2,3;
uint8_t  delayPress;				//--Регистр для задержки при измерении давления;
//-------------------------------------------------------------------------------------------------
int16_t  AC1,AC2,AC3,VB1,VB2,MB,MC,MD;	//--Корректирующие коэффициенты из сенсора;
uint16_t AC4,AC5,AC6; 			
float    c3,c4,b1;				
float    c5,c6,mc,md,x0,x1,x2,y0,y1,y2,p0,p1,p2;
//-------------------------------------------------------------------------------------------------
float    vTemp, vPress;			//--Измеренные значения;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для BME280
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
struct RT_HW_STRUCT_BMP280_ID{ 
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  step;						//--Управление этапами управления в функциях измерения;
char	 mi='I';					//--Тип интерфейса;
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x76;					//--Адрес i2c по умолчанию;
uint32_t speed=400000UL;			//--Скорость шины;
uint8_t  sck=255;					//--Номер пина clk  для SSPI;
uint8_t  miso=255;					//--Номер пина miso для SSPI;
uint8_t  mosi=255;					//--Номер пина mosi для SSPI;
uint8_t  cs=255;					//--Номер пина cs   для SSPI(SPI)
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Используется функцией timeDelay();
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;		
uint8_t  permitHum:1,runTemp:1,runHum:1,runPress:1;	//--Флаги;
uint8_t  runTemp:1,runHum:1,runPress:1;	//--Флаги;
uint8_t  initFresh:1,fresh:1,ok:1,action:1,err:1;
//----Определение значения параметров сенсора (могут быть изменены пользователем)------------------
uint8_t  mode   =0b011;		//--Режимы работы:  =00      спящий режим->нет операций, доступны все регистры, наименьшее энергопотребление, выбирается после запуска; 
                            //                  =01 & 10 принудительный режим->выполняет одно измерение, сохраняет результаты и возвращается в  спящий режим;
							//				    =11      нормальный режим-> постоянный цикл измерений и неактивные периоды;
uint8_t  t_sb   =0b000;		//--Период между измерениями температуры->=000:0.5ms; =001:62.5ms; =010:125ms; =011:250ms; =100:500ms; =101:1000ms; =110:10ms; =111:20ms;
uint8_t  filter	=0b001;		//--Коэф.фильтраци: =000 =фильтр отключен;
							//                  =001 =2;
							//                  =010 =4;
							//                  =011 =8;
							//                  =101 =16;							
uint8_t  osrs_t	 =0b001;	//--Коэф.передискредитации (усреднения) данных температуры=16; При включенном фильтре разрешение АЦП=20 бит.);
uint8_t  osrs_h	 =0b001;	//--Коэф.передискредитации (усреднения) данных влажности  =16; Разрешение АЦП=16 бит.);
uint8_t  osrs_p	 =0b001;	//--Коэф.передискредитации (усреднения) данных давления   =16; При включенном фильтре разрешение АЦП=20 бит.);
uint8_t  spi3w_en=0b000;	//--Режим работы SPI: =0 -четырехпроводный; =1 -трехпроводнsй;
uint8_t  modeChip=0;		//--Идентифицируемый из устройства код сенсора; 
//-------------------------------------------------------------------------------------------------
//uint8_t  vCONFIG;
//uint8_t  vCTRL_HUM;
//uint8_t  vCTRL_MEAS;
uint8_t  chipID;			//--Идентификатор чипа из сенсора;
int32_t  t_fine;
int32_t  t_fine_adjust=0;
uint8_t  val;				//--буфер для значений из сенсора
//----Коэффициенты---------------------------------------------------------------------------------
uint16_t dig_T1; int16_t dig_T2, dig_T3;	//--
uint8_t  dig_H1; int16_t dig_H2; uint8_t dig_H3; int16_t dig_H4, dig_H5; int8_t dig_H6;
uint16_t dig_P1; int16_t dig_P2, dig_P3, dig_P4, dig_P5, dig_P6, dig_P7, dig_P8, dig_P9;
//-------------------------------------------------------------------------------------------------
int32_t  adc_T,adc_H,adc_P;
float    vTemp, vPress, vHum;	//--Измеренные значения;
};
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для BME280
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_BME280_ID{ 
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  step;						//--Управление этапами управления в функциях измерения;
char	 mi='I';					//--Тип интерфейса;
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x76;					//--Адрес i2c по умолчанию;
uint32_t speed=400000UL;			//--Скорость шины;
uint8_t  sck=255;					//--Номер пина clk  для SSPI;
uint8_t  miso=255;					//--Номер пина miso для SSPI;
uint8_t  mosi=255;					//--Номер пина mosi для SSPI;
uint8_t  cs=255;					//--Номер пина cs   для SSPI(SPI)
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Используется функцией timeDelay();
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;		
uint8_t  permitTemp:1, permitPress:1, permitHum:1,
            runTemp:1,    runPress:1,    runHum:1;	//--Флаги;
uint8_t  initFresh:1,fresh:1,ok:1,action:1,err:1;
//----Определение значения параметров сенсора (могут быть изменены пользователем)------------------
uint8_t  mode   =0b011;		//--Режимы работы:  =00      спящий режим->нет операций, доступны все регистры, наименьшее энергопотребление, выбирается после запуска; 
                            //                  =01 & 10 принудительный режим->выполняет одно измерение, сохраняет результаты и возвращается в  спящий режим;
							//				    =11      нормальный режим-> постоянный цикл измерений и неактивные периоды;
uint8_t  t_sb   =0b000;		//--Период между измерениями температуры->=000:0.5ms; =001:62.5ms; =010:125ms; =011:250ms; =100:500ms; =101:1000ms; =110:10ms; =111:20ms;
uint8_t  filter	=0b001;		//--Коэф.фильтраци: =000 =фильтр отключен;
							//                  =001 =2;
							//                  =010 =4;
							//                  =011 =8;
							//                  =101 =16;							
uint8_t  osrs_t	 =0b001;	//--Коэф.передискредитации (усреднения) данных температуры=16; При включенном фильтре разрешение АЦП=20 бит.);
uint8_t  osrs_h	 =0b001;	//--Коэф.передискредитации (усреднения) данных влажности  =16; Разрешение АЦП=16 бит.);
uint8_t  osrs_p	 =0b001;	//--Коэф.передискредитации (усреднения) данных давления   =16; При включенном фильтре разрешение АЦП=20 бит.);
uint8_t  spi3w_en=0b000;	//--Режим работы SPI: =0 -четырехпроводный; =1 -трехпроводнsй;
uint8_t  modeChip=0;		//--Идентифицируемый из устройства код сенсора; 
//-------------------------------------------------------------------------------------------------
//uint8_t  vCONFIG;
//uint8_t  vCTRL_HUM;
//uint8_t  vCTRL_MEAS;
uint8_t  chipID;			//--Идентификатор чипа из сенсора;
int32_t  t_fine;
int32_t  t_fine_adjust=0;
uint8_t  val;				//--буфер для значений из сенсора
//----Коэффициенты---------------------------------------------------------------------------------
uint16_t dig_T1; int16_t dig_T2, dig_T3;	//--
uint8_t  dig_H1; int16_t dig_H2; uint8_t dig_H3; int16_t dig_H4, dig_H5; int8_t dig_H6;
uint16_t dig_P1; int16_t dig_P2, dig_P3, dig_P4, dig_P5, dig_P6, dig_P7, dig_P8, dig_P9;
//-------------------------------------------------------------------------------------------------
int32_t  adc_T,adc_H,adc_P;
float    vTemp, vPress, vHum;	//--Измеренные значения;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Структура для SHT31
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_SHT31_ID{ 
uint8_t  dir=0;						//--Управление этапами управления в функции direct();
uint8_t  step;						//--Управление этапами управления в функциях измерения;
uint8_t  bus=0;						//--Номер шины;
uint8_t  adr=0x44;					//--Адрес i2c по умолчанию;
uint32_t speed=400000UL;			//--Скорость шины i2c;
uint16_t cmnd=0x2400;				//--Table 9 page 10 datasheet;
uint8_t  codeErr;					//--Код ошибки при обмене;
uint8_t  qntMaxErr=5;				//--Максимальное кол-во повторяемых ошибок;
uint8_t  cnt;						//--Рабочий счетчик;
uint32_t timeBegin;					//--Используется функцией timeDelay(timeBegin,stepDelay,sizeDelay);
uint8_t  stepDelay=0;				//--Вычисляемая задержка для функции timeDelay(),используется также для поиска на шине i2c;
uint16_t sizeDelay;					//--Вычисляемая задержка для функции timeDelay();
uint8_t  run:1,fresh:1,ok:1,action:1,err:1;	//--Флаги;
float    vTemp, vHum;				//--Измеренные значения;
};
//=================================================================================================
