//*************************************************************************************************
//							1.Контроллер BLACKPILL_F401CC
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && defined(RT_HW_BOARD_D_BLACKPILL_F401CC)
//---------------------------------------------------------------------------------------------------
#define        RT_HW_BOARD_SELECT	           "BOARD (D) BLACKPILL F401CC)"
//------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY 	  "FLASH=512Kb; RAM=128Kb;"						//--Параметры памяти;
#define RT_HW_PERMIT_UART0  //--USB;
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_I2C1
#define RT_HW_PERMIT_SPI0	
//#define RT_HW_PERMIT_SPI1
#define RT_HW_PERMIT_DAC													//--Разрешение работы с DAC;	
//------Системные пины-----------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=PB5, RT_HW_BOARD_LED=PC13, RT_HW_BOARD_BUTTON=PA1, RT_HW_BOARD_WS=255};//--Пины контроль,led,кнопка;
//------Параметры контроллера общие----------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=46,	RT_HW_FCPU=84, 		RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=PA12, RT_HW_UART0_TX=PA11, //--USB;
		RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9,  
		RT_HW_UART2_RX=PA3,  RT_HW_UART2_TX=PA2};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=PB7,  RT_HW_I2C0_SCL=PB6,  RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM,
        RT_HW_I2C1_SDA=PB3,  RT_HW_I2C1_SCL=PB10, RT_HW_I2C1_MODE_FM=RT_HW_I2C_MODE_FM}; 
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=PA5,  RT_HW_SPI0_MISO=PA6,  RT_HW_SPI0_MOSI=PA7,  RT_HW_SPI0_SS=PA4,  
        RT_HW_SPI1_SCK=PB13, RT_HW_SPI1_MISO=PB14, RT_HW_SPI1_MOSI=PB15, RT_HW_SPI1_SS=PB12};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[] 	={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[] 	={12,16,20,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[] 	={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[] 	={16,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[] 	={					RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL, RT_HW_I2C1_SDA, RT_HW_I2C1_SCL,  RT_HW_PGM_END}; //--adr,SDA,SCL,mode; 
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    															RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK, RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS,
											  RT_HW_SPI1_SCK, RT_HW_SPI1_MISO, RT_HW_SPI1_MOSI, RT_HW_SPI1_SS,	RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={																	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX, RT_HW_UART0_TX, 
										      RT_HW_UART1_RX, RT_HW_UART1_TX, 
											  RT_HW_UART2_RX, RT_HW_UART2_TX,	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={ 							 		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={									RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={									RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, 255, 255,PA15,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15,
										      PC13,PC14,PC15,	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, 255, 255,PA15,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PB0,PB1,		  					 RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={						 												 RT_HW_PGM_END};									
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, 255, 255,PA15,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15,
										      255,255,255,255,255,255,255,255,255,255, 255, 255, 255,PC13,PC14,PC15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={PA0,PA1,PA2,PA3,255,PA5,PA6,PA7,PA8,PA9,PA10,PA11, 255, 255, 255, 255,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255, 255,PB13,PB14,PB15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={																		 RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13, 255, 255,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15, RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={																		 RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  ={						RT_HW_PGM_END};	// debug1,debug2,debug3,debug4;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[]  ={PB0,255,PB1,PB10,		RT_HW_PGM_END};	// PWM0, PWM1, led,dev;
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[]  ={PA0,255,PA1, 			RT_HW_PGM_END};	// A0,   A1, btn1,btn2,btn3;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[]  ={         				RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[]  ={PB8, 255, 255, PB9, 	RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04.Echo,HC-SR04.Trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[]  ={PB12,PB13,PB14,PB15,	RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  ={						RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  ={						RT_HW_PGM_END};	// Пины(дополнительные[]  TFT дисплея(SPI[] ;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[]  ={ 1, 2, 				RT_HW_PGM_END};	//--UART: ModBus, Nextion 
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[] ={63,62,32,33,			RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;		
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							2.Контроллер BLACKPILL_F411CE 
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && defined(RT_HW_BOARD_D_BLACKPILL_F411CE)
//---------------------------------------------------------------------------------------------------
#define        RT_HW_BOARD_SELECT	           "BOARD (D) BLACKPILL F411CE)"
//------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY 	  "FLASH=512Kb; RAM=128Kb;"						//--Параметры памяти;
#define RT_HW_PERMIT_UART0  //--USB;
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_I2C0
#define RT_HW_PERMIT_I2C1
#define RT_HW_PERMIT_SPI0	
//#define RT_HW_PERMIT_SPI1	
#define RT_HW_PERMIT_DAC													//--Разрешение работы с DAC;
//------Системные пины-----------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=PB5, RT_HW_BOARD_LED=PC13, RT_HW_BOARD_BUTTON=PA1, RT_HW_BOARD_WS=255};//--Пины контроль,led,кнопка;
//------Параметры контроллера общие----------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=46,	RT_HW_FCPU=84, 		RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=PA12, RT_HW_UART0_TX=PA11, //--USB;
		RT_HW_UART1_RX=PA10, RT_HW_UART1_TX=PA9,  
		RT_HW_UART2_RX=PA3,  RT_HW_UART2_TX=PA2};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=PB7,  RT_HW_I2C0_SCL=PB6,  RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM,
        RT_HW_I2C1_SDA=PB3,  RT_HW_I2C1_SCL=PB10, RT_HW_I2C1_MODE_FM=RT_HW_I2C_MODE_FM}; 
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=PA5,  RT_HW_SPI0_MISO=PA6,  RT_HW_SPI0_MOSI=PA7,  RT_HW_SPI0_SS=PA4,  
        RT_HW_SPI1_SCK=PB13, RT_HW_SPI1_MISO=PB14, RT_HW_SPI1_MOSI=PB15, RT_HW_SPI1_SS=PB12};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[] 	={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[] 	={12,16,20,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[] 	={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[] 	={16,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[] 	={					RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led; 
//const uint8_t PROGMEM RT_HW_PGM_SYS_PIN[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON,          RT_HW_PGM_END};  //--Пины->control,led; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL,  RT_HW_I2C1_SDA,  RT_HW_I2C1_SCL, RT_HW_PGM_END}; //--adr,SDA,SCL,mode; 
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    															RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK, RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS,
											  RT_HW_SPI1_SCK, RT_HW_SPI1_MISO, RT_HW_SPI1_MOSI, RT_HW_SPI1_SS,	RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={																	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX, RT_HW_UART0_TX, 
										      RT_HW_UART1_RX, RT_HW_UART1_TX, 
											  RT_HW_UART2_RX, RT_HW_UART2_TX,	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={ 							 		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={									RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={									RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, 255, 255,PA15,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15,
										      255,255,255,255,255,255,255,255,255,255, 255, 255, 255,PC13,PC14,PC15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, 255, 255,PA15,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PB0,PB1,		  					 RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[]   ={						 												 RT_HW_PGM_END};									
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12, 255, 255,PA15,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15,
										      255,255,255,255,255,255,255,255,255,255, 255, 255, 255,PC13,PC14,PC15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[]  	={PA0,PA1,PA2,PA3,255,255,PA6,PA7,PA8,PA9,PA10,PA11, 255, 255, 255, 255,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255, 255,PB13,PB14,PB15, RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={																		 RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7,PA8,PA9,PA10,PA11,PA12,PA13, 255, 255,
										      PB0,PB1,255,PB3,PB4,PB5,PB6,PB7,PB8,PB9,PB10, 255,PB12,PB13,PB14,PB15, RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={PA0, PB5,																 RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[] 	={						RT_HW_PGM_END};	// debug1,debug2,debug3,debug4;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={PB0,255,PB1,PB10,		RT_HW_PGM_END};// PWM0, PWM1, led,dev;
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={PA0,255,PA1, 			RT_HW_PGM_END};	// A0,   A1, btn1,btn2,btn3;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[]  	={         				RT_HW_PGM_END};	// DAC0,DAC1,TCH0;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[]   ={PB8, PB9, 255, PA8, 	RT_HW_PGM_END};	// DS1820,DHT22,HC-SR04.Echo,HC-SR04.Trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={PB12,PB13,PB14,PB15,	RT_HW_PGM_END};	// CS SPI:595,LCD,NRF,DEVl 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[] 	={						RT_HW_PGM_END};	// Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[] 	={						RT_HW_PGM_END};	// Пины(дополнительные[]  TFT дисплея(SPI[] ;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[]  ={ 1, 2, 				RT_HW_PGM_END};	//--UART: ModBus, Nextion 	
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[] 	={63,62,32,33,			RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;		
//-------------------------------------------------------------------------------------------------
#endif
//=================================================================================================
