//-------------------------------------------------------------------------------------------------
//			       Возвращает кол-во заполнителей спереди для выравнивания заполняемого поля
//                      (alig=L,C,R,N, len=длина строки, sz=длина заполняемого поля);
//-------------------------------------------------------------------------------------------------
uint8_t getLenBegin(uint8_t len,uint8_t sz,char alig){
if(len<=sz)  {return 0;} 
if(alig=='C'){return (len-sz-(len-sz)/2);}
if(alig=='R'){return (len-sz);}	return 0;};  
//-------------------------------------------------------------------------------------------------
//			       Возвращает кол-во заполнителей сзади для выравнивания заполняемого поля
//                      (alig=L,C,R,N, len=длина строки, sz=длина заполняемого поля);
//-------------------------------------------------------------------------------------------------
uint8_t getLenEnd  (uint8_t len,uint8_t sz,char alig){//==Получение кол-ва заполнителей сзади;	
if(len<=sz)  {return 0;}
if(alig=='C'){return (len-sz-getLenBegin(len,sz,alig));}
if(alig=='L'){return (len-sz);}               return 0;}
//-------------------------------------------------------------------------------------------------
// 					Возвращает длину текста из String  в формате utf-8 с учетом блокирующего символа '~'
//-------------------------------------------------------------------------------------------------
uint8_t getLenSTR(String &str,  uint8_t lenMax){ 							
uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=str[j];	         if(buff>=0xC0) {j++; buff=str[j];}  j++;	
           if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;} 
		   if(buff>=0xC0) {j++;} //buff=str(j);
		   len++;} 		   
		   //len++;} 
return len;}
//-------------------------------------------------------------------------------------------------
// 					Возвращает длину текста из PROGMEM в формате utf-8 с учетом блокирующего символа '~'
//-------------------------------------------------------------------------------------------------
uint8_t getLenPGM(const char *text, uint8_t lenMax){						//==Возвращает len textPGM(utf-8) с учетом блокирующего символа '~');
	uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=pgm_read_byte(text+j);	j++;
		   if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;}
		   if(buff>=0xC0) {j++;} //buff=pgm_read_byte(text+j);
		   len++;} 
return len;}
//-------------------------------------------------------------------------------------------------
//				  Возвращает цифру из val(форматы mode=D,H,B) ее номеру(1:10) (начиная со старшей позиции);							
//-------------------------------------------------------------------------------------------------
uint8_t  getNumberVal(uint32_t val, char mode, uint8_t len, uint8_t n){	//==Возвращает цифру из val(форматы mode=D,H,B) ее номеру(1:10) (начиная со старшей позиции);
uint32_t buff32=0;
if((n>len) || (n>10)) n=0; 
if(mode=='B') {buff32=(val>>(len-n))&1;}
if(mode=='H') {buff32=(val>>(len-n)*4)&0xf;}
if(mode=='D') {n=len-n+1; while(n!=0) {buff32=val; val/=10; buff32=buff32-(val*10); n--;};}
//if(buff32<=9) {buff32=buff32 +'0';} else {buff32=buff32-10+(upper ? 'A' : 'a') ;}
return (uint8_t)buff32;};
//-------------------------------------------------------------------------------------------------
//				  Получение кол-ва знаков в числах  с оcнованиями 10,16,2 (DEC(I,U),HEX,BIN):;							
//-------------------------------------------------------------------------------------------------
uint8_t getLenVal  (char mode, int32_t val){			//==Получение кол-ва знаков в числе;
uint32_t v, buff; uint8_t len=0; uint8_t bs;
if(mode=='I') {if(val<0) {v=-val;} else {v=val;}	
								buff=bs=10;  len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;} if(val<0) {len++;}} 
if(mode=='U') {v=(uint32_t)val; buff=bs=10;  len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;}} 
if(mode=='H') {v=(uint32_t)val;	buff=bs=0xF; len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;}} 
if(mode=='B') {v=(uint32_t)val;	buff=bs=0x1; len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;}} 
return len;};
//-------------------------------------------------------------------------------------------------
//						Выделяет число из строки с разделителями (в отладке!!!)
//-------------------------------------------------------------------------------------------------
int16_t getNumberFromString(String val, uint8_t n, char separator) {	//==Возвращает число int16 из строки с разделителями(DEBUG !!!);
//--n позиция в строке начиная с 1. Если значения нет или =0, возвращает -32768;
int16_t x; int16_t findPoint; uint8_t startPoint,endPoint, len,i; String s;
 startPoint=endPoint=findPoint=0;  s=val; len=val.length();
 x=-32768;
 if(n==0) {return x;} i=1;
 do{if(i>n) break;
    if(startPoint>len) break;
	findPoint=val.indexOf(separator, startPoint);   
	if (findPoint==-1) {endPoint=len;} else {endPoint=findPoint;}
	if (n==i) {s=val.substring(startPoint,endPoint); s.trim(); if(s=="") {break;} x=s.toInt(); break;}  
	if (findPoint==-1)  break;
	startPoint=findPoint+1;	i++; 	
   } while (1);
return x;}	
//-------------------------------------------------------------------------------------------------
//						Выделяет текст из строки с разделителями (в отладке!!!)
//-------------------------------------------------------------------------------------------------
String getTextFromString  (String val, uint8_t n, char separator) {  	//==Возвращает тексты (через разделители) из строки (DEBUG !!!);
//--n позиция в строке начиная с 1. Если значения нет или пробел, возвращает один пробел;
int16_t findPoint; 
uint8_t startPoint=0; 
uint8_t endPoint=0;
String x="";
String s=val; 
uint8_t len=val.length(); 									//--Длина строки;
uint8_t index=0;
do{if(index>n) {break;}
    if(startPoint>len) {break;}
	findPoint=val.indexOf(separator, startPoint);   
	if (findPoint==-1) {endPoint=len;} else {endPoint=findPoint;}
	if (n==index) {s=val.substring(startPoint,endPoint); s.trim(); 
				   if(s=="") {break;} 
				   x=s;       break;}  
	if (findPoint==-1)  {break;}
	startPoint=findPoint+1;	index++; 	
   } while (1);
return x;}
//=================================================================================================
