//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ФУНКЦИИ ЗАПИСИ-ЧТЕНИЯ ПИНОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool pinDigitalRead (RT_HW_PIN_DIR_ID &id, uint8_t pin, char mode){ 				//==Дискретный ввод->mode:I,U,D,F;
//--mode: 'U'- вход с подтяжкой к +Vcc; 'D' -вход с подтяжкой к +Gnd; 'I','F',любой другой символ - j, обычный вход;
//------------------------------------------------------------------------
if(id.dir==0){
	if(!checkPinPGM( RT_HW_PGM_PIN_DIN_ID,pin)) {id.dir=10;} 				//--Проверка на допустимость дискретного ввода;  
	else           { RT_HW_PIN_DIR_SET_ID(id,pin); 							//--Сохранение параметров пина;
		if     (mode=='I') {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход обычный;
		else if(mode=='U') {pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLUP);}	//--Дискретный вход с подтяжкой к +Vcc;
		else if(mode=='D') {pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLDOWN);}	//--Дискретный вход с подтяжкой к Gnd;
		else if(mode=='F') {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход - аналог INPUT; 
		else               {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход - аналог INPUT; 
												 id.dir=1;}}
//------------------------------------------------------------------------
if(id.dir==1) {return RT_HW_PIN_DIR_READ(id);} 
//------------------------------------------------------------------------
return 0;};	//+++END pinDigitalRead();
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ФУНКЦИИ ЗАПИСИ-ЧТЕНИЯ ПИНОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint16_t pinAnalogRead  (RT_HW_PIN_DIR_ID &id, uint8_t pin, char mode, uint16_t &ago){	//==Аналоговый ввод->mode:D,N,F;
// mode: 'D' -возвращает значение непосредственно с устройства ADC (с разрядностью ADC устройства);
//		 'N' -возвращает нормализованное до системной разрядности (device.sys.depth) значение с ADC;
//		 'F' -возвращает нормализованное до системной разрядности (device.sys.depth) значение с ADC
//			  с фильтрацией дрейфа показаний(device.adc.drift) и дрейфа нуля (device.adc.vNull);
//------------------------------------------------------------------------
if(id.dir==0){
	if(!checkPinPGM( RT_HW_PGM_PIN_ADC_ID,pin)) {id.dir=20;} 	//--Проверка на допустимость аналового ввода; 
	else           { RT_HW_PIN_DIR_SET_ID(id,pin); 										//--Сохранение параметров пина;			
	                 pinMode(id.pin, RT_HW_PIN_MODE_INPUT_ANALOG);						//--Настройка пина;
                                                  id.dir=1;}}
//------------------------------------------------------------------------
if(id.dir==1){
	uint16_t m16, dv; int32_t filter=0;	
	m16=maxBitDepth(device.depth.adc); 				//--Получение максимального значения для ADC 
	dv=analogRead(id.pin); 							//--Чтение значения ADC;
	if(dv>m16) {dv=m16;}							//--Ограничение показания ADC сверху;
	if     (mode=='D') {return dv;}					//--Возвращение значение ADC с устройства;
	else if(mode=='N') {return normADC(dv);}		//--Возвращает нормализованное значения ADC;	
	else if(mode=='F') {							//--Возвращает нормализованное значения ADC с корректировкой на параметры дрейфа;
						filter=makeDelta(ago, dv, device.depth.drift); //--Гистерезис
						if(filter>m16) {filter=m16;} 
						if(filter<device.depth.vNull) {filter=0;}
						ago=filter;
						return normADC(filter);}   
   else      			{return normADC(dv);}		//--Возвращает нормализованное значения ADC;	
}
//------------------------------------------------------------------------
return 0;};	//+++END pinAnalogRead(); 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ФУНКЦИИ ЗАПИСИ-ЧТЕНИЯ ПИНОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint16_t pinTouchRead   (uint8_t pin, char mode){										//==Сенсорный ввод ->mode:D,N,F(ESP32);
#if defined(RT_HW_CORE_ESP32) && defined(RT_HW_PERMIT_TOUCH)
	if(!checkPinPGM(RT_HW_PGM_PIN_TCH_ID,pin)) {	//--Проверка на допустимость сенсорног ввода; 
	buff.vu16=touchRead(pin);
	if     (mode=='D') {return buff.vu16;}
	else if(mode=='N') {return buff.vu16;} 
	else if(mode=='F') {return buff.vu16;} 
	else               {return buff.vu16;} 
	}
#else
if(mode=='D') {buff.vu8=pin;} else {buff.vu8=0;} 	//--Для устранения предупреждений от C++;
#endif	
return 0;};	//+++END pinTouchRead();
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ФУНКЦИИ ЗАПИСИ-ЧТЕНИЯ ПИНОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int16_t pinReadHALL(char mode){														//==Ввод с датчика Холла (ESP32);
#if  defined(RT_HW_CORE_ESP32) && defined(RT_HW_PERMIT_HALL)										//--Разрешение работы с датчикаом Холла; 
int16_t buff=hallRead();
	if     (mode=='D') {return buff;} 
	else if(mode=='N') {return buff;} 
	else if(mode=='F') {return buff;} 
	else 			   {return buff;}
#else
buff.vu8=uint8_t(mode);	//--Для устранения предупреждений от C++;	
#endif	
return 0;};	//+++END pinReadHALL();
//=============================================================================


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ФУНКЦИИ ЗАПИСИ-ЧТЕНИЯ ПИНОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool changeProtectPinDI(RT_HW_CHANGE_PINDI_ID &id, uint8_t timeChange, uint8_t val){//==Защита от дребезга значения на пине DI;
if(id.dir==0) {if(id.ago!=val) {id.time=RT_HW_MILLIS; id.dir++;}                       return id.ago;}
if(id.dir==1) {if((getPastMs(id.time)< (timeChange)) && (id.ago==val))  	{id.dir=0; return id.ago;} 
				if( getPastMs(id.time)>= timeChange)     {id.ago=val;		 id.dir=0; return id.ago;}}
																					   return id.ago;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
