//=================================================================================================
//									Дискретный вывод mode[O,N]
//=================================================================================================
void pinDigitalWrite(RT_HW_PIN_DIR_ID &id, uint8_t pin, char mode, uint8_t val){	//==Дискретный вывод -> mode:N,O;
//-------------------------------------------------------------------------
if(id.dir==0){	
	if(!checkPinPGM( RT_HW_PGM_PIN_DOT_ID,pin)) {id.dir=40;}						//--Проверка на допустимость аналогово ввода; 
	else           { RT_HW_PIN_DIR_SET_ID(id,pin); 									//--Сохранение параметров пина (пин, регистр, доступ к биту в регистре и т.п.);
		if(mode=='O') {pinMode(pin, RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN);} 
		else          {pinMode(pin, RT_HW_PIN_MODE_OUTPUT);}
												 id.dir=1;}}
//------------------------------------------------------------------------
if(id.dir==1) { RT_HW_PIN_DIR_WRITE(id,val);}		//--Вывод на дискретный вывод через макрос;
//------------------------------------------------------------------------
};			//+++END pinDigitalWrite();	
//=================================================================================================
//									Аналоговый вывод (PWM) mode[O,N]
//=================================================================================================
uint16_t pinAnalogWrite(RT_HW_PIN_DIR_ID &id, uint8_t pin, char mode, uint16_t freq, uint16_t val){ //==ШИМ вывод -> mode:N,O; (PWM);	
//------------------------------------------------------------------------
if(id.dir==0){
	if(!checkPinPGM( RT_HW_PGM_PIN_PWM_ID,pin)) {id.dir=50;}			//--Проверка на допустимость аналогово вывода (PWM); 
	else           { RT_HW_PIN_DIR_SET_ID(id,pin); 							//--Сохранение параметров пина;
//-----------------------------------------------
#if defined(RT_HW_CORE_ESP8266) 	
	//analogWriteFreq(constrain(freq, 100,10000)); 					//--Настройка частоты ШИМ;
	pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT); 	
	buff.vu16=freq;	buff.vu8=(uint8_t)mode;	//--Для устранения предупреждений от C++;	
//-----------------------------------------------		
#elif  defined(RT_HW_CORE_ESP32) 
{int8_t buff=setFirstFreeBit(device.pwm.channel);		//==Занимает первый свободный бит, возвращает его номер (0:15) или -1; 
 if(buff<0)	{id.dir=52; return 0;} 								//--Если все каналы заняты, выход по состоянию =52 (>50); 
 else       {id.num=buff;	
			 ledcSetup(id.num,constrain(freq,100,40000),device.depth.pwm);//--Настройка канала id.channel: частота и разрешение;
             ledcAttachPin(id.pin,id.num);}}			    	//--Настройка ШИМ ;
					buff.vu8=(uint8_t)mode;	//--Для устранения предупреждений от C++;	
//-----------------------------------------------
#elif defined(RT_HW_CORE_STM32_M_F1) || defined(RT_HW_CORE_STM32_M_F4) || defined(RT_HW_CORE_STM32_D)	
	if(mode=='O') {pinMode(id.pin, RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN);} 
	else          {pinMode(id.pin, RT_HW_PIN_MODE_OUTPUT_PWM);}	
	buff.vu16=freq;							//--Для устранения предупреждений от C++;	
//-----------------------------------------------
#else
	pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT); 
	buff.vu16=freq;	buff.vu8=(uint8_t)mode;	//--Для устранения предупреждений от C++;	
#endif
												 id.dir=1;}} //--END if (id.dir==0){
//------------------------------------------------------------------------
if(id.dir==1){
//-----------------------------------------------	
#if  defined(RT_HW_CORE_ESP32) 
uint16_t buff=normPWM(val);	ledcWrite(id.num,buff); 	return buff;	//--Вывод;
//-----------------------------------------------	
#elif  defined(RT_HW_CORE_STM32_M_F1) || defined(RT_HW_CORE_STM32_M_F4)
uint16_t buff=normPWM(val);	pwmWrite(id.pin,buff); 		return buff;	//--Вывод;	
//-----------------------------------------------
#elif  defined(RT_HW_CORE_STM32_D) 
uint16_t buff=normPWM(val);	analogWrite(id.pin,buff);	return buff;
//-----------------------------------------------	
#elif  !defined(RT_HW_CORE_ANON)
//defined(RT_HW_CORE_AVR) || defined(RT_HW_CORE_SEED) || defined(RT_HW_CORE_SAM)
uint16_t buff=normPWM(val);	analogWrite(id.pin,buff);	return buff;
//-----------------------------------------------
#else	
//-----------------------------------------------	
#endif
//-----------------------------------------------	
}	//--END if (id.dir==1)
return 0;} //+++END	pinAnalogWrite()

//=================================================================================================
//									Аналоговый вывод (DAC)
//=================================================================================================
uint16_t pinDAC(RT_HW_PIN_DIR_ID &id, uint8_t pin, uint16_t val){ 				//==Аналоговый вывод (DAC);
//------------------------------------------------------------------------
if(id.dir==0){
	buff.vu16=val;																//--Для устранения предупреждений от C++;
	if(!checkPinPGM( RT_HW_PGM_PIN_DAC_ID,pin))     {id.dir=60;}				//--Проверка на допустимость аналового ввода; 
    else           { RT_HW_PIN_DIR_SET_ID(id,pin);   id.dir=1; }} 				//--Сохранение параметров пина;   
//-----------------------------------------------
if(id.dir==1) {
#if defined(RT_HW_PERMIT_DAC)													//--Разрешение работы с DAC;	
//-----------------------------------------------
#if  defined(RT_HW_CORE_ESP32)  
	 uint16_t buff=normDAC(val); dacWrite(id.pin,buff);		return buff;
//-----------------------------------------------
#elif  defined(RT_HW_CORE_STM32_M_F1) || defined(RT_HW_CORE_STM32_M_F4) || defined(RT_HW_CORE_STM32_D)	 
     //uint16_t buff=normDAC(val); analogWrite(id.pin,buff); return buff;
	return 0;
//-----------------------------------------------
#else
	uint16_t buff=normDAC(val); analogWrite(id.pin,buff);	return buff;	
//-----------------------------------------------
#endif
//-----------------------------------------------
#endif
//-----------------------------------------------------------------------------
}  //--END if (id.dir==1)
//=============================================================================
return 0;};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
