//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ФУНКЦИЯ ВОЗВРАЩАЕТ ПРОШЕДШЕЕ ВРЕМЯ
//		timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t getPastTime(uint32_t &timeBegin, uint32_t timeEnd) {					//==Возврат прошедшего времени (....->timeBrgin); 
if(timeEnd  >=timeBegin) return (timeEnd  -timeBegin); 						   else return (0xFFFFFFFF-timeBegin+timeEnd); }; 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ФУНКЦИЯ ВОЗВРАЩАЕТ ПРОШЕДШЕЕ ВРЕМЯ (ms)
//		timeBegin -время начала отсчета (определяется вне функции);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t getPastMs(uint32_t &timeBegin){										//==Возврат прошед.времени в ms(RT_HW_MILLIS->timeBegin);
//--Перед вызовом уставливается timeBegin=RT_HW_MILLIS; 
buff.vu32=RT_HW_MILLIS; if(buff.vu32>=timeBegin) return (buff.vu32-timeBegin); else return (0xFFFFFFFF-timeBegin+buff.vu32);};	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ФУНКЦИЯ ВОЗВРАЩАЕТ ПРОШЕДШЕЕ ВРЕМЯ (mcs)
//		timeBegin -время начала отсчета (определяется вне функции); 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t getPastMcs(uint32_t &timeBegin){										//==Возврат прошедшего времени в mcs;
//--Перед вызовом устанавливается timeBegin=RT_HW_MILLIS;
buff.vu32=RT_HW_MICROS; if(buff.vu32>=timeBegin) return (buff.vu32-timeBegin); else return (0xFFFFFFFF-timeBegin+buff.vu32);};			

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ФУНКЦИЯ ТАЙМ-АУТА (возвращает событие 0/1)
//		timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее, timeMax-тайм-аут; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t timeOut(uint32_t &timeBegin, uint32_t timeEnd, uint16_t timeMax){
if(timeEnd  >=timeBegin){if((timeEnd  -timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-timeEnd)  >timeMax) return 1; else return 0;}}; 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ФУНКЦИЯ ТАЙМ-АУТА (ms) (возвращает событие 0/1)
//		timeBegin -время начала отсчета (определяется вне функции);  timeMax-тайм-аут; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t timeOutMs(uint32_t &timeBegin, uint16_t timeMax){					//==Возврат события по таймату в ms;
buff.vu32=RT_HW_MILLIS; 
      if(buff.vu32>=timeBegin){if((buff.vu32-timeBegin)>=timeMax) {return 1;} else {return 0;}} 
else {if((timeBegin-buff.vu32)>timeMax)                           {return 1;} else {return 0;}}}; 

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ФУНКЦИЯ ТАЙМ-АУТА (mcs) (возвращает событие 0/1)
//		timeBegin -время начала отсчета (определяется вне функции); timeMax-тайм-аут; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t timeOutMcs(uint32_t &timeBegin, uint16_t timeMax){					//==Возврат события по таймату в mcs;
buff.vu32=RT_HW_MICROS; 
      if(buff.vu32>=timeBegin){if((buff.vu32-timeBegin)>=timeMax) {return 1;} else {return 0;}} 
else {if((timeBegin-buff.vu32)>timeMax)                           {return 1;} else {return 0;}}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ТОЧНЫЙ ГЕНЕРАТОР СОБЫТИЙ (периодов); 
// Идея от https://alexgyver.ru/arduino-algorithms/
// timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
// Функция генерит событие с точным поддержанием периода ms и защитой от пропуска шага. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t period(uint32_t &timeBegin, uint32_t timeEnd, uint32_t period){if(!period){return 1;}   
if((timeEnd-timeBegin)>=period){do{timeBegin+=period; if(timeBegin<period) {break;}} while(timeBegin<(timeEnd-period)); return 1;} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ТОЧНЫЙ ГЕНЕРАТОР СОБЫТИЙ (периодов) mc; 
// Идея от https://alexgyver.ru/arduino-algorithms/
// timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
// Функция генерит событие с точным поддержанием периода ms и защитой от пропуска шага. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t periodMs(uint32_t &timeBegin,  uint32_t period){if(!period){return 1;} 
if((millis()-timeBegin)>=period){do{timeBegin+=period; if(timeBegin<period) {break;}} while(timeBegin<(millis()-period)); return 1;} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ТОЧНЫЙ ГЕНЕРАТОР СОБЫТИЙ (периодов) mcs; 
// Идея от https://alexgyver.ru/arduino-algorithms/
// timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
// Функция генерит событие с точным поддержанием периода ms и защитой от пропуска шага. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t periodMcs(uint32_t &timeBegin,  uint32_t period){if(!period){return 1;} 
if((micros()-timeBegin)>=period){do{timeBegin+=period; if(timeBegin<period) {break;}} while(timeBegin<(micros()-period)); return 1;} return 0;};	


/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     Задержка по времени
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t timeDelay(uint32_t &timeDelay, uint8_t &stepDelay, uint32_t period){
if(stepDelay==0){timeDelay=millis();             stepDelay=1;}
if(stepDelay==1){if(getPastMs(timeDelay)>period){stepDelay=0; return 1;}}
return 0;}	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     Задержка по времени
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t timeDelayMcs(uint32_t &timeDelay, uint8_t &stepDelay, uint32_t period){
if(stepDelay==0){timeDelay=micros();             stepDelay=1;}
if(stepDelay==1){if(getPastMs(timeDelay)>period){stepDelay=0; return 1;}}
return 0;}	


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//      Расчет прошедшего времени (подходит для типов volation !!!)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t calcPastTime(uint32_t timeBegin,uint32_t timeEnd){if(timeEnd>=timeBegin){return (timeEnd-timeBegin);} else{return (0xFFFFFFFF-timeBegin+timeEnd);}}; 
*/
//=================================================================================================

