//=================================================================================================
//						API консоль - сканирование шин I2c, заголовки
//=================================================================================================
//=================================================================================================
//							Вывод основных параметров платы 
//=================================================================================================
void  consoleBoardGeneral(){		
mess.alig='N';
String str;
str=__DATE__; consoleVar(str);   		   	consoleBlank(' ',61); str=__TIME__; consoleVar(str,'L');
consoleVar(String(F("Board->")));          	consoleVar(String(F(RT_HW_BOARD_NAME)),'/'); 
consoleVar((uint8_t)RT_HW_BOARD_CODE,';',0,'U'); 	consoleBlank(2);
consoleVar(String(F("Arch->")));           	consoleVar(String(F(RT_HW_ARCH_NAME)),'/');	consoleVar((uint8_t)RT_HW_ARCH_CODE,';',0,'U'); 
consoleVar(String(F("  Core->")));		   	consoleVar(String(F(RT_HW_CORE_NAME)),'/'); consoleVar((uint8_t)RT_HW_CORE_DEFINED,'~',0,'U');
#if defined(RT_HW_CORE_STM32)
consoleVar(String(F("[family STM32]")));  
#endif
consoleSuff('E');
consoleVar(String(F("Select board->")));	consoleVar(String(F(RT_HW_BOARD_SELECT)),'E');	
};							
//=================================================================================================
//							Вывод дополнительных параметров платы
//=================================================================================================
void  consoleBoardAdd(){
mess.alig='R'; mess.blank=' '; mess.modePin='T';
//------Вывод наименование библиотеки--------------------------------------------------------------
consoleVar(String(F("RT_HW_BASE.h->")));   consoleVar(String(F(RT_HW_BASE_VER_NAME)),'E');
//------Вывод размера памяти-----------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
consoleVar(String(F("Fcpu=xxx; Vcc=x.xx; Memory=xxx")),'E'); 			
#else
consoleVar(String(F("Fcpu="))); 	consoleVar(uint32_t(RT_HW_FCPU));	consoleVar(String(F("mHz")),';'); 
consoleVar(String(F(" Vcc="))); 	consoleVar(float(RT_HW_VCC/1000.0),';'); 
consoleVar(String(F(" Memory::"))); consoleVar(String(F(RT_HW_BOARD_MEMORY)),'E');
#endif
//-----Вывод системной разрядности и разрядности устройств на плате--------------------------------
{uint8_t arr[]={device.depth.sys, 	device.depth.adc, device.depth.pwm, device.depth.dac};
 consoleVar(String(F("Depth->SYS,ADC,PWM,DAC="))); consoleArrVar(arr,';',2,'W',4); consoleBlank(2);}
{uint8_t arr[]={device.depth.adc, device.depth.drift};
 consoleVar(String(F(" ADC::drift,null=")));       		consoleArrVar(arr,';',3,'W',2); consoleBlank(2);}
 consoleVar(String(F("SYS.max=")));                		consoleVar(uint16_t(maxBitDepth(device.depth.sys)),'E');
//-------------------------------------------------------------------------------------------------
{uint8_t arr[]={device.pin.control,device.pin.led,device.pin.button}; mess.modePin='A'; 
 consoleVar(String(F("pins->control,led,button")),'=');	consoleArrVar(arr,';',mess.lenPin,'P',3);}  
//#if defined(RT_HW_PERMIT_WS)
consoleVar(String(F(" pin WS2812="))); consoleVar(device.pin.ws,';',mess.lenPin,'P');
//#endif
consoleCR(); 
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266)	
//------Исключения при загрузке ESP8266------------------------------------------------------------
consoleVar(String(F("[Download requirement for pins->D3=1,D4=1,D8=0;]")),'E');
#endif
#if defined(RT_HW_CORE_ESP32_S2)
//------Исключения при загрузке ESP32--------------------------------------------------------------
consoleVar(String(F("[Download requirement for pins->pin.3=1,pin.12=1. Note: pins 0,5,14,15=PWM; pins.1=debug;]")),'E');
#endif
#if defined(RT_HW_CORE_ESP32_C3)
//------Исключения при загрузке ESP32-C3--------------------------------------------------------------
consoleVar(String(F("[Download requirement for pins->pin.3=1]")),'E');
#endif
}
//=================================================================================================
//							Вывод параметров диспетчера задач
//=================================================================================================
void  consoleShedulerParameters(){	
mess.alig='R'; mess.blank=' ';
{uint8_t  arr[]={shed.quick.qnt,shed.fast.qnt,shed.slow.qnt,shed.back.qnt,shed.frdm.qnt};
consoleVar(String(F("Sheduler::qnt---->quick,fast,slow,back,frdm="))); consoleArrVar(arr,'E',4,'U',5); consoleBlank(10);}	
{uint16_t arr[]={10,25,250,100,0};
consoleVar(String(F("period->quick,fast,slow,back,frdm=")));           consoleArrVar(arr,'E',4,'U',5);}
}
//=================================================================================================
//							Вывод доступных пинов [T,D,A];
//=================================================================================================
void  consolePinsAll(){
//-------------------------------------------------------------------------------------------------
mess.alig='R'; mess.blank=' '; mess.modePin='T'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
//-------------------------------------------------------------------------------------------------
for(uint8_t i=RT_HW_PGM_PIN_ALL_ID;i<=RT_HW_PGM_PIN_N5V_ID;i++){consoleArrPGM(i,mess.modePin);}
if(getLenPosPGM(RT_HW_PGM_PIN_N5V_ID)==0) {consoleVar(String(F("All pins tolerant to 5V")),'E');}	
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266)	
////------Исключения при загрузке ESP8266----------------------------------------------------------
mess.alig='R'; mess.modePin='D';
consoleHead(String(F("Name pins ESP8266")),'-',80);
{consoleVar(String(F("[D0-D4]--------->")));	uint8_t arr[]={16, 5, 4, 0, 2}; consoleArrVar(arr,'E',mess.lenPin,'P',5);}
{consoleVar(String(F("[D5-D8,--------->")));	uint8_t arr[]={14,12,13,15}; 	consoleArrVar(arr,'E',mess.lenPin,'P',4);}
{consoleVar(String(F("[D9-D10,A0]----->")));	uint8_t arr[]={ 3, 1,17}; 		consoleArrVar(arr,'E',mess.lenPin,'P',3);}
{consoleVar(String(F("[RX,RX0,TX,TX0]->")));	uint8_t arr[]={3,3,1,1};        consoleArrVar(arr,'E',mess.lenPin,'P',4);}
{consoleVar(String(F("[TX1,RX2,TX2]--->")));	uint8_t arr[]={2,13,15};  		consoleArrVar(arr,'E',mess.lenPin,'P',3);}
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32)
{uint8_t arr[16]; char reg; bool ok;
consoleHead(String(F("Name pins STM32")),'-',80);
mess.modePin='A';
for(uint8_t m=0; m<12; m++){reg='A'+ m; ok=0; 
 for(uint8_t i=0;i<16; i++){arr[i]=getNumPinSTM32(reg,i); if(arr[i]<254){ok=1;}}	
  if(ok){consoleChar('P'); consoleVar(char(reg)); consoleVar(String(F("[16]  ")));
    for(uint8_t j=0;j<16;j++){      
		consoleVar(arr[j],' ',9,'P'); 
		if((j==7) && (mess.modePin=='A')){consoleSuff('L'); consoleBlank(8);}
		if(j==15){consoleSuff('L');} 
}}}} 
#endif
//-------------------------------------------------------------------------------------------------
};
//=================================================================================================
//							Вывод интерфейсов
//================================================================================================= 
void consoleInterface(){
//-------------------------------------------------------------------------------------------------
//							Интерфейс i2c
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<=9;i++){i2cHeadInterface(i);}
//-------------------------------------------------------------------------------------------------
//						Сообщения по интерфейсу i2c
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266)
consoleVar(String(F("[SDA,SCL any pin from D1-D10]")),'E');
#endif
#if defined(RT_HW_CORE_ESP32_S2)  
consoleVar(String(F("[SDA,SCL any pin <35]")),'E');
#endif
#if defined(RT_HW_CORE_STM32)
consoleVar(String(F("[i2c0: SDA,SCL pin PB7,PB6 or PB9,PB8]")),'E');   
#endif 
//-------------------------------------------------------------------------------------------------
//							Интерфейс SPI
//-------------------------------------------------------------------------------------------------	
for(uint8_t i=0; i<=9;i++){spiHeadInterface(i);}
//-------------------------------------------------------------------------------------------------
//							Интерфейс UART
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<=9;i++){uartHeadInterface(i);}
//consoleVar(String(F("__UART0(RX,TX):")));  consoleVar(LinkUART0.rx,','); consoleVar(LinkUART0.tx,'E');
/*
mess.alig='R'; mess.blank=' '; mess.modePin='A';
//consoleVar(String(F("__UART0(RX,TX):")));  consoleVar(uartGetPinRX(0),','); consoleVar(uartGetPinTX(0),'E');
//consoleVar(String(F("__UART1(RX,TX):")));  consoleVar(LinkUART1.rx,','); consoleVar(LinkUART1.tx,'E');
//consoleVar(String(F("__UART2(RX,TX):")));  consoleVar(LinkUART2.rx,','); consoleVar(LinkUART2.tx,'E');
//consoleVar(String(F("__UART3(RX,TX):")));  consoleVar(LinkUART3.rx,','); consoleVar(LinkUART3.tx,'E');
#if defined(RT_HW_PERMIT_UART0)
//{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,0), readArrPGM(RT_HW_PGM_PIN_UHS_ID,1)}; 
//  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("__UART0(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}	
{uint8_t arr[2]; arr[0]=uartGetPinRX(0); arr[1]=uartGetPinTX(0); consoleVar(String(F("UART0(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}		  
#endif
#ifdef RT_HW_PERMIT_UART1
//{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,2), readArrPGM(RT_HW_PGM_PIN_UHS_ID,3)}; 
//  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("__UART1(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}	
{uint8_t arr[]={uartGetPinRX(1),uartGetPinTX(1)}; consoleVar(String(F("UART1(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}
#endif
#ifdef RT_HW_PERMIT_UART2
//{uint8_t arr[]={uartGetPinRX(2),uartGetPinTX(2)}; if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART2(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}				 
//{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,4), readArrPGM(RT_HW_PGM_PIN_UHS_ID,5)}; 
//  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("__UART2(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}
{uint8_t arr[]={uartGetPinRX(2),uartGetPinTX(2)}; consoleVar(String(F("UART2(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}  
#endif
#ifdef RT_HW_PERMIT_UART3
//{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,6), readArrPGM(RT_HW_PGM_PIN_UHS_ID,7)}; 
//  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART3(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}
{uint8_t arr[]={uartGetPinRX(3),uartGetPinTX(3)}; consoleVar(String(F("UART3(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}  
#endif
#ifdef RT_HW_PERMIT_UART4
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,8), readArrPGM(RT_HW_PGM_PIN_UHS_ID,9)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART4(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}
#endif
#ifdef RT_HW_PERMIT_UART5
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,10), readArrPGM(RT_HW_PGM_PIN_UHS_ID,11)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART5(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}		
#endif
#ifdef RT_HW_PERMIT_UART6
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,12), readArrPGM(RT_HW_PGM_PIN_UHS_ID,13)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART6(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}		
#endif
#ifdef RT_HW_PERMIT_UART7
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,14), readArrPGM(RT_HW_PGM_PIN_UHS_ID,15)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART7(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}			
#endif
#ifdef RT_HW_PERMIT_UART8
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,16), readArrPGM(RT_HW_PGM_PIN_UHS_ID,17)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UART8(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}		
#endif
#ifdef RT_HW_PERMIT_UARTS
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_UHS_ID,18), readArrPGM(RT_HW_PGM_PIN_UHS_ID,19)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("UARTS(RX,TX):"))); consoleArrVar(arr,'E',0,'P',2);}}
#endif	
*/
//-------------------------------------------------------------------------------------------------
//						Сообщения по интерфейсу UART
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_CORE_ESP8266
consoleVar(String(F("[UART  possible options are (1,3),(2,3) or (15,13);")),'L');
consoleVar(String(F(" Set Serial.pins(uint8_t tx, uint8_t rx) or Serial.swap(uint8_t tx_pin)")),'L');
consoleVar(String(F(" toggle between use of GPIO13/GPIO15 or GPIO3/GPIO(1/2)as RX and TX;")),'E');
consoleVar(String(F(" UART1 allows only TX on 2 if UART is not (2,3);]")),'E');	 
#endif
//-------------------------------------------------------------------------------------------------
									
//-------------------------------------------------------------------------------------------------
//							Интерфейс CAN
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_CAN
mess.alig='R'; mess.blank=' '; mess.modePin='A';
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_CAN_ID,0), readArrPGM(RT_HW_PGM_PIN_CAN_ID,1)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("CAN:   RX,TX="))); consoleArrVar(arr,'E',0,'P',2);}}	
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс BlueTooth
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_BTH
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("BlueTooth->в разработке:"))); 
for(uint8_t i=0; i<3;i++){consoleChar(char(getIntPGM(RT_HW_PGM_PIN_BTH_ID)),i);} consoleSuff('E');
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс Ethernet
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_ETH
mess.alig='R'; mess.blank=' ';
consoleText(String(F("Ethernet->(debug):"))); 
for(uint8_t i=0; i<3;i++){consoleVar(uint8_t(readArrPGM(RT_HW_PGM_PIN_ETH_ID,i)),'.',3);} consoleSuff('E');
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс Wi-Fi
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_WFI
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("Wi-Fi(debug)->:"))); 
for(uint8_t i=0; i<4;i++){consoleChar(char(getIntPGM(RT_HW_PGM_PIN_WFI_ID)),i);} consoleSuff('E'); 
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс: завершение
//-------------------------------------------------------------------------------------------------
};

//=================================================================================================
//							Вывод массивов из PROGMEM 
//=================================================================================================
void  consoleFromPGM(){
mess.alig='R'; mess.blank=' '; mess.modePin='A'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0;                    i<=RT_HW_PGM_SYS_DAC_ID; i++){consoleArrPGM(i,'N');};
consoleLine('-',60);
for(uint8_t i=RT_HW_PGM_PIN_BRD_ID; i<=RT_HW_PGM_PIN_CAN_ID; i++){consoleArrPGM(i,'T');};
consoleLine('-',60);
for(uint8_t i=RT_HW_PGM_PIN_DBG_ID; i<=RT_HW_PGM_PIN_URT_ID; i++){consoleArrPGM(i,'T');};
for(uint8_t i=RT_HW_PGM_PIN_BTH_ID; i<=RT_HW_PGM_PIN_WFI_ID; i++){consoleArrPGM(i,'N');};	 
consoleLine('-',60);
consoleArrPGM(RT_HW_PGM_ADR_I2C_ID,'N');
//-------------------------------------------------------------------------------------------------
};
//--------------------------------------------------------------------------------------------------
