//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							1.СОЗДАНИЕ ОБЪЕКТОВ С ДАННЫМИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
RT_HW_STRUCT_UART_RXTX uart;				//--Флаги инициализации и готовности до 16 UART
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) || defined(RT_HW_CORE_SEEED) || defined(RT_HW_CORE_PI_PICO) || defined(RT_HW_CORE_ESP)
RT_HW_STRUCT_UART_USB uartUSB;				//--Программный USB
#endif
//-------------------------------------------------------------------------------------------------	
#if defined(RT_HW_PERMIT_UARTS)
RT_HW_STRUCT_UART LinkUARTS;				//--Программный UART 
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART0)
RT_HW_STRUCT_UART LinkUART0;				//--UART0
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART1)
RT_HW_STRUCT_UART LinkUART1;				//--UART1
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART2)
RT_HW_STRUCT_UART LinkUART2;				//--UART2
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART3)
RT_HW_STRUCT_UART LinkUART3;				//--UART3
#endif			
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART4)
RT_HW_STRUCT_UART LinkUART4;				//--UART4
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART5)
RT_HW_STRUCT_UART LinkUART5;				//--UART5
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART6)
RT_HW_STRUCT_UART LinkUART6;				//--UART6
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART7)
RT_HW_STRUCT_UART LinkUART7;				//--UART7
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART8)
RT_HW_STRUCT_UART LinkUART8;				//--UART8
#endif

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//										API UART
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
bool     uartCheckBegin(uint8_t num);
bool     uartCheckReady(uint8_t num);
uint16_t uartGetBegin();
uint16_t uartGetReady();
bool	 uartCheckNum  (uint8_t num);				//--Проверка наличия в контроллере UART c номером n; 

//=================================================================================================
// 							3.Запись/чтение номеров пинов, скорости
//=================================================================================================
void     uartSetState  (uint8_t  state,   			uint8_t num=0);	//--Запись в  регистр state;
void     uartSetSpeed  (uint32_t speed,   			uint8_t num=0);	//--Запись в  регистр speed;
void     uartSetConfig (uint32_t config,   			uint8_t num=0);	//--Запись в  регистр config;
uint8_t  uartGetState  (			    			uint8_t num=0);	//--Чтение из регистра state;
uint32_t uartGetSpeed  (	         				uint8_t num=0);	//--Чтение из регистра speed;
uint32_t uartGetConfig (	         				uint8_t num=0);	//--Чтение из регистра config;
//=================================================================================================
// 							3.Запись/чтение номеров пинов, скорости
//=================================================================================================
void     uartSetPinRX  (uint8_t rx,   				uint8_t num=0);	//--Запись в регистр   номера пинa RX;
void     uartSetPinTX  (uint8_t tx,   				uint8_t num=0);	//--Запись в регистр   номера пина TX;
uint8_t  uartGetPinRX  (			    			uint8_t num=0);	//--Чтение из регистра номера пинa RX;
uint8_t  uartGetPinTX  (	         				uint8_t num=0);	//--Чтение из регистра номера пинa TX;


//=================================================================================================
void 	 uartBegin     (uint8_t num=0);	//--Инициализация UART;
bool	 uartSerial    (uint8_t num=0);					//--Ожидание готовности  UART;
uint16_t uartAvailable (uint8_t num=0);					//--Получение кол-ва байт в буфере чтения;
uint16_t uartAvailableForWrite(uint8_t num=0);			//--Получение кол-ва байт в буфере записи;
uint8_t  uartRead      (uint8_t num=0);					//--Чтение байта         из буфера чтения;
void 	 uartWrite     (uint8_t n, uint8_t val);	//--Запись байта в буфер записи;
void 	 uartPrint     (uint8_t n, String str);		//--Вывод строки в буфер записи;
//=================================================================================================
void     uartHeadInterface(uint8_t n=0);			//--Вывод заголовка по интерфейсу;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
