
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							1.СОЗДАНИЕ ОБЪЕКТОВ С ДАННЫМИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_SPI0)										//==1.0.1.Определение структуры для шины SPI0			  
RT_HW_STRUCT_SPI 	LinkSPI0;
#endif	
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1)										//==1.1.1.Определение для SPI1			  
RT_HW_STRUCT_SPI 	LinkSPI1;
#endif	
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2)										//==1.2.1.Определение структуры для шины SPI2			  
RT_HW_STRUCT_SPI 	LinkSPI2;						
#endif 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							2.СОЗДАНИЕ ДОПОЛНИТЕЛЬНЫХ ОБЪЕКТОВ SPI ПОД ТИП MCU
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_ESP32)			//==1.1.2.Создание объекта для SPI1 для ESP32
SPIClass SPI1(HSPI);
#endif 
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_M)		//==1.1.3.Создание объекта для SPI1 для STM32(M)	
SPIClass SPI1(1);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_D)		//==1.1.4.Создание объекта для SPI1 для STM32(D)	
SPIClass SPI1(1);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_M)		//==1.2.2.Создание объекта для SPI1 для STM32(M)	
SPIClass SPI2(2);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_D)		//==1.3.3.Создание объекта для SPI1 для STM32(D)	
SPIClass SPI2(1);
#endif
*/

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								API функций SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//							4.Функции настройки и проверки
//=================================================================================================
//-------------------------------------------------------------------------------------------------
//							4.1.Функции проверки номера шины, управления регистром состояния
//-------------------------------------------------------------------------------------------------
bool 	 spiCheckBus	 (								  uint8_t bus=0);	//--Проверка наличия в контр. spi=bus;
void     spiSetBitState  (				uint8_t bitState, uint8_t bus=0);	//--Запись бита состояния;
void     spiClearBitState(				uint8_t bitState, uint8_t bus=0);	//--Сброс  бита состояния;
void     spiWriteBitState(bool    val, 	uint8_t bitState, uint8_t bus=0);	//--Запись бита состояния;
void     spiSetState     (uint8_t val, 					  uint8_t bus=0);	//--Запись слова состояния
void	 spiSetStatus    (uint8_t val, 					  uint8_t bus=0);	//--Запись статуса;
void	 spiSetCodeErr   (uint8_t val, 					  uint8_t bus=0);	//--Запись кода ошибки;   
bool 	 spiGetBitState  (				uint8_t bitState, uint8_t bus=0);	//--Чтение бита состояния;
uint8_t  spiGetState     (					 			  uint8_t bus=0);	//--Чтение слова состояния;
uint8_t  spiGetStatus    (					 			  uint8_t bus=0);	//--Чтение статуса;
uint8_t  spiGetCodeErr   (					 			  uint8_t bus=0);	//--Чтение кода ошибки;		
//-------------------------------------------------------------------------------------------------
//							4.2.Функции для работы с пинами
//-------------------------------------------------------------------------------------------------
void     spiSetPinSCK    (uint8_t sck, 			uint8_t bus=0);	//--Установка значения пина SCK;
void     spiSetPinMISO   (uint8_t miso, 	 	uint8_t bus=0);	//--Установка значения пина MISO;
void	 spiSetPinMOSI	 (uint8_t mosi, 		uint8_t bus=0);	//--Установка значения пина MOSI;
void 	 spiSetPinSS	 (uint8_t ss, 			uint8_t bus=0);	//--Установка значения пина SS;
uint8_t  spiGetPinSCK 	 (						uint8_t bus=0);	//--Чтение    значения пина SCK;
uint8_t  spiGetPinMISO 	 (						uint8_t bus=0);	//--Чтение    значения пина MISO;
uint8_t  spiGetPinMOSI 	 (						uint8_t bus=0);	//--Чтение    значения пина MOSI;
uint8_t  spiGetPinSS	 (						uint8_t bus=0);	//--Чтение    значения пина SS;
void     spiBeginFirst	 (						uint8_t bus=0); //--Первичная настройка пинов sck,miso,mosi;
uint8_t  spiInitCS		 (uint8_t cs); 							//--Физическая настройка пина CS[err->60];
uint8_t  spiInitDevice   (uint8_t cs,		uint8_t bus=0);	//--Инициализация устройства (Проверка номера bus и настройка cs);
//-------------------------------------------------------------------------------------------------
//							4.3.Функции управления транзакциями
//-------------------------------------------------------------------------------------------------
void	 spiSetSpeed	 (uint32_t speed, 		uint8_t bus=0);	//--Установка параметра speed;
void     spiSetBitOrder  (uint8_t bitOrder, 	uint8_t bus=0);	//--Установка параметра bitOrder;
void     spiSetDataMode  (uint8_t dataMode, 	uint8_t bus=0);	//--Установка параметра dataMode;
uint32_t spiGetSpeed	 ( 						uint8_t bus=0);	//--Установка параметра speed;
uint8_t  spiGetBitOrder  ( 						uint8_t bus=0);	//--Установка параметра bitOrder;
uint8_t  spiGetDataMode  (						uint8_t bus=0);	//--Установка параметра dataMode;
void	 spiSetSetting   (uint32_t    speed, uint8_t bitOrder, uint8_t dataMode, uint8_t bus);	//--Групповая установка speed,bitOrder,dataMode;
void 	 spiBeginTransaction(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t bus);	//--Инициализация транзакции с задаваемыми параметрами;
void 	 spiBeginTransaction(					uint8_t bus=0);	//--Инициализация транзакции с параметрами по умолчанию;
void 	 spiEndTransaction(						uint8_t bus=0);	//--Восстановления транзакции default;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							5.Функции обмена простые
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t	 spiTransfer 	(uint8_t  val, 							 uint8_t bus); //--Обмен байтами;
uint16_t spiTransfer16 	(uint16_t val, 							 uint8_t bus); //--Обмен словами;
void     spiTransferArr	(uint8_t  *tx, uint8_t *rx,	uint8_t qnt, uint8_t bus); //--Обмен qnt байтами;
void 	 spiWrite		(uint8_t  val,      					 uint8_t bus); //--Отправка слова;
void 	 spiWrite16		(uint16_t val, 							 uint8_t bus); //--Отправка слова;
void     spiWriteArr	(uint8_t  *tx,  			uint8_t qnt, uint8_t bus); //--Отправка qnt байт;
uint8_t  spiRead		(              							 uint8_t bus); //--Прием байта;
uint16_t spiRead16		(              							 uint8_t bus); //--Прием слова;
void  	 spiReadArr     (			   uint8_t *rx, uint8_t qnt, uint8_t bus); //--Прием qnt байт; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							5.Функции обмена комплексные
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t	 SPItransfer   	(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  val, 							 uint8_t cs, uint8_t bus);
uint16_t SPItransfer16	(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint16_t val, 							 uint8_t cs, uint8_t bus);
void     SPItransferArr (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  *tx, uint8_t *rx, uint8_t qnt, uint8_t cs, uint8_t bus);
void	 SPIwrite       (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  val, 							 uint8_t cs, uint8_t bus);
void	 SPIwrite16     (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint16_t val, 							 uint8_t cs, uint8_t bus);
void     SPIwriteArr    (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  *tx,              uint8_t qnt, uint8_t cs, uint8_t bus);
uint8_t	 SPIread   	    (uint32_t speed, uint8_t bitOrder, uint8_t dataMode,               							 uint8_t cs, uint8_t bus);
uint16_t SPIread16	    (uint32_t speed, uint8_t bitOrder, uint8_t dataMode,               							 uint8_t cs, uint8_t bus);
void     SPIreadArr     (uint32_t speed, uint8_t bitOrder, uint8_t dataMode,       		   uint8_t *rx, uint8_t qnt, uint8_t cs, uint8_t bus);
//=================================================================================================
//							4.6.Функции настройки шины
//=================================================================================================
void  	 spiBegin	  (uint8_t bus=0);			//--Инициализация шины SPI как Master;
void     spiBeginSlave(uint8_t bus=0);			//--Инициализация шины SPI как Slave;
//=================================================================================================
//							11.Функции настройки параметров транзакций 
//=================================================================================================


//=================================================================================================
//							20.Функция write uint8_t
//=================================================================================================					
//-------------------------------------------------------------------------------------------------
//							4.1.Запись байта
//-------------------------------------------------------------------------------------------------
//void    spiWrite(uint8_t val,			   uint8_t bus=0);	//--Запись байта;
//-------------------------------------------------------------------------------------------------
////						4.2.Запись байта с управлением транзакциями и cs
//-------------------------------------------------------------------------------------------------
void spiWriteCS (uint8_t val, uint8_t cs, uint8_t bus=0){
//spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); spiWrite(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
//spiEndTransaction(bus);
}
//-------------------------------------------------------------------------------------------------
////						4.3.Запись массива из qnt байт
//-------------------------------------------------------------------------------------------------
//void  spiWriteArr(uint8_t *tx, uint8_t qnt,              uint8_t bus=0){	//--Запись qnt байт;
//for(uint8_t i=0; i<qnt; i++){spiWrite(tx[i],bus);}} 
//-------------------------------------------------------------------------------------------------
////						4.4.Запись массива из qnt байт с управлением транзакциями и cs
//-------------------------------------------------------------------------------------------------
void  spiWriteArrCS(uint8_t *tx, uint8_t qnt, uint8_t cs,  uint8_t bus=0){
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){spiWrite(tx[i],bus);}
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus);}
//=================================================================================================
//							5.Функции read
//=================================================================================================					
//-------------------------------------------------------------------------------------------------
//							5.1.Чтение байта
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
////						5.2.Чтение байта с управлением транзакциями и cs
//-------------------------------------------------------------------------------------------------
uint8_t  spiReadCS (uint8_t cs, uint8_t bus=0){
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); uint8_t v=spiRead(bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus); 
return v;}
//-------------------------------------------------------------------------------------------------
////						5.3.Чтение qnt байт в массив
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
////						5.4.Чтение qnt байт в массив с управлением транзакциями и cs
//-------------------------------------------------------------------------------------------------
void  spiReadArrCS(uint8_t *rx, uint8_t qnt, uint8_t cs,  uint8_t bus=0){
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){rx[i]=spiRead(bus);}
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus);}
//=================================================================================================
//							6.Функции transfer
//=================================================================================================					
//-------------------------------------------------------------------------------------------------
//							6.1.Запись/чтение байта
//-------------------------------------------------------------------------------------------------
//uint8_t	 spiTransfer 	(uint8_t val, uint8_t bus=0);
//uint16_t spiTransfer16	(uint8_t val, uint8_t bus=0);
//uint8_t	 spiTransfer32	(uint8_t val, uint8_t bus=0);
//-------------------------------------------------------------------------------------------------
////						6.2.Запись/чтение с управлением транзакциями и cs
//-------------------------------------------------------------------------------------------------
uint8_t spiTransferCS(uint8_t val, uint8_t cs, uint8_t bus=0){
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);       RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); uint8_t v=spiTransfer(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus); 
return v;}
//-------------------------------------------------------------------------------------------------
////						6.3.Запись из массива/чтение в массив qnt байt 
//-------------------------------------------------------------------------------------------------
void  spiReadArr  (uint8_t *rx, uint8_t *tx, uint8_t qnt, uint8_t bus=0){for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(tx[i],bus);}} 
//-------------------------------------------------------------------------------------------------
////						6.4.Чтение qnt байт в массив с управлением транзакциями и cs
//-------------------------------------------------------------------------------------------------
void  spiReadArrCS(uint8_t *rx, uint8_t *tx, uint8_t qnt, uint8_t cs,  uint8_t bus=0){
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(tx[i],bus);}
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus);}
//=================================================================================================

//=================================================================================================
//  						42.Вывод параметров интерфейса i2c шины bus  mess.lenPin
//=================================================================================================
void  spiHeadInterface(uint8_t bus){
if(!spiCheckBus(bus))			{return;}	//--Проверка наличия шины;
consoleBegin();	if(!console.ok)	{return;} 	//--Настройка консоли с параметрами по умолчанию и ожидание готовности;
mess.alig='R'; mess.blank=' '; mess.modePin='T'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
uint8_t arr[4]; arr[0]=spiGetPinSCK(bus); arr[1]=spiGetPinMISO(bus); arr[2]=spiGetPinMOSI(bus); arr[3]=spiGetPinSS(bus); 
consoleVar(String(F("SPI"))); consoleVar(bus);
consoleVar(String(F(" bus="))); consoleVar(bus,':');
consoleVar(String(F(" SCK,MISO,MOSI,SS="))); consoleArrVar(arr,';',0,'P',4);
uint8_t status=spiGetStatus(bus);
     if(status==1){consoleVar(String(F("  Master")),';');}
else if(status==2){consoleVar(String(F("   Slave")),';');}
else			  {consoleVar(String(F(" No init")),';');}
consoleVar(String(F(" speed(kHz)="))); consoleVar(uint32_t(spiGetSpeed(bus)/1000),';');
consoleCR();
}

//=================================================================================================
