//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//										API функций SSPI
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//=================================================================================================
//										Настройка пинов и устройства
//=================================================================================================
uint8_t  SSPIinitCS    (uint8_t cs){											//--Физическая настройка пина CS[err->68];;
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,cs))										 {return 68;} 	//--Выход, если не допустимый номер пина cs;
else                                     {digitalWrite(cs,1); pinMode(cs,OUTPUT); return 0;}}	//--Настройка пина на выход;	
uint8_t  SSPIinitPins  (uint8_t sck, uint8_t miso, uint8_t mosi){				//--Физическая настройка пина пинов SCK,MISO,MOSI[err->65,66,67];
			  if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, sck))	{return 65;}	//--Выход, если не допустимый номер пина sck;
if(miso!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, miso))	{return 66;}}	//--Выход, если не допустимый номер пина mosi;	
if(mosi!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, mosi))	{return 67;}}	//--Выход, если не допустимый номер пина mosi;
              digitalWrite(sck, 0); pinMode(sck, OUTPUT);													 
if(miso!=255){						pinMode(miso, INPUT);}	
if(mosi!=255){digitalWrite(mosi,0); pinMode(mosi,OUTPUT);}	
return 0;}
uint8_t  SSPIinitDevice(uint8_t sck, uint8_t miso, uint8_t mosi, uint8_t cs){ 	//--Физическая настройка устройста(пины SCK,MISO,MOSI,CS[err->65,66,67,68]);
			  if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, sck))	{return 65;}	//--Выход, если не допустимый номер пина sck;
if(miso!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, miso))	{return 66;}}	//--Выход, если не допустимый номер пина mosi;	
if(mosi!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, mosi))	{return 67;}}	//--Выход, если не допустимый номер пина mosi;
			  if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID, cs))	{return 68;}	//--Выход, если не допустимый номер пина sck;
			  digitalWrite(cs,  1); pinMode(cs,  OUTPUT); 
			  digitalWrite(sck, 0); pinMode(sck, OUTPUT);													 
if(miso!=255){						pinMode(miso, INPUT);}	
if(mosi!=255){digitalWrite(mosi,0); pinMode(mosi,OUTPUT);}	
return 0;}
uint8_t  SSPIinitTime  (uint8_t div){											//--Расчет задержки для макроса RT_HW_DELAY(time);
	uint16_t tm=(RT_HW_SPN_DELAY+1)*div; if(tm>255) {return 255;} return (uint8_t)tm;}
//=================================================================================================
//												Обмен 
//=================================================================================================
uint8_t  SSPItransfer   (uint8_t time, uint8_t bitOrder, uint8_t   tx, 							  uint8_t sck, uint8_t mosi, uint8_t miso, uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMOSI, idMISO, idCS;	uint8_t rx=0;		//--Создание  временных объектов для пинов clk(SCK),miso(SO),cs(CS);
												RT_HW_PIN_DIR_SET_ID(idSCK,sck);   						
uint8_t  permitTx=0; if(mosi!=255) {permitTx=1; RT_HW_PIN_DIR_SET_ID(idMOSI,mosi);}
uint8_t  permitRx=0; if(miso!=255) {permitRx=1; RT_HW_PIN_DIR_SET_ID(idMISO,miso);}
												RT_HW_PIN_DIR_SET_ID(idCS,cs);	 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);										//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
if(bitOrder){for(uint8_t i=0; i<=7; i++){							//--Цикл записи/чтения для MSBFIRST;
if(permitTx){   RT_HW_PIN_DIR_WRITE(idMOSI,(tx & 1<<(7-i)));}	//--Побитовая запись переменной;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
if(permitRx){if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(7-i);}}}}	//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
else	    {for(uint8_t i=0; i<=7; i++){							//--Цикл записи/чтения для MSBFIRST;
if(permitTx){   RT_HW_PIN_DIR_WRITE(idMOSI,(tx & 1<<(i)));}			//--Побитовая запись переменной;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
if(permitRx){if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(i);}}}}		//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);	RT_HW_PIN_DIR_WRITE_LOW(idMOSI); 
return rx;}
uint16_t SSPItransfer16 (uint8_t time, uint8_t bitOrder, uint16_t  tx, 							  uint8_t sck, uint8_t mosi, uint8_t miso, uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMOSI, idMISO, idCS; 	uint8_t  rx=0; 		//--Создание  временных объектов;
												RT_HW_PIN_DIR_SET_ID(idSCK,sck);  					
uint8_t  permitTx=0; if(mosi!=255) {permitTx=1; RT_HW_PIN_DIR_SET_ID(idMOSI,mosi);}
uint8_t  permitRx=0; if(miso!=255) {permitRx=1; RT_HW_PIN_DIR_SET_ID(idMISO,miso);}
												RT_HW_PIN_DIR_SET_ID(idCS,cs); 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);										//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
if(bitOrder){for(uint8_t i=0; i<=15; i++){							//--Цикл записи/чтения для MSBFIRST;
if(permitTx){if(tx & 1<<(15-i)){RT_HW_PIN_DIR_WRITE_HIGH(idMOSI);} else{RT_HW_PIN_DIR_WRITE_LOW(idMOSI);}				//--Побитовая запись переменной;
			 RT_HW_PIN_DIR_WRITE_LOW(idSCK); RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);}	//--Строб sck с задержкой;
if(permitRx){if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(15-i);}}}}		//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
else	    {for(uint8_t i=0; i<=15; i++){							//--Цикл записи/чтения для MSBFIRST;
if(permitTx){if(tx & 1<<(i))   {RT_HW_PIN_DIR_WRITE_HIGH(idMOSI);} else{RT_HW_PIN_DIR_WRITE_LOW(idMOSI);}	//--Побитовая запись переменной;
			 RT_HW_PIN_DIR_WRITE_LOW(idSCK); RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);}		//--Строб sck с задержкой;
if(permitRx){if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(i);}}}}		//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);	RT_HW_PIN_DIR_WRITE_LOW(idMOSI); 
return rx;}
void 	 SSPItransferArr(uint8_t time, uint8_t bitOrder, uint8_t  *tx, uint8_t  *rx, uint8_t qnt, uint8_t sck, uint8_t mosi, uint8_t miso, uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMOSI, idMISO, idCS;			//--Создание  временных объектов для пинов clk(SCK),miso(SO),cs(CS);
												RT_HW_PIN_DIR_SET_ID(idSCK,sck); 						
uint8_t  permitTx=0; if(mosi!=255) {permitTx=1; RT_HW_PIN_DIR_SET_ID(idMOSI,mosi);}
uint8_t  permitRx=0; if(miso!=255) {permitRx=1; RT_HW_PIN_DIR_SET_ID(idMISO,miso);}
												RT_HW_PIN_DIR_SET_ID(idCS,cs); 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);										//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
for(uint8_t j=0; j<qnt; j++){
if(bitOrder){for(uint8_t i=0; i<=7; i++){							//--Цикл записи/чтения для MSBFIRST;
if(permitTx){   RT_HW_PIN_DIR_WRITE(idMOSI,(tx[j] & 1<<(7-i)));}	//--Побитовая запись переменной;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
if(permitRx){if(RT_HW_PIN_DIR_READ(idMISO)){rx[j] |=1<<(7-i);}}}}	//--Побитовое чтение измеряемого параметра;
else	    {for(uint8_t i=0; i<=7; i++){							//--Цикл записи/чтения для MSBFIRST;
if(permitTx){   RT_HW_PIN_DIR_WRITE(idMOSI,(tx[j] & 1<<(i)));}		//--Побитовая запись переменной;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
if(permitRx){if(RT_HW_PIN_DIR_READ(idMISO)){rx[j] |=1<<(i);}}}}}	//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);	RT_HW_PIN_DIR_WRITE_LOW(idMOSI);}
void     SSPIwrite      (uint8_t time, uint8_t bitOrder, uint8_t   tx, 							  uint8_t sck, uint8_t mosi,               uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMOSI, idCS;		//--Создание  временных объектов для пинов clk(SCK),miso(SO),cs(CS);
RT_HW_PIN_DIR_SET_ID(idSCK,sck);   			//--Настройка idSCK;						
RT_HW_PIN_DIR_SET_ID(idMOSI,mosi);  		//--Настройка idMOSI	
RT_HW_PIN_DIR_SET_ID(idCS,cs);	  			//--Настройка idCS;	 
if(bitOrder){tx=reverseByte(tx);}			//--Реверс бит в байте;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);	RT_HW_DELAY(time);						//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<=7; i++){RT_HW_PIN_DIR_WRITE(idMOSI,(tx & 1<<(i)));	//--Побитовая запись переменной;
RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_LOW(idSCK);  					//--sck->LOW  с задержкой;
RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK);} 					//--sck->HIGH с задержкой;
//-------------------------------------------------------------------------------------------------	
RT_HW_PIN_DIR_WRITE_HIGH(idCS);	RT_HW_DELAY(time);						//--Установка пина cs в HIGH; 
RT_HW_PIN_DIR_WRITE_LOW(idMOSI);}										//--Очистка пина mosi   и EXIT;
void  	 SSPIwrite16    (uint8_t time, uint8_t bitOrder, uint16_t  tx, 							  uint8_t sck, uint8_t mosi,  			   uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMOSI, idCS;		//--Создание  временных объектов для пинов clk(SCK),miso(SO),cs(CS);
RT_HW_PIN_DIR_SET_ID(idSCK,sck);   			//--Настройка idSCK;						
RT_HW_PIN_DIR_SET_ID(idMOSI,mosi);  		//--Настройка idMOSI	
RT_HW_PIN_DIR_SET_ID(idCS,cs);	  			//--Настройка idCS;	 
if(bitOrder){tx=reverseV16(tx);}			//--Реверс бит в байте;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);	RT_HW_DELAY(time);						//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<=15; i++){RT_HW_PIN_DIR_WRITE(idMOSI,(tx & 1<<(i)));	//--Побитовая запись переменной;
RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_LOW(idSCK);  					//--sck->LOW  с задержкой;
RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK);} 					//--sck->HIGH с задержкой;
//-------------------------------------------------------------------------------------------------	
RT_HW_PIN_DIR_WRITE_HIGH(idCS);	RT_HW_DELAY(time);						//--Установка пина cs в HIGH; 
RT_HW_PIN_DIR_WRITE_LOW(idMOSI);}										//--Очистка пина mosi   и EXIT;

//====================================================================================================
void 	 SSPIwriteArr   (uint8_t time, uint8_t bitOrder, uint8_t  *tx, uint8_t qnt, uint8_t sck, uint8_t mosi,               uint8_t cs){
if(qnt==0) {return;}  
RT_HW_PIN_DIR_ID idSCK;  RT_HW_PIN_DIR_SET_ID(idSCK,sck);    //--Настройка idSCK;
RT_HW_PIN_DIR_ID idMOSI; RT_HW_PIN_DIR_SET_ID(idMOSI,mosi);  //--Настройка idMOSI;
RT_HW_PIN_DIR_ID idCS;   RT_HW_PIN_DIR_SET_ID(idCS,cs); 	 //--Настройка idCS;						
uint8_t arr[qnt];
for(uint8_t i=0; i<qnt; i++){if(bitOrder){arr[i]=reverseByte(tx[i]);} else {arr[i]=tx[i];}}	//--Реверс бит в байтах;
//-------------------------------------------------------------------------------------------------; 
RT_HW_PIN_DIR_WRITE_LOW(idCS);	RT_HW_DELAY(time);						//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
for(uint8_t j=0; j<qnt; j++){uint8_t k; if(bitOrder) {k=qnt-j-1;} else{k=j;}
  for(uint8_t i=0; i<=7;  i++){RT_HW_PIN_DIR_WRITE(idMOSI,(arr[k] & 1<<(i)));	//--Побитовая запись переменной;
    RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); 						//--sck->LOW  с задержкой;
    RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_LOW(idSCK);} 		 				//--sck->HIGH с задержкой;
  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_LOW(idMOSI);}						//--Очистка пина mosi 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);	RT_HW_DELAY(time);}						//--Установка пина cs в HIGH и EXIT;


uint8_t  SSPIread       (uint8_t time, uint8_t bitOrder,               			 uint8_t sck,               uint8_t miso, uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMISO, idCS;		uint8_t rx=0;			//--Создание  временных объектов;
											RT_HW_PIN_DIR_SET_ID(idSCK,sck);
											RT_HW_PIN_DIR_SET_ID(idMISO,miso);   
											RT_HW_PIN_DIR_SET_ID(idCS,cs); 							 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);										//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
if(bitOrder){for(uint8_t i=0; i<=7; i++){							//--Цикл записи/чтения для MSBFIRST;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
 if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(7-i);}}}					//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
else	    {for(uint8_t i=0; i<=7; i++){								//--Цикл записи/чтения для MSBFIRST;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
  if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(i);}}}	//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);		   								//--Установка пина cs в HIGH; 
return rx;}
uint16_t SSPIread16     (uint8_t time, uint8_t bitOrder,               			 uint8_t sck,               uint8_t miso, uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMISO, idCS;	   uint16_t rx=0;			//--Создание  временных объектов;
											RT_HW_PIN_DIR_SET_ID(idSCK,sck);
											RT_HW_PIN_DIR_SET_ID(idMISO,miso);   
											RT_HW_PIN_DIR_SET_ID(idCS,cs); 							 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);										//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
if(bitOrder){for(uint8_t i=0; i<=15; i++){							//--Цикл записи/чтения для MSBFIRST;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(15-i);}}}					//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
else	    {for(uint8_t i=0; i<=15; i++){							//--Цикл записи/чтения для MSBFIRST;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
  if(RT_HW_PIN_DIR_READ(idMISO)){rx |=1<<(i);}}}		//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);		   								//--Установка пина cs в HIGH; 
return rx;}
void     SSPIreadArr	(uint8_t time, uint8_t bitOrder, uint8_t  *rx, uint8_t qnt, uint8_t sck,               uint8_t miso, uint8_t cs){
RT_HW_PIN_DIR_ID idSCK, idMOSI, idMISO, idCS;			//--Создание  временных объектов для пинов clk(SCK),miso(SO),cs(CS);
												RT_HW_PIN_DIR_SET_ID(idSCK,sck); 						
												RT_HW_PIN_DIR_SET_ID(idMISO,miso);
												RT_HW_PIN_DIR_SET_ID(idCS,cs); 
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_LOW(idCS);										//--Установка пина cs в HIGH; 
//-------------------------------------------------------------------------------------------------
for(uint8_t j=0; j<qnt; j++){
if(bitOrder){for(uint8_t i=0; i<=7; i++){							//--Цикл записи/чтения для MSBFIRST;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
			 if(RT_HW_PIN_DIR_READ(idMISO)){rx[j] |=1<<(7-i);}}}	//--Побитовое чтение измеряемого параметра;
else	    {for(uint8_t i=0; i<=7; i++){								//--Цикл записи/чтения для MSBFIRST;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(time);	//--Строб sck с задержкой;
			 if(RT_HW_PIN_DIR_READ(idMISO)){rx[j] |=1<<(i);}}}}	//--Побитовое чтение измеряемого параметра;
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS);}
//=================================================================================================
