//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//          Параметры
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_SR04_VER             14	//--Версия библиотеки;
#define RT_HW_SR04_timePulse	   10	//--Длительность (mcs) генерируемого импульса на пине Trig; 
#define RT_HW_SR04_maxBegin      1200	//--Максимальное время (mcs) появления ответного импульса Echo; 
#define RT_HW_SR04_minBegin       200	//--Минимальное время  (mcs) появления ответного импульса Echo; 
#define RT_HW_SR04_maxDurate    49000	//--Максимальная длительность ответного импульса;
#define RT_HW_SR04_convert        582 	//--Коэффициент пересчета мкс в мм;
#define RT_HW_SR04_CmToMcs	   	   70 	//--Коэффициент преобразования; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            ЧТЕНИЕ СЕНСОРА  HC-SR04
//
// При измерении параметров ответного эхо-импульса c аппаратным прерывание в скетч или в блок FLProg 
// должны быть включены определения переменных и функции 
// volatile uint8_t  state; 
// volatile uint32_t timeBegin;
// volatile uint32_t timeEnd;
// volatile uint32_t timeStart;
//
//if(z.state==1) {z.state++;  attachInterrupt(z.numIRQ, RT_HW_IRQ_SR04_handler_120905424,CHANGE);} //--start IRQ_handler; 
//RT_HW_IRAM_ATTR void RT_HW_IRQ_SR04_handler_120905424(){          
//(z.state==2) {if( RT_HW_PIN_DIR_READ(z.ddPin)){z.timeBegin=micros(); z.state=3;}}
//(z.state==3) {if(!RT_HW_PIN_DIR_READ(z.ddPin)){z.timeEnd  =micros(); z.state=4;}}}
// state=0 - отключен
// state=2 - готовность к определению переднего фронта;
// state=3 - готовность к определению заднего   фронта;
// state=4 - обработка по прерываниям завершена;
// state=5 - измерение завершено успешно;
// state=6 - измерение завершено по timeOut заднего в режиме без прерывания);
// state=7 - ошибка по преждевренному переднему фронту;
// state=8 - ошибка по timeOut переднего фронта;
// state=9 - ошибка по timeOut заднего    фронта;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void sr04(RT_HW_STRUCT_HC_SR04_ID &z){	
//=================================================================================================
if(z.dir==0){
z.run=1; z.fresh=1; z.ok=0;
z.LenMcs=z.maxLen*RT_HW_SR04_CmToMcs;;				//--Установка начальных состояний;
z.codeErr=0; z.cntErrCur=0; z.maxQntErr=3;			//--Параметры ошибок измерений;
z.cntOk=z.cntErr=0;									//--Очистка счетчиков наработки;
sr04_air(z);										//--Расчет скорости воздуха;
//-------------------------------------------------------------------------------------------------
z.pinTrig=z.extPinTrig;
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,z.pinTrig)){z.codeErr=203; z.dir=90; return;}
//-------------------------------------------------------------------------------------------------
z.pinEcho=z.extPinEcho; 
if(z.pinEcho==255){z.pinEcho=z.pinTrig;} 
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,z.pinEcho)){z.codeErr=204; z.dir=90; return;}
//-------------------------------------------------------------------------------------------------
//consoleVar(String(F("1.extPinTrig, pinTrig, first->"))); consoleVar(z.extPinTrig,','); consoleVar(z.pinTrig,','); consoleVar(z.first,'E');
//consoleVar(String(F("2.extPinEcho, pinEcho, first->"))); consoleVar(z.extPinEcho,','); consoleVar(z.pinEcho,','); consoleVar(z.first,'E');
z.dir++;}
//=================================================================================================
//					По команде запуска(run) проверка входных параметров и запуск измерения
//=================================================================================================
if(z.dir==1){
if(!z.run) {return;}																//--Ожидание команды запуска;
//-------------------------------------------------------------------------------------------------
z.numIRQ=digitalPinToInterrupt(z.pinEcho);								//--Проверка пина Echo на наличие прерываний, возвращает -1,;
if((z.numIRQ>=0) && (z.enableIRQ)){z.modeIRQ=1;} else{z.modeIRQ=0;}		//--Выбор режима обработки (с прерываниями/без прерываний);
//-------------------------------------------------------------------------------------------------
if(z.modeIRQ){detachInterrupt(z.numIRQ);}			//--Блокировка прерываний на Echo; 
z.state=0; z.begin=z.end=false;						//--Очистка регистров; 
//----------Формирование запускающего импульса------------------------------------------------------
pinMode(z.pinTrig,OUTPUT); 
digitalWrite(z.pinTrig,1); 
delayMicroseconds(10); 
digitalWrite(z.pinTrig,0);	 
//---------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_SET_ID(z.ddPin,z.pinEcho);			//--Настройка ddPin на пин Trig;
RT_HW_PIN_DIR_MODE_PULLUP(z.ddPin);					//--Пин Echo на ввод с подтяжкой к Vcc; 		   
//----------Проверка входа Echo (должен быть =0 нем менее 200mcs)-----------------------------------
if(RT_HW_PIN_DIR_READ(z.ddPin)){z.state=7; z.dir=10;}//--Чтение Echo. При наличии датчика HIGH не появляется ранее400mcs;		
z.timeStart=micros(); z.timeBegin=z.timeEnd=micros();//--Фиксация начальных времен;	
//----------Переход на обработку по прерыванию/без прерывания--------------------------------------
if(z.modeIRQ){z.state=1; z.dir=2;}  else{z.state=2; z.dir=3;}
}
//=================================================================================================
// 					Обработка импульса Echo в режиме C ПРЕРЫВАНИЯ
//=================================================================================================
if(z.dir==2){if(z.state==4){detachInterrupt(z.numIRQ); z.dir=10;}}
if(z.dir==2){
	z.timeCur=micros(); 
    if(calcPastTime(z.timeStart,z.timeCur)>RT_HW_SR04_maxDurate){
	detachInterrupt(z.numIRQ); 
	z.state=9; z.codeErr=210; z.dir=90;
	}
};						
//=================================================================================================
// 					Обработка импульса Echo в режиме БЕЗ ПРЕРЫВАНИЯ
//=================================================================================================
if(z.dir==3){															
//-------------------------------------------------------------------------------------------------
//				Фиксация переднего фронта на пине Echo c контролем тайм-аута
//------------------------------------------------------------------------------------------------- 
if(z.state==2){do{z.timeBegin=micros(); if( RT_HW_PIN_DIR_READ(z.ddPin)){z.state=3; break;}  		 
 if(calcPastTime(z.timeStart,z.timeBegin)>(RT_HW_SR04_maxBegin)){z.state=8; z.timeEnd=z.timeBegin;break;}}while(1);}
//-------------------------------------------------------------------------------------------------
//				Фиксация заднего фронта на пине Echo c контролем тайм-аута
//------------------------------------------------------------------------------------------------- 
if(z.state==3){do{z.timeEnd=micros();   if(!RT_HW_PIN_DIR_READ(z.ddPin)){z.state=5; break;} //---Выход по тайм-ауту ожидания заднего фронта;
   if(calcPastTime(z.timeBegin,z.timeEnd)>(z.maxLen*RT_HW_SR04_CmToMcs)){z.state=6; break;}}while(1);}
//-------------------------------------------------------------------------------------------------
//				Переход на этап, в зависимости от результатов обработки импульса Echo; 
//-------------------------------------------------------------------------------------------------
if((z.state==5) || (z.state==6)) {z.dir=10;} else {z.codeErr=211; z.dir=90;};}  
//=================================================================================================
//       	   Проверка на преждевременность переднего фронта
//=================================================================================================
if(z.dir==10){if(calcPastTime(z.timeStart,z.timeBegin)< RT_HW_SR04_minBegin){z.state=7; z.codeErr=212; z.dir=90;}}  
//=================================================================================================
//				Расчет длительности ответного импульса и расстояние в мм
//=================================================================================================
if(z.dir==10){z.run=0; z.cntOk++; z.LenMcs=z.echoMcs=(uint16_t)calcPastTime(z.timeBegin,z.timeEnd); z.cntErrCur=0; z.ok=1; z.fresh=1; z.dir=1;}	
//=================================================================================================
//       				Обработка ошибочных измерений
//=================================================================================================
if(z.dir==90){z.run=0; z.cntErr++; if(++z.cntErrCur>z.maxQntErr){z.cntErrCur=0; z.ok=0; z.fresh=1; z.LenMcs=z.echoMcs=z.maxLen*RT_HW_SR04_CmToMcs;} z.dir=1;}
//=================================================================================================
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            				Расчет скорости звука с учетом окружающей температуры;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void sr04_air(RT_HW_STRUCT_HC_SR04_ID &z){if(z.tmpAir!=z.extAir){z.tmpAir=z.extAir; z.speedSoundAir=(331.3+(0.606*float(z.tmpAir)))/2000.0;}}
//=================================================================================================
