//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            			СЕНСОР HTU21
//  i2cFindAdr(uint32_t &timeDelay, uint16_t &custom, uint8_tnno okMax, uint8_t period, uint16_t periodMax, uint8_t adr, uint8_t bus);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_HTU21_VER 				13			//--Номер версии библиотеки
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Параметры для работы с устройством
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_HTU21_ADDRESS 			0x40  		//--Адрес сенсора на шине i2c
#define RT_HW_HTU21_DELAY_ERR   		50 			//--Базовая задержка при повторов после ошибки;
#define RT_HW_HTU21_TIME_METER_TMP		50  		//--Время измерения(mc) в сенсоре после запроса;
#define RT_HW_HTU21_TIME_METER_HUM		70  		//--Время(сенсора) измерения в сенсоре после запроса;
#define RT_HW_HTU21_TIME_REPEAT_RESET   1000		//--Период(bc повторного программного сброса; 
#define RT_HW_HTU21_MAX_NUM_ERR			3			//--Максимальное кол-во тиков с ошибками;
//#define RT_HW_HTU21_FIND_MAX			20			//--Максимальное кол-во циклов при поиске на шине i2c;
#define RT_HW_HTU21_TRIG_TMP_HOLD	 	0xE3		//--Измерение температуры c  удержанием шины;
#define RT_HW_HTU21_TRIG_HUM_HOLD		0xE5		//--Измерение влажности   с  удержанием шины;
#define RT_HW_HTU21_TRIG_TMP_NOHOLD	 	0xF3		//--Измерение темературы без удержания  шины;
#define RT_HW_HTU21_TRIG_HUM_NOHOLD		0xF5		//--Измерение влажности  без удержания  шины;
#define RT_HW_HTU21_SOFT_RESET			0xFE		//--Код программного сброса сенсора
#define RT_HW_HTU21_SHIFTED_DIVISOR 	0x988000	//--Полином 0x0131 = x^8 + x^5 + x^4 + 1;	
#define RT_HW_HTU21_TMP_DEFAULT			-1			//--Значение температуры default;
#define RT_HW_HTU21_HUM_DEFAULT			 2			//--Значение влажности   default;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Управление измерением
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void htu21(RT_HW_STRUCT_HTU21_ID &z){

//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {z.runTemp=z.runHum=1; z.ok=0; z.fresh=1; 
			  z.vTemp=-0.1; z.vHum= 0.2;				//--Начальные параметры для вывода;
			  z.codeErr=i2cInitMaster(z.bus); 			//--Настройка шины i2c;
			  if(z.codeErr){z.dir=95; return;}			//--Выход по ошибке;
              z.sizeDelay=0; z.dir=5;}					//--Подготовка параметров и переход;
//-------------------------------------------------------------------------------------------------
// 							Поиск устройства на шине i2c
//-------------------------------------------------------------------------------------------------
if(z.dir==5) {if(i2cFindAdr(z.timeBegin,z.sizeDelay,z.adr,z.bus)){z.dir=12;} return;}
//----------------------------------------------------------------------------------------
if(z.dir==12){z.codeErr=i2cSendByte(RT_HW_HTU21_SOFT_RESET,z.adr,z.bus); 
			  z.dir=20;} //--Сброс устройства;
if(z.dir==20){if((!z.runTemp)&&(!z.runHum)){return;} 					//--Переход на измерения по внешним флагам;
			  z.step=0; if(z.runTemp){z.runTemp=0; z.dir=21;} else{z.dir=25;}}		//--Переход на измерениe температуры;
if(z.dir==21){htu21_readTemp(z);										//--Измерение температуры
              if(z.err){z.dir=0; return;} 								//--Переход на начало по ошибке;
			  if(z.action)      {return;} 								//--Ожидание завершения;			  
			  z.step=0; if(z.runHum) {z.runHum=0;  z.dir=25;} else{z.dir=80;}}		//--Переход на измерениe температуры;			   
if(z.dir==25){htu21_readHum(z);											//--Измерение влажности;
              if(z.err){z.dir=0; return;} 								//--Переход на начало по ошибке;
			  if(z.action)      {return;} 								//--Ожидание завершения;
			  z.runHum=0; z.dir=80;}												//--Переход по ошибке или на измерение влажности; 		
//-------------------------------------------------------------------------------------------------
// 					Задержка с последующим возвратом на цикл измерения
//-------------------------------------------------------------------------------------------------
if(z.dir==80){z.stepDelay=0; z.dir++;}
if(z.dir==81){if(!timeDelay(z.timeBegin,z.stepDelay,50)){return;} else {z.dir=20; return;}}}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Чтение температуры
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void htu21_readTemp  (RT_HW_STRUCT_HTU21_ID &z){
if(z.step==0){z.err=0; z.action=1; z.cnt=0; z.cntStatus=0; 		 	z.step++;}			//--Подготовка функции;
if(z.step==1){z.codeErr=i2cSendByte(RT_HW_HTU21_TRIG_TMP_NOHOLD,z.adr,z.bus); 			//--Отправка команды;
			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;
			  z.cntStatus=0; z.step++;}													//--Переход на задержку;	 
if(z.step==2){if(timeDelay(z.timeBegin,z.stepDelay,50)){z.step++;} 			  return;}	//--Задержка 50мс;  		 
if(z.step==3){z.codeErr=i2cGetBytes(1,3,z.adr,z.bus); 						  
			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;	 	
			  uint8_t msb=i2cRead(z.bus); uint8_t lsb=i2cRead(z.bus);  uint8_t crc=i2cRead(z.bus);		//--Чтение 3 байт из буфера i2c;
		      uint16_t raw=((uint16_t)msb<<8)|(uint16_t)lsb; 
			  if(htu21_check_crc(raw,crc)!=0){z.step=50; return;} //--Вычисление параметра с контролем CRC;
			  raw&=0xFFFC; float valTmp=raw/(float)65536; z.vTemp= -46.85 + (175.72 * valTmp); 			//--Вычисление температуры float;
			  z.action=0; z.fresh=z.ok=1; z.step=0; return;}																//--Установка флагов;
//-------------------------------------------------------------------------------------------------
if(z.step==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_HTU21_DELAY_ERR; z.step++;}}	//--Контроль повторных ошибок;
if(z.step==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}
//-------------------------------------------------------------------------------------------------
}				
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Чтение влажности
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void htu21_readHum  (RT_HW_STRUCT_HTU21_ID &z){
if(z.step==0){z.err=0; z.action=1; z.cnt=0; z.cntStatus=0; 		 	z.step++;}			//--Подготовка функции; 
if(z.step==1){z.codeErr=i2cSendByte(RT_HW_HTU21_TRIG_HUM_NOHOLD,z.adr,z.bus); 			//--Отправка команды;
			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;
			  z.cntStatus=0; z.step++;}													//--Переход на задержку;
if(z.step==2){if(timeDelay(z.timeBegin,z.stepDelay,20)){z.step++;} 			  return;}	//--Задержка 50мс;  
if(z.step==3){z.codeErr=i2cGetBytes(1,3,z.adr,z.bus); 						  
			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;												//--Переход на задержку;	 	
			  uint8_t msb=i2cRead(z.bus); uint8_t lsb=i2cRead(z.bus);  uint8_t crc=i2cRead(z.bus);		//--Чтение 3 байт из буфера i2c;
		      uint16_t raw=((uint16_t)msb<<8)|(uint16_t)lsb; 
			  if(htu21_check_crc(raw,crc)!=0){z.step=50; return;} //--Вычисление параметра с контролем CRC;
			  raw&= 0xFFFC;  float valHum=raw/(float)65536; z.vHum= -6 + (125 * valHum); 				//--Вычисление влажности float;
			  z.action=0; z.fresh=z.ok=1; z.step=0; return;}																	//--Установка флагов;
//-------------------------------------------------------------------------------------------------
if(z.step==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_HTU21_DELAY_ERR; z.step++;}}	//--Контроль повторных ошибок;
if(z.step==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}
//-------------------------------------------------------------------------------------------------
}		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							Проверка CRC
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t htu21_check_crc(uint16_t message_from_sensor, uint8_t check_value_from_sensor){
uint32_t divisor   = (uint32_t)RT_HW_HTU21_SHIFTED_DIVISOR;	//--Запоминаем 3-х байтовый полином;
uint32_t remainder = (uint32_t)message_from_sensor << 8;	//--Сдвиг измеренного значения на один байт влево (для работы с 3-байтовым полиномом); 
         remainder|= check_value_from_sensor; 				//--Добавление в младший байт crc из сенсора;
for (uint8_t i=0;i<16;i++){if(remainder & (uint32_t)1<<(23-i)) remainder^= divisor; divisor>>=1;} //--Расчет остатка после проверки crc;
return (uint8_t)remainder;
return 0;
}