//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            			СЕНСОР AHT20
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_AHTXX_VER  	 			11		//--Номер версии библиотеки;
#define RT_HW_AHTXX_DELAY_ERR   		50 		//--Базовая задержка при повторов после ошибки;
#define RT_HW_AHTXX_I2CADDR_DEFAULT 	0x38   	//--Базовый адрес i2c;
#define RT_HW_AHTXX_CMD_SOFTRESET 		0xBA    //--Команда программного сброса;
#define RT_HW_AHTXX_CMD_INIT            0xBE  	//--Инициализация
#define RT_HW_AHTXX_CMD_CALIBRATE 		0xE1	//--Команда калибровк;
#define RT_HW_AHTXX_CMD_TRIGGER 		0xAC    //--Trigger reading command
#define RT_HW_AHTXX_CMD_STATUS          0x71  	//--Регистр состояния сенсора;
#define RT_HW_AHTXX_STATUS_BUSY 		0x80    //--Бит занятости  в регистре статуса;
#define RT_HW_AHTXX_STATUS_CALIBRATED 	0x08 	//--Бит калибровки в регистре статуса;

/*
#define AHT20_DEF_I2C_ADDR           0x38  ///< Default I2C address of AHT20 sensor 
#define CMD_INIT                     0xBE  ///< Init command
#define CMD_INIT_PARAMS_1ST          0x08  ///< The first parameter of init command: 0x08
#define CMD_INIT_PARAMS_2ND          0x00  ///< The second parameter of init command: 0x00
#define CMD_INIT_TIME                10    ///< Waiting time for init completion: 10ms
#define CMD_MEASUREMENT              0xAC  ///< Trigger measurement command
#define CMD_MEASUREMENT_PARAMS_1ST   0x33  ///< The first parameter of trigger measurement command: 0x33
#define CMD_MEASUREMENT_PARAMS_2ND   0x00  ///< The second parameter of trigger measurement command: 0x00
#define CMD_MEASUREMENT_TIME         80    ///< Measurement command completion time: 80ms
#define CMD_MEASUREMENT_DATA_LEN     6     ///< Return length when the measurement command is without CRC check.
#define CMD_MEASUREMENT_DATA_CRC_LEN 7     ///< Return data length when the measurement command is with CRC check.
#define CMD_SOFT_RESET               0xBA  ///< Soft reset command
#define CMD_SOFT_RESET_TIME          20    ///< Soft reset time: 20ms
#define CMD_STATUS                   0x71  ///< Get status word command
*/
//=================================================================================================
//							Управление измерением
//=================================================================================================
void ahtXX(RT_HW_STRUCT_AHTXX_ID &z){
enum {QntMaxErr=8};
//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {z.run=1; z.ok=0; z.fresh=1; 
			  z.vTemp=-0.1; z.vHum= 0.2; 		 	//--Начальные параметры для вывода;
			  z.codeErr=i2cInitMaster(z.bus); 		//--Настройка шины i2c;
			  if(z.codeErr){z.dir=95; return;}		//--Выход по ошибке;
              z.sizeDelay=0; z.dir=5;}				//--Подготовка параметров и переход;	
//-------------------------------------------------------------------------------------------------
// 							Поиск устройства на шине i2c
//-------------------------------------------------------------------------------------------------
if(z.dir==5) {if(i2cFindAdr(z.timeBegin,z.sizeDelay,z.adr,z.bus)){z.dir=15;} return;}
//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==15){z.step=0; z.dir++;}					//--Настройка параметров;
if(z.dir==16){ahtXX_init(z); 	  					//--Пошаговая настройка; 		  
              if(z.err){z.dir=0; return;} 			//--Переход на начало по ошибке;
			  if(z.action)      {return;} 			//--Ожидание завершения;
			  z.dir=20;          return;}			//--Переход;			  
//-------------------------------------------------------------------------------------------------
// 							Ожидание флагов запуска измерений
//-------------------------------------------------------------------------------------------------
if(z.dir==20){if(z.run) {z.dir=30;} else {return;}}			
//-------------------------------------------------------------------------------------------------
// 							Измерение 
//-------------------------------------------------------------------------------------------------
if(z.dir==30){if(z.run){z.run=0; z.step=0; z.dir++;} else {z.dir=80;}}	//--Проверка флага;
if(z.dir==31){ahtXX_measurument(z);	 	  			//--Пошаговое измерение; 
              if(z.err){z.dir=0; return;} 			//--Переход на начало по ошибке;
			  if(z.action)      {return;} 			//--Ожидание завершения;
			  z.dir=80;}							//--Переход;
//-------------------------------------------------------------------------------------------------
// 					Задержка с последующим возвратом на цикл измерения
//-------------------------------------------------------------------------------------------------
if(z.dir==80){z.stepDelay=0; z.dir++;}
if(z.dir==81){if(!timeDelay(z.timeBegin,z.stepDelay,50)){return;} else {z.dir=20; return;}}
//-------------------------------------------------------------------------------------------------
}
//=================================================================================================
//								Инициализация
//=================================================================================================
void ahtXX_init(RT_HW_STRUCT_AHTXX_ID &z){
if(z.step==0){z.err=0; z.action=1; z.cnt=0; z.cntStatus=0; 		 	z.step++;}	//--Подготовка функции;
if(z.step==1){if(!timeDelay(z.timeBegin,z.stepDelay,40)){return;} 	z.step++;}	//--Задержка для нормал.питания;
if(z.step==2){z.codeErr=i2cSendByte(0xBA,z.adr,z.bus);  						//--Отправка команды [0xBA] программного сброса;
			  if(z.codeErr){z.step=50; return;}	 					z.step++;}	//--Переход на задержку по ошибке обмена;
if(z.step==3){if(!timeDelay(z.timeBegin,z.stepDelay,20)){return;} 	z.step++;}  //--Задержка для сброса;
if(z.step==4){uint8_t arr[3]={0xE1,0x08,0x00}; 									//--Подготовка команды [0xBE] инициализация;
			  z.codeErr=i2cSendBytes(arr,3,z.adr,z.bus); 						//--Отправка команды;
			  if(z.codeErr){z.step=50; return;}						z.step++;}	//--Переход на задержку по ошибке обмена;
if(z.step==5){if(!timeDelay(z.timeBegin,z.stepDelay,10)){return;}   z.step++;}			
if(z.step==6){uint8_t state;
			  i2cGetBytes (1,1,z.adr,z.bus); if(z.codeErr){z.step=50; return;}	//--Переход на задержку по ошибке обмена;
			  state=i2cRead(z.bus); 
			  i2cGetBytes (1,1,z.adr,z.bus); if(z.codeErr){z.step=50; return;}	//--Переход на задержку по ошибке обмена;
			  state=i2cRead(z.bus);			  
			  if(!bitRead(state,7)){z.action=0; return;}
			  if(++z.cntStatus>5){z.codeErr=70; z.err=1; return;}
               z.step=5; return;}
//if(z.step==6){i2cGetBytes (1,1,z.adr,z.bus);
 //             uint8_t state=i2cRead(z.bus);
//			  if(!bitRead(state,7)){z.action=0; return;}
//			  if(++z.cntStatus>5){z.codeErr=70; z.err=1; return;}//
//
//z.step=5; return;}
			  
			  
//if(z.step==2){z.codeErr=i2cReadRegs(RT_HW_AHTXX_CMD_STATUS,1,z.adr,z.bus);				//--Запрос регистра состояния[0x71]; 
//			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;
//			  uint8_t state=i2cRead(z.bus);												//--Чтение регистра состояния из буфера i2c;	
//			  if(bitRead(state,3)){z.action=0; return;} 					z.step=5;}	//--Успешный выход, если флаг калибровки или переход на инициализацию;
//if(z.step==3){z.codeErr=i2cSendByte(RT_HW_AHTXX_CMD_SOFTRESET,z.adr,z.bus);				//--Отправка команды [0xBA] программного сброса;
//			  if(z.codeErr){z.step=50; return;}	 							z.step++;}	//--Переход на задержку по ошибке обмена;
//if(z.step==4){if(!timeDelay(z.timeBegin,z.stepDelay,20)){return;} 			z.step++;}  //--Задержка для сброса;
//------------
//if(z.step==5){uint8_t arr[3]={RT_HW_AHTXX_CMD_INIT,     0x08,0x00}; 					//--Подготовка команды [0xBE] инициализация;
//			  z.codeErr=i2cSendBytes(arr,3,z.adr,z.bus);								//--Отправка команды;
//			  if(z.codeErr){z.step=50; return;}								z.step++;}	//--Переход на задержку по ошибке обмена;
//if(z.step==6){if(!timeDelay(z.timeBegin,z.stepDelay,20)){return;} 			
//              z.action=0; return;}
			  //z.step++;} 	//--Задержка для проверки состояния калибровки;	
//------------
//if(z.step==6){uint8_t arr[3]={RT_HW_AHTXX_CMD_CALIBRATE,0x08,0x00};	z.cntStatus=0;	 	//--Подготовка команды [0xE1] калибровки;
//			  z.codeErr=i2cSendBytes(arr,3,z.adr,z.bus);								//--Отправка команды;
//			  if(z.codeErr){z.step=50; return;}								z.step++;}	//--Переход на задержку по ошибке обмена;
//if(z.step==7){if(!timeDelay(z.timeBegin,z.stepDelay,10)){return;} 			z.step++;} 	//--Задержка для проверки состояния калибровки;			  
//if(z.step==8){z.codeErr=i2cReadRegs(RT_HW_AHTXX_CMD_STATUS,1,z.adr,z.bus);				//--Запрос регистра состояния[0x71]; 
//			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;
//			  uint8_t state=i2cRead(z.bus);												//--Чтение регистра состояния из буфера i2c;	
//			  if(bitRead(state,3)){z.action=0; return;} 								//--Успешный выход, если флаг калибровки=1;
//			  else{z.step=7; if(++z.cntStatus>5){z.codeErr=70; z.err=1; return;}}}		//--		   
//-------------------------------------------------------------------------------------------------
if(z.step==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_AHTXX_DELAY_ERR; z.step++;}}	//--Контроль повторных ошибок;
if(z.step==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}
}
//=================================================================================================
//								Измерение
//=================================================================================================
void ahtXX_measurument(RT_HW_STRUCT_AHTXX_ID &z){
if(z.step==0){z.err=0; z.action=1; z.cnt=0;  		  						z.step++;}	//--Подготовка функции;
if(z.step==1){uint8_t arr[3]={0xAC,0x33,0x00};											//--Подготовка команды;
			  z.codeErr=i2cSendBytes(arr,3,z.adr,z.bus);								//--Отправка команды;
			  if(z.codeErr){z.step=50; return;}											//--Переход на задержку по ошибке обмена;
			  z.cntStatus=0; z.step++;}													//-- 
if(z.step==2){if(timeDelay(z.timeBegin,z.stepDelay,10)){z.step++;} 			  return;}	//--Задержка 100мс;  
if(z.step==3){z.codeErr=i2cGetByte(z.adr,z.bus);									//--Запрос байт состояния;
			  if(z.codeErr) {z.step=50; return;} 										//--Выход по ошибке обмена;
			  uint8_t state=i2cRead(z.bus);												//--Чтение состояния;
			  if(bitRead(state,7)){z.step=2;return;} 									//--Переход на новый цикл чтения состояния;
			  else                {z.step++;}}											//--Переход на запрос данных;	 			  		  
if(z.step==4){z.codeErr=i2cGetBytes (1,7,z.adr,z.bus);									//--Запрос 7-ми байт с результами мзмерения;
			  if(z.codeErr) {z.step=50; return;} 													//--Выход по ошибке обмена;
			  uint8_t data[7];															//--Создание временного массива;
			  for(uint8_t i=0;i<7;i++){data[i]=i2cRead(z.bus);}							//--Сохранение 7-ми байт масссиве;
			  if( bitRead(data[0],7)){z.codeErr=53;            z.step=50; return;} //--Выход по периодической ошибке, если не завершено преобразование;
			  if(!bitRead(data[0],3)){z.codeErr=54; z.err=1;   z.step=0;  return;} //--Выход по фатальной ошибке, если нет калибровки;
			  if(ahtXX_crc8(&data[0],6)!=data[6]){z.codeErr=55;z.step=50; return;} //--Выход по периодической ошибке,если не совпала контрольная сумма;
//-------------------------------------------------------------------------------------------------			  		  
			  uint32_t temp;
			  temp=data[1];      temp<<=8; temp|=data[2]; temp<<=4; temp|=data[3]>>4; z.vHum =(float)(temp*100)/(float)0x100000;
			  temp=data[3]&0x0F; temp<<=8; temp|=data[4]; temp<<=8; temp|=data[5];    z.vTemp=(float)(temp*200)/(float)0x100000 - 50;		 			   
			  z.action=0; z.fresh=z.ok=1; z.step=0; return;}
//-------------------------------------------------------------------------------------------------
if(z.step==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_AHTXX_DELAY_ERR; z.step++;}}	//--Контроль повторных ошибок;
if(z.step==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}
//-------------------------------------------------------------------------------------------------
}	
//=================================================================================================
//		 Calcuration CRC8 polynomial: CRC[7: 0] = X8 + X5 + X4 + 1  -  0x1 0011 0001 - 0x131
//=================================================================================================
uint8_t ahtXX_crc8(uint8_t *pData, uint8_t len){ uint8_t crc = 0xFF;
for(int pos = 0; pos < len; pos++){crc ^= pData[pos];
 for(int i = 8; i > 0; i--){if(crc & 0x80){crc <<= 1; crc ^= 0x31;} else{crc <<= 1;}}}
return crc;}
//=================================================================================================
