//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            			СЕНСОР BH1750 (освещение)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_BH1750_VER  	 	11		//--Номер версии библиотеки;
#define RT_HW_BH1750_DELAY_ERR  50 		//--Базовая задержка при повторов после ошибки;
//=================================================================================================
//							Управление измерением
//=================================================================================================
void bh1750(RT_HW_STRUCT_BH1750_ID &z){
//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {z.run=1; z.ok=0; z.fresh=1; 
			  z.vLux=0; 		 					//--Начальные параметры для вывода;
			  z.codeErr=i2cInitMaster(z.bus); 		//--Настройка шины i2c;
			  if(z.codeErr){z.dir=95; return;}		//--Выход по ошибке;
              z.sizeDelay=0; z.dir=5;}				//--Подготовка параметров и переход;	
//-------------------------------------------------------------------------------------------------
// 							Поиск устройства на шине i2c
//-------------------------------------------------------------------------------------------------
if(z.dir==5) {if(i2cFindAdr(z.timeBegin,z.sizeDelay,z.adr,z.bus))     {z.dir=10;} return;}			 //--Переход;			  
if(z.dir==10){z.codeErr=i2cSendByte(0x10, z.adr,z.bus);  if(z.codeErr){z.dir=50;  return;} z.dir++;} //--Команда включения питания;
if(z.dir==11){if(!timeDelay(z.timeBegin,z.stepDelay,10))                         {return;} z.dir++;} //--Задержка 10мс;
if(z.dir==12){z.codeErr=i2cSendByte(0x42, z.adr,z.bus);  if(z.codeErr){z.dir=50;  return;} z.dir++;} //--Команда;
if(z.dir==13){z.codeErr=i2cSendByte(0x65, z.adr,z.bus);  if(z.codeErr){z.dir=50;  return;} z.dir++;} //--Команда;
if(z.dir==14){z.codeErr=i2cSendByte(0x10, z.adr,z.bus);  if(z.codeErr){z.dir=50;  return;} z.dir++;} //--Команда;
if(z.dir==15){if(!timeDelay(z.timeBegin,z.stepDelay,10))                         {return;} z.dir=20;}//--Задержка 10мс;
//-------------------------------------------------------------------------------------------------
// 							Ожидание флагов запуска измерений
//-------------------------------------------------------------------------------------------------
if(z.dir==20){if(z.run){z.run=0; z.dir++;} else {return;}}				
if(z.dir==21){z.codeErr=i2cGetBytes(1,2,  z.adr,z.bus);  if(z.codeErr){z.dir=50; return;}           //--Отправка команды измерения;
              uint16_t v=(uint16_t)(i2cRead(z.bus)<<8) | i2cRead(z.bus); z.vLux=v/1.2; 				//--Обработка результата;
			  z.ok=z.fresh=1;															  z.dir++;} //--Обработка результата;
if(z.dir==22){if(!timeDelay(z.timeBegin,z.stepDelay,10))                        {return;} z.dir=20;}//--Задержка 10мс;	
//-------------------------------------------------------------------------------------------------
// 					Динамическая задержка с последующим возвратом на цикл измерения
//-------------------------------------------------------------------------------------------------
if(z.dir==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_BH1750_DELAY_ERR; z.dir++;}}	//--Контроль повторных ошибок;
if(z.dir==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.dir=0; return;}
//-------------------------------------------------------------------------------------------------
}
//=================================================================================================
