//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            			СЕНСОР SHT31
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define RT_HW_SHT31_VER  	 	11		//--Номер версии библиотеки;
#define RT_HW_SHT31_DELAY_ERR   50 		//--Базовая задержка при повторов после ошибки;
#define RT_HW_SHT31_DEFAULT_ADDR          	0x44   //--SHT31 Default Address;
#define RT_HW_SHT31_SOFTRESET 				0x30A2 //--Soft Reset;
#define RT_HW_SHT31_MEAS_HIGHREP_STRETCH  	0x2C06 //--Measurement High   Repeatability with Clock Stretch Enabled;
#define RT_HW_SHT31_MEAS_MEDREP_STRETCH   	0x2C0D //--Measurement Medium Repeatability with Clock Stretch Enabled;
#define RT_HW_SHT31_MEAS_LOWREP_STRETCH    	0x2C10 //--Measurement Low    Repeatability with Clock Stretch Enabled;
#define RT_HW_SHT31_MEAS_HIGHREP           	0x2400 //--Measurement High   Repeatability with Clock Stretch Disabled;
#define RT_HW_SHT31_MEAS_MEDREP          	0x240B //--Measurement Medium Repeatability with Clock Stretch Disabled;
#define RT_HW_SHT31_MEAS_LOWREP     		0x2416 //--Measurement Low    Repeatability with Clock Stretch Disabled;
#define RT_HW_SHT31_READSTATUS 				0xF32D //--Read Out of Status Register;
#define RT_HW_SHT31_CLEARSTATUS 			0x3041 //--Clear Status;
#define RT_HW_SHT31_REG_HEATER_BIT 			0x0d   //--Status Register Heater Bit;
#define RT_HW_SHT31_HEATEREN 				0x306D //--Heater Enable;
#define RT_HW_SHT31_HEATERDIS 				0x3066 //--Heater Disable;
//=================================================================================================
//							Управление измерением
//=================================================================================================
void sht31(RT_HW_STRUCT_SHT31_ID &z){
enum {QntMaxErr=8};
//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {z.run=1; z.ok=0; z.fresh=1; 
			  z.vTemp=-0.1; z.vHum= 0.2; 		 	//--Начальные параметры для вывода;
			  z.codeErr=i2cInitMaster(z.bus); 		//--Настройка шины i2c;
			  if(z.codeErr){z.dir=95; return;}		//--Выход по ошибке;
              z.sizeDelay=0; z.dir=5;}				//--Подготовка параметров и переход;	
//-------------------------------------------------------------------------------------------------
// 							Поиск устройства на шине i2c
//-------------------------------------------------------------------------------------------------
if(z.dir==5) {if(i2cFindAdr(z.timeBegin,z.sizeDelay,z.adr,z.bus)){z.dir=20;} return;}
//-------------------------------------------------------------------------------------------------
// 							Настройка параметров
//-------------------------------------------------------------------------------------------------
//if(z.dir==15){z.step=0; z.dir++;}					//--Настройка параметров;
//if(z.dir==16){sht31_Calibrator(z); 	  				//--Пошаговая настройка; 
//              if(z.err){z.dir=0; return;} 			//--Переход на начало по ошибке;
//			  if(z.action)      {return;} 			//--Ожидание завершения;
//			  z.dir=20;}							//--Переход;			  
//-------------------------------------------------------------------------------------------------
// 							Ожидание флагов запуска измерений
//-------------------------------------------------------------------------------------------------
if(z.dir==20){if(z.run) {z.dir=30;} else {return;}}			
//-------------------------------------------------------------------------------------------------
// 							Измерение 
//-------------------------------------------------------------------------------------------------
if(z.dir==30){if(z.run){z.run=0; z.step=0; z.dir++;} else {z.dir=80;}}	//--Проверка флага;
if(z.dir==31){sht31_Measurument(z);	 	  			//--Пошаговое измерение; 
              if(z.err){z.dir=0; return;} 			//--Переход на начало по ошибке;
			  if(z.action)      {return;} 			//--Ожидание завершения;
			  z.dir=80;}							//--Переход;
//-------------------------------------------------------------------------------------------------
// 					Задержка с последующим возвратом на цикл измерения
//-------------------------------------------------------------------------------------------------
if(z.dir==80){z.stepDelay=0; z.dir++;}
if(z.dir==81){if(!timeDelay(z.timeBegin,z.stepDelay,50)){return;} else {z.dir=20; return;}}
//-------------------------------------------------------------------------------------------------
}
//=================================================================================================
//								Калибровка
//=================================================================================================
/*
void sht31_Calibrator(RT_HW_STRUCT_SHT31_ID &z){
if(z.step== 0){z.err=0; z.action=1; z.cnt=0; z.step++;}
if(z.step== 1){z.codeErr=i2cReadRegs(0x71,1,z.adr,z.bus);			//--Запрос регистра состояния; 
			   if(z.codeErr){z.step=50; return;}					//--Переход на задержку по ошибке обмена;
			   uint8_t state=i2cRead(z.bus);						//--Чтение регистра состояния из буфера i2c;	
			   if(bitRead(state,3)){z.action=0; return;} 			//--Успешный выход, если флаг калибровки=1;
			   z.step++;} 				
if(z.step== 2){uint8_t arr[3]={0xBE,0x08,0x00};			 			//--Подготовка команды калибровки;
			   if(z.codeErr){z.step=50; return;}					//--Переход на задержку по ошибке обмена;
			   z.step++;}
if(z.step== 3){if(!timeDelay(z.timeBegin,z.stepDelay,10)){return;}	//--Задержка;
			   z.action=0; z.step=0;}								//--Завершение;
//-------------------------------------------------------------------------------------------------
if(z.step==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_AHTXX_DELAY_ERR; z.step++;}}	//--Контроль повторных ошибок;
if(z.step==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}
}
*/
//=================================================================================================
//								Измерение
//=================================================================================================
void sht31_Measurument(RT_HW_STRUCT_SHT31_ID &z){
if(z.step==0){z.action=1; z.err=0; z.step++;}						//--Подготовка функции;
if(z.step==1){uint8_t cmd[2]; cmd[0]=z.cmnd>>8;	cmd[1]=z.cmnd&0xFF;	//--Подготовка команды;
			  z.codeErr=i2cSendBytes(cmd,2,z.adr,z.bus);			//--Отправка команды;
			  if(z.codeErr){z.step=50; return;}						//--Переход на задержку по ошибке обмена;
			  z.step++;} 
if(z.step==2){if(!timeDelay(z.timeBegin,z.stepDelay,50)){return;} 	//--Задержка 100мс;  
			  z.step++;} 
if(z.step==3){z.codeErr=i2cGetBytes (1,6,z.adr,z.bus);				//--Запрос 7-ми байт с результами мзмерения;
			  if(z.codeErr) {return;} 								//--Выход по ошибке обмена;
			  uint8_t data[6];										//--Создание временного массива;
			  for(uint8_t i=0;i<6;i++){data[i]=i2cRead(z.bus);}		//--Сохранение 7-ми байт масссиве;
			  if(data[2] !=sht31_crc8(data,  2)){z.codeErr=10; return;}
			  if(data[5] !=sht31_crc8(data+3,2)){z.codeErr=11; return;}
			  int32_t stemp=(int32_t)(((uint32_t)data[0]<<8) | data[1]);
			  // simplified (65536 instead of 65535) integer version of:
			  // temp = (stemp * 175.0f) / 65535.0f - 45.0f;
			   stemp=((4375 * stemp) >> 14) - 4500; z.vTemp = (float)stemp / 100.0f;

			  uint32_t shum = ((uint32_t)data[3] << 8) | data[4];
			  // simplified (65536 instead of 65535) integer version of:
			  // humidity = (shum * 100.0f) / 65535.0f;
			  shum = (625 * shum) >> 12; z.vHum = (float)shum / 100.0f;
			  
			  
			  
			  
			  
			  
			  //if( bitRead(data[0],7)){z.codeErr=53;            z.step=50; return;} //--Выход по периодической ошибке, если не завершено преобразование;
			  //if(!bitRead(data[0],3)){z.codeErr=54; z.err=1;   z.step=0;  return;} //--Выход по фатальной ошибке, если нет калибровки;
			  //if(ahtXX_crc8(&data[0],6)!=data[6]){z.codeErr=55;z.step=50; return;} //--Выход по периодической ошибке,если не совпала контрольная сумма;
//-------------------------------------------------------------------------------------------------			  		  
			  //uint32_t temp;
			  //temp=data[1];      temp<<=8; temp|=data[2]; temp<<=4; temp|=data[3]>>4; z.vHum =(float)(temp*100)/(float)0x100000;
			  //temp=data[3]&0x0F; temp<<=8; temp|=data[4]; temp<<=8; temp|=data[5];    z.vTemp=(float)(temp*200)/(float)0x100000 - 50;		 			   
			  z.action=0; z.fresh=z.ok=1; z.step++; return;}
//-------------------------------------------------------------------------------------------------
if(z.step==50){if(++z.cnt>z.qntMaxErr){z.err=1; return;} else{z.sizeDelay=z.cnt*z.cnt*RT_HW_SHT31_DELAY_ERR; z.step++;}}	//--Контроль повторных ошибок;
if(z.step==51){if(!timeDelay(z.timeBegin,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}
//-------------------------------------------------------------------------------------------------
}	
//=================================================================================================
//		 Calcuration CRC8 polynomial: CRC[7: 0] = X8 + X5 + X4 + 1  -  0x1 0011 0001 - 0x131
//=================================================================================================
//uint8_t sht31XX_crc8(uint8_t *pData, uint8_t len){ uint8_t crc = 0xFF;
//for(int pos = 0; pos < len; pos++){crc ^= pData[pos];
// for(int i = 8; i > 0; i--){if(crc & 0x80){crc <<= 1; crc ^= 0x31;} else{crc <<= 1;}}}
//return crc;}

//=================================================================================================
//		 Calcuration CRC8 polynomial: CRC[7: 0] = X8 + X5 + X4 + 1  -  0x1 0011 0001 - 0x131
// CRC-8 formula from page 14 of SHT spec pdf
// Test data 0xBE, 0xEF should yield 0x92
// Initialization data 0xFF
// Polynomial 0x31 (x8 + x5 +x4 +1)
// Final XOR 0x00
//=================================================================================================
uint8_t sht31_crc8(const uint8_t *data, int len) {
const uint8_t POLYNOMIAL(0x31);
uint8_t crc(0xFF);
for(int j = len; j; --j) {crc ^= *data++;
 for(int i = 8; i; --i) {crc = (crc & 0x80) ? (crc << 1) ^ POLYNOMIAL : (crc << 1);}}
  return crc;
}
//=================================================================================================
