/**************************************************************************************************
 *       БИБЛИОТЕКА ДЛЯ РАСШИРИТЕЛЯ ВВОДА/ВЫВОДА
 *					mcp23017   
 ***********************************************************
  Написана ecoins (ecoins@mail.ru) 
   2019-01-21: Начальная версия
   2021.07.16: Полностью переработанная версия под библиотеку RT_HW_BASE.h; 
   2022.04.22: Переработанная версия под библиотеку RT_HW_BASE.h и для FLProg; 
 ******************************************************************/
//-------------------------------------------------------------------------------------------------
#define RT_HW_MCP23x17_VER 	  	  25	//--Номер версии библиотеки;
#define RT_HW_MCP23x17_DELAY_ERR  50 	//--Базовая задержка при повторов после ошибки;
#define RT_HW_MCP23x17_SIZE_BUFF   6	//--Размер буфера обмена с устройствами;
#define RT_HW_MCP23x17_IODIRA	0x00	//--регистр направления пинов A: =0x00(default) - все на выход, 0xff - все на вход
#define RT_HW_MCP23x17_IODIRB	0x01	//--регистр направления пинов B: =0x00(default) - все на выход, 0xff - все на вход
#define RT_HW_MCP23x17_IPOLA	0x02	//--регистр инверсии    пинов A: =0x00(default) - все прямые,   0xff - все инверсные
#define RT_HW_MCP23x17_IPOLB	0x03	//--регистр инверсии    выводов регистра B: =0x00(default) - все прямые,   0xff - все инверсные
#define RT_HW_MCP23x17_GPPUA	0x0C	//--регистр подтяжки входов регистра A резисторами 100кОм: =0x00(default) - не подтянуты,   0xff - все подтянуты
#define RT_HW_MCP23x17_GPPUB	0x0D	//--регистр подтяжки входов регистра A резисторами 100кОм: =0x00(default) - не подтянуты,   0xff - все подтянуты
#define RT_HW_MCP23x17_GPIOA	0x12	//--регистр выводов  на пины A
#define RT_HW_MCP23x17_GPIOB	0x13	//--регистр выводов  на пины B
#define RT_HW_MCP23x17_IOCON    0x0A	//--регистр конфигурации  

//=================================================================================================
//							Управление устройством
//=================================================================================================
void mcp23x17(RT_HW_STRUCT_MCP23x17_ID &z){
if(z.dir==0) {
z.runIn=z.runOut=1; z.fresh=1; z.ok=z.inA=z.inB=0;   //--Установка параметров;
z.codeErr=0; z.stepDelay=0; z.step=0; z.dir=5;}
//-------------------------------------------------------------------------------------------------
if(z.dir==5) {mcp23x17_initBus(z);    if(z.err){z.dir=90; return;}	//--Инициализация шины c rjynh; 
									  if(z.action)		 {return;}	//--Ожидание завершения;
			                          z.step=0; z.dir=10; return;}			
//-------------------------------------------------------------------------------------------------
if(z.dir==10){mcp23x17_initDevice(z); if(z.err){z.dir=90; return;}	//==Инициализация устройства;			      
									  if(z.action)		 {return;}	//--Ожидание завершения;
			  z.ok=1; z.dir=20;}											//--Переход;
if(z.dir==20){if(z.runIn || z.runOut) {z.dir=25; return;} else   {return;}}	//==Проверка флагов запуска ВВОДА И ВЫВОДА;
//-------------------------------------------------------------------------------------------------
if(z.dir==25){if(z.runIn)   {z.step=0; z.dir++;}  else {z.dir=30; return;}}	//==Проверка флага запуска ВВОДА;
if(z.dir==26){mcp23x17_get(z);		  if(z.err){z.dir=90; return;}	//==ВВОД с контролем ошибок;		   
									  if(z.action)		 {return;}	//--Ожидание завершения;	
			  z.fresh=1; 			
			  z.runIn=0; z.dir=30;  	 return;}	//--Переход;
//-------------------------------------------------------------------------------------------------
if(z.dir==30){if(z.runOut)  {z.step=0; z.dir++;}  else {z.dir=80; return;}} //--Проверка флага запуска ВЫВОДА;	
if(z.dir==31){mcp23x17_send(z);		  if(z.err){z.dir=90; return;}	//--ВЫВОД; 
			  if(z.action)			  				     {return;}	//--Ожидание завершения ВЫВОДА;
			  z.runOut=0;      					z.dir=80; return;}	//--Сброс флага ВЫВОДА и переход;
//-------------------------------------------------------------------------------------------------
//							Ограничение частоты обращения к устройству
//-------------------------------------------------------------------------------------------------
if(z.dir==80){if(!timeDelayMs(z.timeDelay,z.stepDelay,10)){return;} z.dir=20; return;} 
//-------------------------------------------------------------------------------------------------
//							Обработка ошибок
//-------------------------------------------------------------------------------------------------
if(z.dir==90){if(++z.cnt>3){z.dir=0; return;} else{z.sizeDelay=z.cnt*RT_HW_MCP23x17_DELAY_ERR; 
z.stepDelay=0; z.dir++; return;}}	//--Контроль повторных ошибок;
if(z.dir==91){if(!timeDelayMs(z.timeDelay,z.stepDelay,z.sizeDelay)){return;} z.dir=0; return;}
//=================================================================================================
//							Ошибочный замкнутый цикл
//=================================================================================================
if(z.dir==95) {return;}
//-------------------------------------------------------------------------------------------------
}	//--END void RT_HW_HD44780:: direct(RT_HW_HD44780_DEVICE_ID &z){	
	
//=================================================================================================
// 						Настройка устройства
//--Направление бита регистра: =1-ввод, =0-вывод;
//--Режимы входов:=0 инвер.+подтяжка к Vcc; =1 инвер.;=2 - подтяжка к Vcc; =3-как есть;
//=================================================================================================	
void mcp23x17_initDevice(RT_HW_STRUCT_MCP23x17_ID &z) {
if(z.step==0) {z.action=1; z.cnt=0; z.step++; return;}
if(z.step==1) {uint8_t arr[5]; arr[0]=RT_HW_MCP23x17_IODIRA ;arr[1]=z.cnfgA; arr[2]=z.cnfgB; arr[3]=z.cnfgIPOLA; arr[4]=z.cnfgIPOLB; //--Подготовка транзакции;				
			   mcp23x17_write(z,arr,5);	if(z.codeErr) {z.step=90;} else {z.step++;} return;}	//--Запись в устройство с контролем ошибок;	   
if(z.step==2) {uint8_t arr[3]; arr[0]=RT_HW_MCP23x17_GPPUA; arr[1]=z.cnfgGPPUA; arr[2]=z.cnfgGPPUB; 								 //--Подготовка транзакции;
			   mcp23x17_write(z,arr,3);	if(z.codeErr) {z.step=90;} else {z.step++;} return;}	//--Запись в устройство с контролем ошибок;			   
if(z.step==3) {													z.action=0; return;}	//--Успешный выход;
//-------------------------------------------------------------------------------------------------
if(z.step==90){if(++z.cnt>3){z.err=1; return;} else{z.sizeDelay=z.cnt*RT_HW_MCP23x17_DELAY_ERR; z.step++; return;}} //--Выход по повторяемой ошибки;
if(z.step==91){if(timeDelayMs(z.timeDelay,z.stepDelay,z.sizeDelay)){z.step=1;} return;} 	//--Задержка;	
//-------------------------------------------------------------------------------------------------
};
	
//=================================================================================================
//            			 Чтение из устройства	
//=================================================================================================
void mcp23x17_get(RT_HW_STRUCT_MCP23x17_ID &z){
if(z.step==0) {z.action=1; z.cnt=0; z.step++;}
if(z.step==1) {											
//---------------------------Нет ввода-------------------------------------------------------------
			   if((z.cnfgA==0) && (z.cnfgB==0))                          {z.action=0; return;}  //--Успешныый выход; 
//---------------------------Только РA-ввод--------------------------------------------------------
			   if((z.cnfgA!=0) && (z.cnfgB==0)){uint8_t arr[2];   
			   mcp23x17_read(z,RT_HW_MCP23x17_GPIOA,arr,1);  if(z.codeErr){z.step=90; return;}	//--Чтение с контролем ошибок;
               z.inA=arr[0];}																	//--Сохранение результата ввода;
//---------------------------Только РB-ввод--------------------------------------------------------
			   if((z.cnfgA==0) && (z.cnfgB!=0)){uint8_t arr[2];
               mcp23x17_read(z,RT_HW_MCP23x17_GPIOB,arr,1);  if(z.codeErr){z.step=90; return;}	//--Чтение с контролем ошибок;
               z.inB=arr[0];}																	//--Сохранение результата ввода;
//---------------------------РA и PB ввод-----------------------------------------------------------
			   if((z.cnfgA!=0) && (z.cnfgB!=0)){uint8_t arr[2];
			   mcp23x17_read(z,RT_HW_MCP23x17_GPIOA,arr,2);  if(z.codeErr){z.step=90; return;}  //--Успешныый выход; 
			   z.inA=arr[0]; z.inB=arr[1];}														//--Сохранение результата ввода;
//-------------------------------------------------------------------------------------------------
			                                                              z.action=0; return;}	//--Успешныый выход; 	
//-------------------------------------------------------------------------------------------------
if(z.step==90){if(++z.cnt>3){z.err=1; return;} else{z.sizeDelay=z.cnt*RT_HW_MCP23x17_DELAY_ERR; z.stepDelay=0; z.step++;}} //--Выход по повторяемой ошибке;
if(z.step==91){if(timeDelayMs(z.timeDelay,z.stepDelay,z.sizeDelay)){z.step=1;} return;} 			//--Задержка;	
//-------------------------------------------------------------------------------------------------
};
//=================================================================================================
//            			 Запись в устройство
//=================================================================================================
void mcp23x17_send(RT_HW_STRUCT_MCP23x17_ID &z){
if(z.step==0) {z.action=1; z.cnt=0; z.step++;}
//-------------------------------------------------------------------------------------------------
//				Вывод для конфигурации только РА-вывод;
//-------------------------------------------------------------------------------------------------
if(z.step==1) {
//---------------------------Нет вывода--------------------------------------------------------
			   if((z.cnfgA==0xFF) && (z.cnfgB==0xFF)) 					 {z.action=0; return;}  //--Успешный выход;   
//---------------------------Только РA-вывод-------------------------------------------------------			
			   if((z.cnfgA!=0xFF) && (z.cnfgB==0xFF)) {uint8_t arr[2]; arr[0]=RT_HW_MCP23x17_GPIOA; arr[1]=z.outA; //--Подготовка данных для вывода;
			   mcp23x17_write(z,arr,2); 					if(z.codeErr){z.step=90; return;}}	//--Запись с контролем ошибок; 
//---------------------------Только РB-вывод-------------------------------------------------------
			   if((z.cnfgA==0xFF) && (z.cnfgB!=0xFF)) {uint8_t arr[2]; arr[0]=RT_HW_MCP23x17_GPIOB; arr[1]=z.outA; //--Подготовка данных для вывода; 
			   mcp23x17_write(z,arr,2); 					if(z.codeErr){z.step=90; return;}}	//--Запись с контролем ошибок; 	 	
//---------------------------PA и РB-вывод---------------------------------------------------------
			   if((z.cnfgA!=0xFF) && (z.cnfgB!=0xFF)) {uint8_t arr[3]; arr[0]=RT_HW_MCP23x17_GPIOA; arr[1]=z.outA; arr[2]=z.outB;  //--Подготовка данных для вывода;
               mcp23x17_write(z,arr,3); 					if(z.codeErr){z.step=90; return;}}	//--Запись с контролем ошибок; 
//-------------------------------------------------------------------------------------------------
																		  z.action=0; return;}  //--Успешныый выход;			
//-------------------------------------------------------------------------------------------------
if(z.step==90){if(++z.cnt>3){z.err=1; return;} else{z.sizeDelay=z.cnt*RT_HW_MCP23x17_DELAY_ERR; z.step++;}} //--Выход по повторяемой ошибке;
if(z.step==91){if(!timeDelayMs(z.timeDelay,z.stepDelay,z.sizeDelay)){return;} z.step=1; return;}	//--Задержка;
//-------------------------------------------------------------------------------------------------
};

//=================================================================================================
//=================================================================================================
//=================================================================================================
//=================================================================================================
//							Инициализация шин и поиск устройства для I2c
//=================================================================================================
void mcp23x17_initBus(RT_HW_STRUCT_MCP23x17_ID &z){
if(z.step==0) {z.err=0; z.action=1;
z.sizeDelay=0; //--Используется как служебный регистр в функции поиска i2cFindAdr()
	 if(z.mi=='I'){z.step=1;}
else if(z.mi=='S'){z.step=5;}
else if(z.mi=='s'){z.step=10;}
else {z.codeErr=10; z.err=1; return;}
z.sizeDelay=0; //--Используется как служебный регистр в функции поиска i2cFindAdr()
}
//-------------------------------------------------------------------------------------------------
if(z.step==1) {z.codeErr=i2cInitMaster(z.bus); if(z.codeErr){z.err=1; return;}	//--Настройка шины i2c;
               z.sizeDelay=0; z.step++;}		//--z.sizeDelay используется как служебный регистр;
if(z.step==2) {if(!i2cFindAdr(z.timeDelay,z.sizeDelay,z.adr,z.bus)){return;}; z.step=80;} //--Поиск устройства на шине i2c;
//-------------------------------------------------------------------------------------------------
if(z.step==5) {z.codeErr=10; z.err=1; return;}			//--Настройка шины SPI;
//-------------------------------------------------------------------------------------------------
if(z.step==10){z.codeErr=12; z.err=1; return;}			//--Настройка шины SPI;
//-------------------------------------------------------------------------------------------------
if(z.step==80){z.err=0;   z.action=0; return;}			//--Успешное заверешение;
//----------------------------------------------------------
}

//=================================================================================================	
// 							 Запись qnt байт из буфера arr[]
//=================================================================================================	
void mcp23x17_write(RT_HW_STRUCT_MCP23x17_ID &z, uint8_t *arr, uint8_t qnt){
//------Отправка через интерфейс i2c-----------------------
if(z.mi=='I'){i2cSetClockNew(z.speed,z.bus); z.codeErr=i2cSendBytes(arr,qnt,z.adr,z.bus); i2cSetClock(z.bus); return;}
//------Отправка через интерфейс SPI-----------------------
if(z.mi=='S'){z.codeErr=10; return;}
//------Отправка через интерфейс SSPI-----------------------
if(z.mi=='s'){z.codeErr=20; return;}
//---------------------------------------------------------	
z.codeErr=50;
//---------------------------------------------------------		
}
//=================================================================================================	
// 							 Чтение qnt байт начиная адреса=reg в буфер arr[]
//=================================================================================================
void mcp23x17_read(RT_HW_STRUCT_MCP23x17_ID &z, uint8_t reg, uint8_t *arr, uint8_t qnt){ 
//------Отправка через интерфейс i2c-----------------------
if(z.mi=='I'){i2cSetClockNew(z.speed,z.bus); z.codeErr=i2cReadRegs(reg,qnt,z.adr,z.bus); i2cSetClock(z.bus); 
				 //if(qnt>=6)          {z.codeErr=8; return;}
				 for(uint8_t i=0; i<qnt; i++){arr[i]=i2cRead(z.bus);}
				 return;}
//------Отправка через интерфейс SPI-----------------------
if(z.mi=='S'){z.codeErr=11; return;}
//------Отправка через интерфейс SSPI----------------------
if(z.mi=='s'){z.codeErr=21; return;}
//---------------------------------------------------------	
z.codeErr=51;
//--------------------------------------------------------
}

/*	
	//if(id.custom!=1) {return;} 						//--Ожидание настройки ID;
	//if(!id.EN)       {return;}						//--Ожидание разрешения работы;
	//id.timePeriod=millis();							//--Установка параметров;
	if      (id.link=='I'){id.bu16=0; id.dir= 1;}	//--Переход на инициализацию i2c;
	else if (id.link=='S') 			 {id.dir= 2;}	//--Переход на инициализацию SPI;
	else                  {id.custom=96; return;}	//--Выход при ошибочном id.link;
	return;}
if(id.dir== 1) {								//==Для i2c поиск устройства на шине;
	if(RT_HW_Base.i2cFindAdr(id.timePeriod,id.bu16,id.adr,id.bus,3,10,2000)){id.dir=5;} return;} //--Поиск устройства на шине i2c;
if(id.dir== 2) {id.dir=5;}						//==Проверка наличия устройства на SPI (ЗАГЛУШКА);					
if(id.dir== 5) {								//==Инициализация устройства;
	init(id); id.timePeriod=millis(); 				//--Вызов функции настройки и настройка параметра времени;
	if(id.errLink==0){id.dir=10;} else {id.dir=40;} return;}//--Продолжение или  переход по ошибке обмена;
if(id.dir==10) {								//==Проверка id.EN(EN) в каждом цикле запуска;
	if(!id.EN) {return;} id.dir++; return;}
if(id.dir==11) {
	if((++id.cntPeriod)>=id.divPeriod){id.cntPeriod=0; devRead(id);		//==Чтение из устройства;
       if(id.errLink==0){id.freshInput=id.getOutput=1; id.dir=12;} 		//--Продолжение или  переход по ошибке обмена;
	else {id.dir=40;} return;} else id.dir=12;}
if(id.dir==12) {devWrite(id);					//==Запись в устройство;
	if(id.errLink==0){id.dir=20;} else {id.dir=40;} return;}//--Продолжение или  переход по ошибке обмена;
if(id.dir==20) {								//==Ожидание завершения периода;
	if(RT_HW_Base.periodMs(id.timePeriod,id.period)) {id.EN=0; id.dir=10;} return;}
if(id.dir==40) {								//==Обработка ошибки связи (программная задержка и переход на перезапуск);
	if(RT_HW_Base.getPastMs(id.timePeriod)<1000) {return;} else {id.dir=00;}}
}
*/
/*

void setID(RT_HW_STRUCT_MCP23x17 &z, uint8_t vA, uint8_t vB){		//==Настройка (корректировка) ID;
if(z.custom==0){
//----------------------------Сохранение(коректировка) основных параметров-------------------------
id.cnfgA=vA; id.cnfgB=vB;					//--Настройка побитовой конфигурации регистров A,B;	
id.inFlagA =id.outFlagA =id.inFlagB =id.outFlagB =false;	//--Очистка флагов конфигурации      (вход/выход) регистров PA,PB;
id.inFreshA=id.outFreshA=id.inFreshB=id.outFreshB=false; 	//--Очистка флагов готовности данных (вход/выход) регистров PA,PB;
if(id.cnfgA!=0)    {id.inFlagA =id.inFreshA =true;}			//--PA как вход;
if(id.cnfgA!=0xFF) {id.outFlagA=id.outFreshA=true;}			//--PA как выход;
if(id.cnfgB!=0)    {id.inFlagB =id.inFreshB =true;}			//--PA как вход;
if(id.cnfgB!=0xFF) {id.outFlagB=id.outFreshB=true;}			//--PA как выход;
//--------------------------------Настройка шин----------------------------------------------------
if(id.link=='I'){		//==Настройка шины i2c как Master------------------------------------------
if(id.adr<8) {id.adr=0x20+id.adr;}	//--Корректировка адресов i2c для диапазона 0-7;
RT_HW_Base.i2cBegin(255,255,0, id.bus); 												//--Настройка i2c. Функция выполняет действия, если шина раньше не настраивалась;
if(!RT_HW_Base.i2cCheckBusState(RT_HW_I2C_STATE_MASTER,id.bus)){id.custom=90; return;}}	//--Если шина не настроена, выход  по состоянию =90; 	
else if(id.link=='S'){	//==Настройка шины SPI как Master------------------------------------------
//if(!RT_HW_Base.checkPinPGM( RT_HW_PGM_PIN_DOT_ID,id.adr)){id.custom=91; return;}		//--Проверка пина cs на дискретный вывод;
//RT_HW_PIN_DIR_SET_ID(id.ddCS,id.adr);													//--Настройка ID пина 
//RT_HW_PIN_DIR_WRITE_HIGH(id.ddCS); RT_HW_PIN_DIR_MODE_OUTPUT(id.ddCS); 					//--Настройка пина CS;
//RT_HW_Base.spiBegin(255,255,255,255,id.bus);											//--Настройка SPI. Функция выполняет действия, если шина раньше не настраивалась;
//if(!RT_HW_Base.spiCheckBusState(RT_HW_SPI_STATE_MASTER,id.bus)) {id.custom=92; return;}	//--Если шина не настроена, выход  по состоянию =94; 	
//RT_HW_PIN_DIR_WRITE_LOW(id.ddCS); RT_HW_Base.spiSendByte(0,id.bus); RT_HW_PIN_DIR_WRITE_HIGH(id.ddCS);
} //--Очистка SPI;
else {					//==Если не определен тип шины---------------------------------------------
	id.custom=93; return;}															//--Выход по ошибке;
//----------------------------------------------------------------------------------------
id.custom=1;}									//--Код успешного завершения настройки ID;
};

*/




//=================================================================================================
//							//--Установка параметров конфигурации;Установка основных параметров
//=================================================================================================
//void mcp23x17_sertID(RT_HW_STRUCT_MCP23x17_ID &z){
//z.inFlagA =z.outFlagA =z.inFlagB =z.outFlagB =0;	//--Очистка флагов конфигурации      (вход/выход) регистров PA,PB;
//z.inFreshA=z.outFreshA=z.inFreshB=z.outFreshB=0; 	//--Очистка флагов готовности данных (вход/выход) регистров PA,PB;
//if(z.cnfgA!=0)    {z.inFlagA =1;}		//--PA как вход;
//if(z.cnfgA!=0xFF) {z.outFlagA=1;}		//--PA как выход;
//if(z.cnfgB!=0)    {z.inFlagB =1;}		//--PA как вход;
//if(z.cnfgB!=0xFF) {z.outFlagB=1;}		//--PA как выход;
//};