//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   RT_HW_median.h - быстрый медианный фильтр 3-го порядка.
//   Использованы идеи и алгоритмы https://alexgyver.ru/gyverfilters/
//   1.При первом вызове буфер заполняется первым принятым значением. 
//	 2.Сортирует входные данные в порядке возрастания.
//   3.Возвращает серединный результат (медиану). 		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++				  
#ifndef RT_HW_median3_h
#define RT_HW_median3_h
#include "RT_HW_BASE.h"
//-------------------------------------------------------------------------------------------------
template < typename TYPE >
class RT_HW_median3{
public:
TYPE buff[3];
uint8_t index = 255;
//-------------------------------------------------------------------------------------------------
TYPE filtered(TYPE val) {	
if(index==255){index=0; for(uint8_t i=0; i<3; i++){buff[i]=val;} return val;}	//--Заполнение буфера при первом вызове;																
buff[index]=val;        if (++index > 2) {index = 0;}							//--Сохранение значения и смена индекса;
return (max(buff[0],buff[1])==max(buff[1],buff[2])) ? max(buff[0],buff[2]) : max(buff[1],min(buff[0],buff[2]));}
//-------------------------------------------------------------------------------------------------
};
#endif