//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   RT_HW_median.h -  медианный фильтр N-го порядка
//   Использованы идеи и алгоритмы https://alexgyver.ru/gyverfilters/
//   1.При первом вызове буфер заполняется первым принятым значением. 
//	 2.Сортирует входные данные в порядке возрастания.
//   3.Возвращает серединный результат (медиану). 
//   Рекомендуется выбирать N нечетным. 		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++				  
#ifndef RT_HW_median_h
#define RT_HW_median_h
//-------------------------------------------------------------------------------------------------
template < typename TYPE, uint8_t vSize >
class RT_HW_median{
public:
TYPE buff[vSize];
uint8_t index=255;
//-------------------------------------------------------------------------------------------------
TYPE filtered(TYPE val) {
//-------------------------------------------------------------------------------------------------
if(index==255){index=0; for(uint8_t i=0; i<vSize; i++){buff[i]=val;} return val;}	//--Заполнение буфера при первом вызове;
buff[index]=val;																	//--Сохранение в буфере очередного значения;
//--Если index указывает не на последнее значение массива и новое значение нарушило сортировку, выполняется частичная сортировка
     if((index<(vSize-1))&&(buff[index]>buff[index+1])){for(uint8_t i=index; i<(vSize-1);i++){if(buff[i]>buff[i+1]){TYPE bt=buff[i]; buff[i]=buff[i+1]; buff[i+1]=bt;}}} 
//--Если index указывает не на последнее значение массив и новое значение нарушило сортировку, выполняется сортировка
else{if((index>0)        &&(buff[index-1]>buff[index]))  {for(uint8_t i=index; i>0;        i--){if(buff[i]<buff[i-1]){TYPE bt=buff[i]; buff[i]=buff[i-1]; buff[i-1]=bt;}}}}
if(++index>=vSize){index=0;} //--Циклическое изменение индекса
return buff[vSize/2];
}
//-------------------------------------------------------------------------------------------------
};
#endif