//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   RT_HW_ringAverage.h - бегущее среднее с кольцевым буфером;
//   Использованы идеи и алгоритмы https://alexgyver.ru/gyverfilters/
//   1.При первом вызове буфер заполняется первым принятым значением. 
//	 2.По кольцу вместо самого старого записывается новое значение и вычисляется среднее.
//   3.Возвращает серединный результат (медиану). 
//   Рекомендуется выбирать N четным. 		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++				  
#ifndef RT_HW_ringAverage_h
#define RT_HW_ringAverage_h
//-------------------------------------------------------------------------------------------------
template < typename TYPE, uint8_t vSize >
class RT_HW_ringAverage{
public:
TYPE buff[vSize];
uint8_t index=255;
int32_t sum;				//--Временная переменная;
//-------------------------------------------------------------------------------------------------
TYPE filtered(TYPE val) {
if(index==255){index=0; for(uint8_t i=0; i<vSize; i++){buff[i]=val;} return val;}	//--Заполнение буфера при первом вызове;
if(++index>=vSize) index=0; //--Изменение индекса
sum -=buff[index];     		//--Вычитаем старое;
      buff[index]=val;      //--Сохраняем новое значение;
sum +=buff[index];         	//--Прибавляем новое;
return (sum/vSize);}		//--Возвращаем новое среднее;
//-------------------------------------------------------------------------------------------------
float filtered(float val) {
if(index==255){index=0; for(uint8_t i=0; i<vSize; i++){buff[i]=val;} return val;}	//--Заполнение буфера при первом вызове;
if(++index>=vSize) index=0; //--Изменение индекса
sum -=buff[index];     		//--Вычитаем старое;
      buff[index]=val;      //--Сохраняем новое значение;
sum +=buff[index];         	//--Прибавляем новое;
return (sum/vSize);}		//--Возвращаем новое среднее;
//-------------------------------------------------------------------------------------------------
};
#endif