//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                    Структура таблицы фонтов (кириллица)
// font - растровое изображение символа (8 байт); code - код символа в unicode-8;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_HD44780_FONT_UNICODE {uint8_t  font[8]; uint16_t code;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                    Структура данных рабочих параметров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_HD44780_HIVE	{uint16_t set=0; uint8_t qnt=0;};//--Флаги занятости устройства;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                    СТРУКТУРА RT_HW_HD44780_DEVICE_ID;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct   RT_HW_HD44780_DEVICE_ID{		  
//-----------------Основные параметры управления---------------------------------------------------
uint8_t  num=0; 				//--Номер устройства (от 1 до RT_HW_HD44780_MAX_DEVICE).По этому номеру внешние блоки привязываются к устройству;
uint8_t  dir=0;					//--Этапы основной программы управления устройствами;
uint8_t  codeErr=0;				//--Код ошибки при настройке(50-100);
uint8_t  genState=2;			//--Состояние генератора:=0-LOW тактового генератора; =1-HIGH тактового генератора; =2-сброс внешних блоков,тактовый генератор=LOW;
uint8_t  extReset:1,agoReset:1,	//--Внешний перезапуск 	Lcd 			[0->1];
		 extClear:1,agoClear:1,	//--Внешняя очистка 	Lcd				[0->1]; 
		 extLight:1,agoLight:1,	//--Внешнее управление подсветкой Lcd	[=1];
		 extEN:1,	agoEN:1;	//--Разрешение работы Lcd  				[=1];
//-----------------Параметры корректируемые до вызова функции setID()------------------------------
char 	 mode='I';				//--Интерфейс (I,S,4,8);
uint8_t  kind=0;				//--Для i2c:=0-[PCF8574->RS,RW,E,Light,D4-D7]; 	=1-[PCF8574->D4-D7,E,RW,E,Light]; 								//			=2-[MCP23017->PA:RS,RW,E,light; PB:D0-D7];
uint8_t  cols=16; 				//--Кол-во колонок дисплея;
uint8_t  rows=2;				//--Кол-во строк   дисплея;
uint8_t  sizeLcd=3;				//--Размер дисплея;				
uint16_t periodReboot=0;		//--Период внутреннего перезапуска в мин. Если =0, перезапуск не выполняется;
uint16_t cntReboot;				//--Счетчик периода внутреннего перезапуска в мин (и временный рабочий регистр для функции i2cFindAdr);
uint8_t  bus=0;					//--Номер шины (i2c,SPI); 
uint8_t  adr=255;				//--Адрес i2c
uint8_t  cs=255;				//--SPI.cs
uint8_t  sck=255;				//--SPI.sck(SoftWare);
uint8_t  mosi=255;				//--SPI.mosi(SoftWare);
uint8_t  pin[11];				//--i2c->bus,a[i]=255dr,bus; 
uint8_t  sendTime=10;
//------------------------------------------------------------------------------------------------- 
uint8_t	 chip:2,				//--Кол-во чипов в устройстве; 
		 agoChip:2,				//--Номер текущего чипа;		 
		 blockPinRW:1,			//--Блокировка использования пина RW (шины bus4,bus8);  
		 orderBitLcd:1;			//--Последовательность битов  в платах согласования интерфейсов(i2c,SPI,SSPI) Lcd;		 
//-----------------Основные параметры управления---------------------------------------------------
uint8_t  periodBlink=10;		//--Период мерцания полями (в тиках);
//-----------------Параметры тактирующего генератора (для связи с внешними блоками)----------------
uint8_t  genPeriod=RT_HW_HD44780_PERIOD_TICK; //--Период событий  тактирующего генератора в мс;
uint32_t genTime;				//--Рабочий регистр тактирующего генератора;
uint16_t genCalcMin;			//--Счетчик для вычисление минутных событий;
//---------------------------Флаги-----------------------------------------------------------------
uint8_t  cmnd:1,				//--0/1-в дисплей передаются данные/команда (RS=0/1);  
		 busy:1, 				//--Флаг занятости дисплея;
		 link:1,				//--Флаг успешной (=1) связи с устройством (важно для i2c);
		 event:1, 				//--События 50мс;
		 runReset:1,			//--Флаг запуска сброса;	
		 tick:1,				//--Меандр 50мс;
		 mnt:1;					//--Меандр 1 мин;
uint8_t  codeErrLink;			//--Код ошибки при обмене с шинами;
//-----------------------Рабочие регистры----------------------------------------------------------
uint8_t  cntWatchDogBusy;		//--Счетчик watch dog для флага busy (в тиках);
uint32_t timeDelay;				//--Рабочие регистры для работы со временем;
uint16_t buff16;				//--Рабочий регистры для функции i2cFindAdr;
uint8_t  index;					//--Рабочий регистр;
uint8_t  stepSend;				//--Этапы для функции deviceSend();
uint8_t  stepInit; 				//--Этапы для функций инициализации устройства; 
uint8_t  step; 					//--Этапы; 
uint8_t  codeBlack=0xFF;		//--Код для отображения черного квадрата (может меняться в зависимости от кодировки);
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//				Структура для блоков вывода на LCD
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_HD44780_PARAM_ID{			
uint8_t  num=0;  		//--Номер устройства; 
uint8_t  dir=0;  		//--Номер этапа блока вывода параметра на lcd;
uint8_t  lcdState=2;
uint8_t  agoState=0;
uint8_t  index=0;		//--Индекс для вывода;
uint8_t  indexSrc;		//--Индекс - используется для перекодировки в RUS;
uint8_t  buff;			//--Буфер для выводимого кода;
uint8_t  mode='B';		//--Интерфейс [I,S,4,8];
uint8_t  modeOutput='C';//--Режим вывода [C,P,T,A,E,S,F];
uint16_t col:6,   		//--Номера колонки выводимого поля;
		 row:4,  		//--Номера строки  выводимого поля;
		 len:6;  		//--Полная длина выводимого поля(заголовок+переменная+суффикс+заполнители свободного поля);		 
uint16_t custom:1,		//--Флаг успешной настройки ID;
		 lenHead:6,		//--Длина заголовка;
         lenVar:6, 		//--Длина переменной;		 
		 lenSuff:1,		//--Длина суффикса;
		 flagHead:1,	//--Флаг вычисления длин заголовка и суффикса; 
		 flagBuff:1;	//--Флаг заполненности буфера buff (байтом предназначенным для вывода);	
uint8_t  output=0;		//--Флаг вывода данных;
uint8_t  clear:1,		//--Флаг очистки поля;
		 first:1,		//--Флаг первого запуска
		 fresh:1,		//--"Свежие" данные;
		 flicker:1, 	//--Флаг для мерцания;
		 run:1,			//--Флаг индикации вывода;
		 runENon:1,		//--Флаг начала операции блокировки(очистка)/разблокировки
		 runENoff:1,	//	 
		 runOutput:1;	//--Флаг запуска вывода;
uint8_t	 extEN:1,    agoEN:1,	//--Состояние входа EN 	 (текущее и предыдущее значения); 	 	 
		 exteN:1,    agoeN:1,	//--Состояние входа eN 	 (текущее и предыдущее значения); 	 	 
		 extBlink:1, agoBlink:1,//--Состояние входа Blink(текущее и предыдущее значения);  	 
		 agoBool:1, 			//--Предыдущее  значение битовой переменной;
		 outStart:1;			//--Флаг ожидания вывода (после вывода очищается);
uint8_t  curChip:2, fistLine:1;	//--Номер текущего чипа Lcd;
uint8_t  vCursor;
uint16_t  periodLimitLow=2;		//--Период  минимального периода вывода(в тиках);
uint16_t  cntPeriodLimitLow;		//--Счетчик минимального периода вывода(в тиках);
uint16_t  periodOutput=1; 		//--Период  периодического вывода(в тиках) [режимы P,T,A];  
uint16_t  cntPeriodOutput;		//--Счетчик периодического вывода(в тиках) [режимы P,T,A]; 
uint8_t  periodBlink=10;		//--Период мерцания (в тиках);
uint8_t  cntFunc;
uint8_t  dirBlink;
uint8_t  agoTest=0;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++




