//=================================================================================================
//							Настройка ID
//=================================================================================================
void setDeviceID(RT_HW_HD44780_DEVICE_ID &z){
z.genState=4;
if(z.num!=0)	 {return;}					//--Выход, если ID уже настроен;
for(uint8_t i=0; i<8;i++){z.pin[i]=255;} 	//--Заполнение буферов значениями 255 (недопустимые пины, адреса и т.п.;
z.chip=1;									//--Предварительная установка кол-ва чипов в Lcd;
z.extEN=1;									//--Флаг  для параметра EN;
z.extLight=1;								//--Флаги для параметра Light;
z.agoClear=0;	z.extClear=0;				//--Флаги для параметра Clear;
z.agoReset=z.extReset=z.runReset=0;			//--Флаги для параметра Reboot;								
z.blockPinRW=1;								//--Установка флага "Блокировка работы с пином RW";
//------------------------------------------------------------------------------------------------
//		Если z не настроен и есть свободные номера (1-15), то настройка указателя
//------------------------------------------------------------------------------------------------
if(hive.qnt>15)						 {z.codeErr=50; return;}//--Выход по превышению макс. qnt;
if(hive.qnt>RT_HW_HD44780_MAX_DEVICE){z.codeErr=51; return;}//--Выход по занятым указателям;
uint8_t num=RT_HW_Base.setFistFreeDevice(hive.set,RT_HW_HD44780_MAX_DEVICE); //--Получение номера устройства;
if(num==0) 							 {z.codeErr=52; return;}//--Выход, если все номера оказались заняты;
z.num=num;													//--Сохранение полученного номера устройства; 							
hive.qnt++;													//--Увеличение кол-ва занятых устройств;
setPointID(&z);												//--Установка адреса указателя;
//-------------------------------------------------------------------------------------------------
}  //--End setPointID();
//=================================================================================================
// 						Установка указателя (временная функция - будет переделано)
//=================================================================================================
void  setPointID(RT_HW_HD44780_DEVICE_ID *z){if(z->num<=RT_HW_HD44780_MAX_DEVICE)  {ptr[z->num]=z;}}
//=================================================================================================
// 						Основной тактирующий генератор устройства
// Вход:  genState: отключение генератора 2->genState;
// Выход: genState: =0 тик=LOW; =1 тик=HIGH; =2 тик=LOW, флаг перезапуска для синхронизируемых устройств; 
//        z.event: событие 50мс; z.tick: меандр 50мс; z.mnt мендр 1мин; 
//        z.runReboot: периодический[z.genPeriodReboot в мин] флаг перезагрузки;
//=================================================================================================
void generator(RT_HW_HD44780_DEVICE_ID &z){
if(z.num==0){z.genState=4; return;}
if(RT_HW_Base.periodMs(z.genTime, RT_HW_HD44780_PERIOD_TICK)){
if(z.genState>=2){z.tick=z.mnt=0; z.runReset=0; z.cntWatchDogBusy=z.genCalcMin=z.cntReboot=0; return;} //--Если генератор выключен, сброс переменных и выход;	
if(z.genState==0){z.genState=1;} else{z.genState=0;}
if(z.busy){z.cntWatchDogBusy++; if(z.cntWatchDogBusy>RT_HW_HD44780_WATCH_DOG_BUSY){z.cntWatchDogBusy=0; z.busy=0;}}
if(++z.genCalcMin>=1200){								//--Проверка  периода 1 мин;
//if(++z.genCalcMin>=20){								//--Проверка  периода 1 сек;
z.genCalcMin=0; if(z.mnt==0) {z.mnt=1;} else {z.mnt=0;}; 							//--Генерация меандра 1 мин z.mnt;
if(z.periodReboot>0){z.cntReboot++; if(z.cntReboot>=z.periodReboot){z.cntReboot=0; z.runReset=1;}}} 	//--Установка флага перезагрузки;  
}}; 
//=================================================================================================
//							Управление устройством 
//         extEN:1, agoEN:1, eN:1, extReset:1, agoReset:1, reset:1, busy:1;
//=================================================================================================
void direct(RT_HW_HD44780_DEVICE_ID &z){
generator(z);	//--Тактирующий генератор(параметор z.genState синхронизирует внешние блоки вывода [для FLProg]);
//-------------------------------------------------------------------------------------------------
//					[dir==0]:Первичная (одноразовая) инициализация внутренних параметров
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {return;}									
//-------------------------------------------------------------------------------------------------
//					[dir==5]:Инициализация устройства с учетом внешних параметров(констант)
//							[внешние параметры задаются по условию z.dir==0]
//-------------------------------------------------------------------------------------------------
if(z.dir==5){	
if((z.cols==40) && (z.rows==4))  {z.chip=2;} else {z.chip=1;}	//--Получение кол-ва чипов в дисплее(для дисплеев 40x4 два чипа);
z.codeErr=initBUS(z);											//--Инициализация шины;
if(z.codeErr>0) {z.dir=90;}  else{z.dir=8;} return;}			//--Выход по ошибке или продолжение;
//-------------------------------------------------------------------------------------------------
//							Циклическая проверка условий запуска
//-------------------------------------------------------------------------------------------------
if(z.dir==8){z.timeDelay=millis(); z.dir++;} 
if(z.dir==9){if(RT_HW_Base.getPastMs(z.timeDelay)>200){z.dir++;} else{return;}}
//-------------------------------------------------------------------------------------------------
if(z.dir==10){												
z.genState=2;								//--Остановка(сброс) тактирующих генераторов внешних блоков;			
if(!z.extEN) {return;}						//--Ожидание разрешения работы;
z.codeErr=0; 								//--Очистка кода ошибок;
z.tick=z.mnt=0; 							//--Очистка флагов генератора;
z.cntReboot=z.runReset=0;					//--Очистка параметров перезапуска Lcd; 
z.genCalcMin=z.cntWatchDogBusy=0; 			//--Очистка параметров генератора
z.buff16=z.step=z.index=z.stepInit=0; 		//--Подготовка регистров;
z.busy=z.link=1; 							//--Подготовка регистров;
if(z.mode=='I'){z.dir=11;} else {z.dir=12;} //--Если не шина i2c, то пропуск поиcка устройства на шине i2c;
return;}				
//-------------------------------------------------------------------------------------------------
//							Поиск устройства на шине i2c
//  i2cFindAdr(uint32_t &timeDelay, uint16_t &custom, uint8_t okMax, uint8_t period, uint16_t periodMax, uint8_t adr, uint8_t bus);
//-------------------------------------------------------------------------------------------------
if(z.dir==11) {
if(RT_HW_Base.i2cFindAdr(z.timeDelay, z.buff16,10,3,2000,z.adr, z.bus)){z.dir=12;} return;}
//-------------------------------------------------------------------------------------------------
//							Инициирование шины дисплея;
//-------------------------------------------------------------------------------------------------
if(z.dir==12) {
if(!initLcd(z))						   {return;}		//--Настройка Lcd;
if(!z.link) {z.genState=2; 	 z.dir=8;	return;}		//--Выход, если оборвалась связь;
z.busy=0; 	 z.genState=0; 	 z.dir=20;					//--Переход на открытый цикл;	
return;} 												//--Успешный переход;
//-------------------------------------------------------------------------------------------------
//							Основной открытый цикл
//-------------------------------------------------------------------------------------------------
if(z.dir==20){
if(z.codeErr) {z.genState=2; 			     z.dir=8;  return;}	//--Перезапуск при обрыве связи (i2c);
if(!z.extEN)  {z.genState=2; directClear(z); z.dir=8;  return;}	//--Перезапуск при блокирование дисплея;
if(z.agoReset!=z.extReset){z.agoReset=z.extReset; if(z.agoReset){z.genState=2; z.dir=10; return;}} //--Перезапуск по кнопке сброс(событие)
if(z.runReset){z.genState=2; 				 z.dir=10; return;} //--Перезапуск от счетчика перезапуска(мин) генератора (при периоде перезапуска>0); 
return;}
//-------------------------------------------------------------------------------------------------
//							Замкнутый цикл (при неопредолимых ошибок при настройке
//-------------------------------------------------------------------------------------------------
if(z.dir==90) {return;}
//-------------------------------------------------------------------------------------------------
}
//=================================================================================================
//				Функции для работы c полями ID внешних блоков через ptr[num]->
//=================================================================================================
bool checkNum (uint8_t &num){if((num!=0) && (num<=hive.qnt))   {return true;} else {return false;}} 										
//=================================================================================================
// 						Установка указателя (временная функция - будет переделано)
//=================================================================================================
//void directLight(RT_HW_HD44780_DEVICE_ID &z){
//if(z.busy) {return;}
//if(z.agoLight==z.extLight){return;}	else{z.agoLight=z.extLight;}
//uint8_t v; if(z.agoLight){v=0b00001100;} else{v=0b00000100;} delayMicroseconds(40); deviceSend(z.num,1,v,'I'); delayMicroseconds(40);
//if(z.chip==2) 												{delayMicroseconds(40); deviceSend(z.num,2,v,'I'); delayMicroseconds(40);}	
//}
//=================================================================================================
// 						Установка указателя (временная функция - будет переделано)
//=================================================================================================
void directClear(RT_HW_HD44780_DEVICE_ID &z){
uint8_t v= 0b00000001; 	 deviceSend(z.num,1,v,'I'); delayMicroseconds(40);
if(z.chip==2) 			{deviceSend(z.num,2,v,'I'); delayMicroseconds(40);}}
//=================================================================================================
// 						Вспомогательные функции
//=================================================================================================
uint8_t getGenState (uint8_t num){if(!checkNum(num)){return 4;}  	else {return ptr[num]->genState;}};
bool    checkBusy   (uint8_t num){return ptr[num]->busy;}
bool    checkSetBusy(uint8_t num){if(ptr[num]->busy) {return 1;} ptr[num]->busy=1; return 0;}
void    setBusy     (uint8_t num){ptr[num]->busy=1;}
void    clearBusy   (uint8_t num){ptr[num]->busy=0; ptr[num]->cntWatchDogBusy=0;}

//=================================================================================================