//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									ИНИЦИАЛИЗАЦИЯ ШИН
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//							Инициализация шины по выбору её типа =z.mode
//=================================================================================================
uint8_t initBUS(RT_HW_HD44780_DEVICE_ID &z){
if(z.mode=='I')	{return initBUS_i2c(z);} //--i2c;
if(z.mode=='S')	{return initBUS_SPI(z);} //--SPI;
if(z.mode=='4')	{return initBUS_bus(z);} //--bus4;
if(z.mode=='8')	{return initBUS_bus(z);} //--bus8;
return 55;};
//=================================================================================================
//						Инициализация i2c ->adr,bus;
//=================================================================================================
uint8_t initBUS_i2c(RT_HW_HD44780_DEVICE_ID &z){
if(z.adr>=254) {return 60;}													//--Выход, если не допустимый адрес устройства i2c;
RT_HW_Base.i2cBegin(z.bus); 												//--Настройка   шины i2c как Master;
if(!RT_HW_Base.i2cGetBitState(RT_HW_I2C_STATE_MASTER,z.bus)) {return 61;}	//--Выход, если шина i2c не настроена; 
return 0;}	
//=================================================================================================
//						Инициализация SPI ->cs,bus
//=================================================================================================
uint8_t initBUS_SPI(RT_HW_HD44780_DEVICE_ID &z){
if(!RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID, z.cs))		 {return 52;}	//--Выход, если не допустимый номер пина cs устройства SPI;																
RT_HW_Base.spiBegin(z.bus);													//--Настройка SPI;
if(!RT_HW_Base.spiGetBitState(RT_HW_SPI_STATE_MASTER,z.bus)) {return 53;}	//--Выход, если шина SPI не настроена;	
RT_HW_Base.spiWriteCS(0,z.cs,z.bus);										//--Отправка 0 в SPI;
return 0;}
//=================================================================================================
//						Инициализация BUS4 или BUS8 ->RS,RW,E,D0-D8
//=================================================================================================
uint8_t initBUS_bus(RT_HW_HD44780_DEVICE_ID &z){
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<11; i++){RT_HW_Base.consoleVar(z.pin[i],' ','U');} RT_HW_Base.consoleCR();

if(RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[0])) {digitalWrite(z.pin[0],0); pinMode(z.pin[0],OUTPUT);} else{return (60);}	//--Выход, если недоступный пин RS;
if(RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[1])) {digitalWrite(z.pin[1],0); pinMode(z.pin[1],OUTPUT);}						//--Выход, если недоступный пин RW;
if(RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[2])) {digitalWrite(z.pin[2],0); pinMode(z.pin[2],OUTPUT);} else{return (62);}	//--Выход, если недоступный пин RS;
//-------------------------------------------------------------------------------------------------
if(z.mode=='4') {
for(uint8_t i=0; i<4; i++){												//--Перебор используемых пинов;
if(!RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[i+7])) {return (66+i);}	//--Выход, если недоступный пин; 
digitalWrite(z.pin[i+7],0); pinMode(z.pin[i+7],OUTPUT);}						//--Настройка пина на выход с установленным 0;
} 
else{
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<8; i++){												//--Перебор используемых пинов;
if(!RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[i+3])) {return (70+i);}	//--Выход, если недоступный пин; 
digitalWrite(z.pin[i+3],0); pinMode(z.pin[i+3],OUTPUT);}						//--Настройка пина на выход с установленным 0;
//-------------------------------------------------------------------------------------------------
}	
//-------------------------------------------------------------------------------------------------
return 0;};
//=================================================================================================	
