//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									ИНИЦИАЛИЗАЦИЯ ДИСПЛЕЯ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//==================================Lcd HD44780====================================================
//=================================================================================================	
//			Инициализация дисплея (4-х и 8-ми битные форматы)
//=================================================================================================	
bool initLcd(RT_HW_HD44780_DEVICE_ID &z){
//-------------------------------------------------------------------------------------------------
if(z.stepInit==0) {z.index=0; if(z.mode!='8'){z.stepInit=10;} else{z.stepInit=20;}}
//-------------------------------------------------------------------------------------------------	
if(z.stepInit==10){															//--4-x битная шина данных, Lcd для 1-го чипа; 
if(!deviceSend(z.num, 1,													//--Вывод в 1-й чип; 					
      pgm_read_byte(RT_HW_HD44780_INIT_BUS4+(z.index*3)),					//--Выводимое значение;
(char)pgm_read_byte(RT_HW_HD44780_INIT_BUS4+(z.index*3+1)),					//--Тип посылки(I-инструкция,D-данные,T-тетрада) 
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS4+(z.index*3+2))*100)) {return 0;}//--Время задержки;		
if(++z.index<=13) {return 0;} 												//--Последовательная передача 13 значений; 
if(z.chip==2){z.index=0; z.stepInit++; return 0;}							//--Продолжение, если LCD c двумя чипами;
else		 {z.index=0; z.stepInit=0; return 1;}} 							//--Выход для Lcd с 1-м чипом;
//-------------------------------------------------------------------------------------------------
if(z.stepInit==11){z.stepInit++;}
//-------------------------------------------------------------------------------------------------
if(z.stepInit==12){															//--4-x битная шина данных, Lcd для 2-го чипа; 
if(!deviceSend(z.num, 2,													//--Вывод во 2-й чип; 					
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS4+(z.index*3)),					//--Выводимое значение;
(char)pgm_read_byte(RT_HW_HD44780_INIT_BUS4+(z.index*3+1)),					//--Код ('I','D','T') 
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS4+(z.index*3+2))*100)) {return 0;}//--Время задержки;		
if(++z.index<=13)       {return 0;} 										//--Последовательная передача 13 значений;
z.index=0; z.stepInit=0; return 1;}											//--Выход для Lcd с 2-мя чипами;
//-------------------------------------------------------------------------------------------------
if(z.stepInit==20){															//--8-ми битная шина данных, Lcd для 1-го чипа; 
if(!deviceSend(z.num, 1,													//--Вывод в  1-й чип; 	
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS8+(z.index*3)),					//--Выводимое значение;
(char)pgm_read_byte(RT_HW_HD44780_INIT_BUS8+(z.index*3+1)),					//--Тип посылки(I-инструкция,D-данные,T-тетрада);
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS8+(z.index*3+2))*100)) {return 0;}//--Время задержки;	
if(++z.index<13){return 0;} 												//--Последовательная передача 13 значений; 	
if(z.chip==2){z.index=0; z.stepInit++; return 0;}							//--Продолжение, если LCD c двумя чипами;
else		 {z.index=0; z.stepInit=0; return 1;}} 							//--4-x битная шина данных, выход для Lcd с 2-мя чипами;
//-------------------------------------------------------------------------------------------------
if(z.stepInit==21){z.stepInit++;}
//-------------------------------------------------------------------------------------------------
if(z.stepInit==22){															//--8-ми битная шина данных, Lcd для 2-го чипа;
if(!deviceSend(z.num, 2,													//--Вывод во 2-й чип; 					
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS8+(z.index*3)),					//--Выводимое значение;
(char)pgm_read_byte(RT_HW_HD44780_INIT_BUS8+(z.index*3+1)),					//--Тип посылки(I-инструкция,D-данные,T-тетрада);
	  pgm_read_byte(RT_HW_HD44780_INIT_BUS8+(z.index*3+2))*100)) {return 0;}//--Время задержки;	
if(++z.index<=13)       {return 0;} 										//--Последовательная передача 13 значений;
z.index=0; z.stepInit=0; return 1;}											//--4-x битная шина данных, выход для Lcd с 2-мя чипами;	
//-------------------------------------------------------------------------------------------------	
return 0;};
//=================================================================================================
