//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Генератор переменных управления для запуска функций  вывода параметров в устройство
//  Вход: 1) id.periodOut,periodBlink - период обновления переменных и мерцания;	
//		  2) Gen,EN,Blink - внешний меандр 50 мс, разрешение вывода, разрешение мерцания; 
//  Выход 1) id.out (0/1) запуск вывода поля; 
//           id.clear запуск очистки поля; 
//           q.dir: =0 вывод запрещен; =1 -разрешен (первичный или периодический вывод); =2 -разрешена очистка;
// 		  2) id.fresh  -  вывод (при id.out=1). Дополнительно устанавливается внешней функцией. 
//                        Сбрасывается блоков вывода поля и при перезапуске.
//enum {RT_HW_HD44780_WRITE_FIRST=0,RT_RT_HW_HD44780_WRITE_FRESH,	RT_HW_HD44780_WRITE_GEN,  
//	  	RT_HW_HD44780_WRITE_DATA, 	RT_HW_HD44780_WRITE_CLEAR, 		RT_HW_HD44780_WRITE_OUTPUT,	RT_HW_HD44780_WRITE_FLICKER};   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool LcdGenerator(RT_HW_HD44780_PARAM_ID &id){	 
//-------------------------------------------------------------------------------------------------
id.lcdState=getGenState(id.num);
//-------------------------------------------------------------------------------------------------
//						Проверка на разрешение вывода от главного блока
//-------------------------------------------------------------------------------------------------
if(id.agoState!=id.lcdState){id.agoState=id.lcdState;
//-------------------------------------------------------------------------------------------------
//						Проверка на разрешение вывода от главного блока
//-------------------------------------------------------------------------------------------------
if(id.lcdState>=2){
id.first=1; id.output=id.clear=0;			//--Очистка флагов;
id.run=id.agoBool=id.flicker=0; 			//--Очистка флагов;
//RT_HW_Base.consoleVar(String(F("period->tick,Output,LimitLow,finishOutput->"))); RT_HW_Base.consoleVar((uint16_t)RT_HW_HD44780_PERIOD_TICK,',');
//RT_HW_Base.consoleVar(id.periodOutput,','); RT_HW_Base.consoleVar(id.periodLimitLow,','); 
  if(id.periodOutput<id.periodLimitLow){id.periodOutput=id.periodLimitLow;}	//--Ограничение периода вывода;
//if(id.mode=='T'){id.periodLimitLow=id.periodOutput;}
//RT_HW_Base.consoleVar(id.periodOutput,'E');
id.cntPeriodOutput=id.cntPeriodLimitLow=0;	//--Очистка счетчиков;
id.cntFunc=0;								//--Очистка счетчика;
id.agoEN=0;  id.extEN=1;					//--Флаги EN;
id.runOutput=id.fresh=1;					//--Установка флагов;								
id.vCursor=pointCursor(id.num,id.col,id.row); 
if(id.custom){id.dir=1;}					//--Блок вывода на начало;	
return 1;}
//-------------------------------------------------------------------------------------------------
//			Очистка параметров при отсутствии разрешения от главного блока
//-------------------------------------------------------------------------------------------------
if(!checkNum(id.num)){id.output=0; return 1;}	
//-------------------------------------------------------------------------------------------------
//			Подготовка параметров
//-------------------------------------------------------------------------------------------------
id.clear=0;																	//--Сброс флага очистки;
if(id.outStart){id.outStart=0; id.cntPeriodOutput=id.cntPeriodLimitLow=0;}	//--Сброс счетчика периода, если блоком запущен вывод;
//-------------------------------------------------------------------------------------------------
//			Вывод в первый раз (в т.ч. для режима 'F' (Однократный вывод);
//-------------------------------------------------------------------------------------------------
if(id.first) {if(!id.extEN){return 1;} id.first=0; 										id.fresh=id.output=1; return 0;}	//--Однократный вывод;
//-------------------------------------------------------------------------------------------------
//			Обработка блокирующих состояний	(управление по EN)
//-------------------------------------------------------------------------------------------------
if(id.agoEN!=id.extEN){id.agoEN=id.extEN; id.dirBlink=0;  id.runENon=0; id.runENoff=0; id.cntFunc=0; if(id.agoEN){id.runENon=1;} else{id.runENoff=1;}}
if(id.runENoff){id.runENoff=0; id.output=id.clear=1; return 0;}
if(id.runENon) {if(++id.cntFunc<3){return 1;}  else{id.runENon=0; id.cntFunc=0;      	id.fresh=id.output=1; return 0;}}
if(!id.agoEN){return 1;}
//-------------------------------------------------------------------------------------------------
//			Обработка режима мерцания
//--------------------------------------------------------------------------------------------------
if(id.agoBlink!=id.extBlink){id.agoBlink=id.extBlink; id.dirBlink=0; if(!id.agoBlink){	id.fresh=id.output=1; return 0;}} 
if(id.agoBlink){
if(id.dirBlink==0){id.output=id.fresh=1; 		 		id.dirBlink++;  return 0;}
if(id.dirBlink==1){if(++id.cntFunc<RT_HW_HD44780_PERIOD_BLINK_ON)  	   {return 1;} 
              else{id.output=id.clear=1; id.cntFunc=0; 	id.dirBlink++;  return 0;}}
if(id.dirBlink==2){if(++id.cntFunc<RT_HW_HD44780_PERIOD_BLINK_OFF)     {return 1;}
              else{						 id.cntFunc=0;  id.dirBlink=0;  return 1;}}}
//-------------------------------------------------------------------------------------------------
//			Вывод по изменениям с ограничением периода;
//-------------------------------------------------------------------------------------------------
if(id.modeOutput=='C'){if(++id.cntPeriodLimitLow>=id.periodLimitLow){id.cntPeriodLimitLow=0; 	 id.output=1; return 0;}}
//-------------------------------------------------------------------------------------------------
//			Вывод в режиме 'E' (вывод в каждом цикле)
//-------------------------------------------------------------------------------------------------
if(id.modeOutput=='E'){id.fresh=id.output=1; return 0;}	//--Вывод в каждом цикле;
//-------------------------------------------------------------------------------------------------
//			Вывод в режиме 'S' (Вывод по внешнему входу En(0->1);
//-------------------------------------------------------------------------------------------------
if(id.modeOutput=='S'){if(id.agoeN!=id.exteN){id.agoeN=id.exteN; if(id.agoeN){			id.fresh=id.output=1; return 0;}}}	//--Вывод по внешнему входу En(0->1);
//-------------------------------------------------------------------------------------------------
//			Вывод в режиме 'P' (периодический вывод)
//-------------------------------------------------------------------------------------------------
if(id.modeOutput=='P'){if(++id.cntPeriodOutput>=id.periodOutput){id.cntPeriodOutput=0;	id.fresh=id.output=1; return 0;}}	
//-------------------------------------------------------------------------------------------------
//			Вывод в режиме 'T' (периодический вывод)
//-------------------------------------------------------------------------------------------------
if(id.modeOutput=='T'){if(++id.cntPeriodOutput>=id.periodOutput){id.cntPeriodOutput=0;            id.output=1; return 0;}}	//--Периодический вывод, если подтвердится изменение переменной;	
//-------------------------------------------------------------------------------------------------
//			Вывод в режиме 'A' (периодический вывод)
//-------------------------------------------------------------------------------------------------
if(id.modeOutput=='A'){if(++id.cntPeriodOutput>=id.periodOutput)    {id.cntPeriodOutput=0;	id.fresh=id.output=1; return 0;}	//--Периодический безусловный вывод (если не было вывода по изменению);	
                       if(++id.cntPeriodLimitLow>=id.periodLimitLow){id.cntPeriodLimitLow=0; 		 id.output=1; return 0;}}	//--Периодический вывод, если подтвердится изменение переменной;	
//-------------------------------------------------------------------------------------------------
} 
return 1;};	
//=================================================================================================
