//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//						 [LIBRARY] RT_HW_BASE.h
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef   RT_HW_BASE_h
#define   RT_HW_BASE_h
//=================================================================================================
#define   RT_HW_BASE_VER 		 703							//--Library version number [digital];
#define   RT_HW_BASE_VER_NAME 	"7.0.3-14.08.2022"				//--Library version number [text];
//=================================================================================================
//				1., ,  PROGMEM [Macros,enum, arrays in PROGMEM]
//=================================================================================================
#include "BASE_001_Common define/COM_101_define.hpp"			//--Common macros;
#include "BASE_001_Common define/COM_102_enum.hpp"				//--Common enum;
#include "BASE_001_Common define/COM_103_array_PROGMEM.hpp"		//--Common arrays in PROGMEM;
//=================================================================================================
//				2.   [Data structures used]
//=================================================================================================
#include "BASE_002_Struct data/Struct_201_System.hpp"			//--System structures;
#include "BASE_002_Struct data/Struct_202_Sheduler.hpp"			//--Task manager structures;
#include "BASE_002_Struct data/Struct_203_Console.hpp"			//--Console structures;
#include "BASE_002_Struct data/Struct_204_Mess.hpp"				//--Console structures;
#include "BASE_002_Struct data/Struct_215_Counter.hpp"			//--Counter structures;
#include "BASE_002_Struct data/Struct_216_Generator.hpp"		//--Generator structures;
#include "BASE_002_Struct data/Struct_217_Other.hpp"			//--Other structures;
//=================================================================================================
//				3.   [Board selections macros]
//		[AVR,SAM,ESP8266,ESP32,ESP32x,STM32_M_F1,STM32_M_F4,STM32_D, SEEED]
//=================================================================================================
#include "BASE_003_Select board/Select_301_Board_AVR.hpp"		//--Select a board for the Core AVR;
#include "BASE_003_Select board/Select_302_Board_SAM.hpp"		//--Select a board for the ore SAM;
#include "BASE_003_Select board/Select_311_Board_ESP8266.hpp"	//--Select a board for the ore ESP8266;
#include "BASE_003_Select board/Select_312_Board_ESP32S.hpp"	//--Select a board for the ore ESP32;
#include "BASE_003_Select board/Select_315_Board_ESP32C3.hpp"	//--Select a board for the ore ESP32C3;
#include "BASE_003_Select board/Select_316_Board_ESP32_M5.hpp"	//--Select a board for the ore ESP32_M5Stack;
#include "BASE_003_Select board/Select_317_Board_ESP32_STAMP.hpp"//--Select a board for the ore ESP32 STAMP;
#include "BASE_003_Select board/Select_321_Board_STM32_M_F1.hpp"//--Select a board for the ore STM32master STM32F1;
#include "BASE_003_Select board/Select_322_Board_STM32_M_F4.hpp"//--Select a board for the ore STM32master STM32F4;
#include "BASE_003_Select board/Select_331_Board_STM32_D_F1.hpp"//--Select a board for the ore STM32duino  STM32F1;
#include "BASE_003_Select board/Select_332_Board_STM32_D_F4.hpp"//--Select a board for the ore STM32duino  STM32F4;
#include "BASE_003_Select board/Select_333_Board_STM32_D_H7.hpp"//--Select a board for the ore STM32duino  STM32H7;
#include "BASE_003_Select board/Select_351_Board_SEEED.hpp"		//--Select a board for the ore Seeeduino(SAMD21);
#include "BASE_003_Select board/Select_371_Board_PI_PICO.hpp"	//--Select a board for the ore Raspberry Pi Pico;
//-------------------------------------------------------------------------------------------------
#include "BASE_003_Select board/Select_390_Board_ANON.hpp"		//--Select a board for the ore ANON;
//=================================================================================================
//				4.  [descriptions Core] 
//		[AVR,SAM,ESP8266,ESP32,ESP32x,STM32_M_F1,STM32_M_F4,STM32_D, SEEED, ANON]
//=================================================================================================
#include "BASE_004_Core descriptions/CORE_401_AVR.hpp"			//--Description of the Core AVR;
#include "BASE_004_Core descriptions/CORE_402_SAM.hpp"			//--Description of the Core SAM;
#include "BASE_004_Core descriptions/CORE_411_ESP8266.hpp"		//--Description of the Core ESP8266;
#include "BASE_004_Core descriptions/CORE_412_ESP32.hpp"		//--Description of the Core ESP32;
#include "BASE_004_Core descriptions/CORE_421_STM32_M_F1.hpp"	//--Description of the Core STM32_M_F1;
#include "BASE_004_Core descriptions/CORE_422_STM32_M_F4.hpp"	//--Description of the Core STM32_M_F4;
#include "BASE_004_Core descriptions/CORE_431_STM32_D.hpp"		//--Description of the Core STM32_D;
#include "BASE_004_Core descriptions/CORE_451_SEEED.hpp"		//--Description of the Core Seeed (SAMD21);
#include "BASE_004_Core descriptions/CORE_471_PI_PICO.hpp"		//--Description of the Core Raspberry Pi Pico;
//-------------------------------------------------------------------------------------------------
#include "BASE_004_Core descriptions/CORE_490_ANON.hpp"			//--  Core ANON;
//-------------------------------------------------------------------------------------------------
#include "BASE_004_Core descriptions/CORE_499_ADD_DEFINE.hpp"	//--   CORE;

//=================================================================================================
//				5.    [descriptions Board]
//		[AVR,SAM,ESP8266,ESP32,ESP32x,STM32_M_F1,STM32_M_F4,STM32_D, SEEED, ANON]
//=================================================================================================
#include  "BASE_005_Board descriptions/Board_501_AVR.hpp"	    	//--Description of the board AVR;
#include  "BASE_005_Board descriptions/Board_502_SAM.hpp"			//--Description of the board SAM;
#include  "BASE_005_Board descriptions/Board_511_ESP8266.hpp"		//--Description of the board ESP8266;
#include  "BASE_005_Board descriptions/Board_512_ESP32S.hpp"		//--Description of the board ESP32;
#include  "BASE_005_Board descriptions/Board_515_ESP32C3.hpp"		//--Description of the board ESP32_C3;
#include  "BASE_005_Board descriptions/Board_516_ESP32_M5.hpp"		//--Description of the board ESP32_M5Stack;
#include  "BASE_005_Board descriptions/Board_517_ESP32_STAMP.hpp"	//--Description of the board ESP32-STAMP;
#include  "BASE_005_Board descriptions/Board_521_STM32_M_F1.hpp"	//--Description of the board STM32_M_F1;
#include  "BASE_005_Board descriptions/Board_522_STM32_M_F4.hpp"	//--Description of the board STM32_M_F4x7;
#include  "BASE_005_Board descriptions/Board_531_STM32_D_F1.hpp"	//--Description of the board STM32_D_F4x1;
#include  "BASE_005_Board descriptions/Board_532_STM32_D_F4x1.hpp"	//Description of the board STM32_D_F4x1;
#include  "BASE_005_Board descriptions/Board_533_STM32_D_F4x7.hpp"	//Description of the board STM32F4x1;
#include  "BASE_005_Board descriptions/Board_534_STM32_D_H7.hpp"	//--Description of the board STM32H7;
#include  "BASE_005_Board descriptions/Board_551_SEEED.hpp"			//--Description of the board Seeeduino;
#include  "BASE_005_Board descriptions/Board_571_PI_PICO.hpp"		//--Description of the board Raspberry Pi Pico;
//-------------------------------------------------------------------------------------------------
#include  "BASE_005_Board descriptions/Board_590_ANON.hpp"			//--Description of the board ANON (always last  of the list);
//=================================================================================================
//				6.   core STM32master[Defined pins for core STM32master]
//=================================================================================================
#include "BASE_007_For STM32master defined pins/RT_HW_BASE_701_STM32master_PIN.hpp" //For STM32master_defined pins	
//=================================================================================================
//						7.  (  Core  Board)
//=================================================================================================
#include "BASE_002_Struct data/Struct_220_Link.hpp"				//--Communication interface structures;
#include "BASE_002_Struct data/Struct_230_Sensor.hpp"			//--Sensor structures;
#include "BASE_002_Struct data/Struct_235_Extenders.hpp"		//--Extender structures;
#include "BASE_002_Struct data/Struct_240_FLProg.hpp"			//--FLProg structures;

//=================================================================================================
//									 RT_HW_BASE.h
//=================================================================================================
class RT_HW_BASE{
public:
//-------------------------------------------------------------------------------------------------
RT_HW_STRUCT_BUFF		buff;				//-- ;
RT_HW_STRUCT_SHED		shed;				//-- ;
RT_HW_STRUCT_DEVICE 	device;				//--  ;
RT_HW_STRUCT_CONSOLE	console;			//-- ;
RT_HW_STRUCT_MESS		mess;				//--   ;
//-------------------------------------------------------------------------------------------------
String strTest="1";
//-------------------------------------API  ( .cpp)-----------------------------------
#include "BASE_010_API System.h/API_010_SystemFuncMain_h.hpp"			//--API   ;
#include "BASE_010_API System.h/API_011_SystemFuncArrayPGM_h.hpp"		//--API       PROGMEM;
#include "BASE_010_API System.h/API_012_SystemFuncString_h.hpp"			//--API     ;
#include "BASE_010_API System.h/API_013_SystemFuncVarToString_h.hpp"	//--API      ( );
#include "BASE_010_API System.h/API_014_SystemFuncVarToMess_h.hpp"		//--API      ;
#include "BASE_010_API System.h/API_015_SystemFuncNamePinSTM32_h.hpp"	//--API        STM32;
#include "BASE_010_API System.h/API_016_SystemFuncChangeVar_h.hpp"		//--API   ;
#include "BASE_010_API System.h/API_017_SystemFuncCounter_h.hpp"		//--API ;
#include "BASE_010_API System.h/API_018_SystemFuncGenerator_h.hpp"		//--API ;
#include "BASE_010_API System.h/API_019_SystemFuncCRC_h.hpp"			//--API     ;
#include "BASE_010_API System.h/API_020_SystemFuncLimitVar_h.hpp"		//--API     mode[L,A,N];
#include "BASE_020_API Pins.h/API_020_PinsInput_h.hpp"					//--API for input pins;;
#include "BASE_020_API Pins.h/API_021_PinsOutput_h.hpp"					//--API_for output pins;
#include "BASE_030_API Time.h/API_030_TimeFuncGeneral_h.hpp"			//--API for time;
#include "BASE_030_API Time.h/API_031_TimeFuncSheduler_h.hpp"			//--API_sheduler;
#include "BASE_030_API Time.h/API_032_TimeFuncFLProg_h.hpp"				//--API_for program FLProg;
#include "BASE_030_API Time.h/API_033_TimeFuncAdd_h.hpp"				//--API_for time add;
#include "BASE_050_API Console.h/API_051_ConsoleBaseFunc_h.hpp"			//--API base functions console main; 
#include "BASE_050_API Console.h/API_052_ConsoleHeadFunc_h.hpp"			//--API base functions console for output head;
//-------------------------------------API  xxx.cpp------------------------------------------
#include "BASE_100_API Link.h for Link.cpp/API_101_UART_H.hpp"			//--API UART;
#include "BASE_100_API Link.h for Link.cpp/API_103_I2C_H.hpp"			//--API i2c;
#include "BASE_100_API Link.h for Link.cpp/API_105_SPI_H.hpp"			//--API SPI;
#include "BASE_100_API Link.h for Link.cpp/API_107_SSPI_H.hpp"			//--API SSPI;
#include "BASE_100_API Link.h for Link.cpp/API_109_OneWire_H.hpp"		//--API OneWire;
//-------------------------------------API sensors ( .cpp)--------------------------------------
#include "BASE_200_API Sensor.h/API_200_DHT22.hpp"						//--API sensor DHT22;
#include "BASE_200_API Sensor.h/API_201_DS1820.hpp"						//--API sensor DS1820;
#include "BASE_200_API Sensor.h/API_202_HC_SR04.hpp"					//--API sensor HC-SR04;
#include "BASE_200_API Sensor.h/API_203_HTU21.hpp"						//--API sensor HTU21;
#include "BASE_200_API Sensor.h/API_204_MAX6675.hpp"					//--API sensor MAX6675;
#include "BASE_200_API Sensor.h/API_205_AHT20.hpp"						//--API sensor AHT20;
#include "BASE_200_API Sensor.h/API_206_BH1750.hpp"						//--API sensor BH1750;
#include "BASE_200_API Sensor.h/API_210_BMP180.hpp"						//--API sensor BMP180;
#include "BASE_200_API Sensor.h/API_211_BME280.hpp"						//--API sensor BME280;
#include "BASE_200_API Sensor.h/API_212_SHT31.hpp"						//--API sensor SHT31;
//-------------------------------------API extenders ( .cpp)------------------------------------
#include "BASE_210_API Extenders.h/API_202_MCP23X17.hpp"				//--API extender MCP4725;
#include "BASE_210_API Extenders.h/API_210_MCP4725.hpp"					//--API extender MCP4725 (DAC);
//-------------------------------------------------------------------------------------------------
RT_HW_BASE();								//--;
private:
};  //---END 
//=================================================================================================
extern RT_HW_BASE 	RT_HW_Base; 										//--  RT_HW_Base;
//=================================================================================================


//=================================================================================================
//									 RT_HW_FILTER.h
//=================================================================================================
#include "BASE_300_API Filters.h/API_010_filterFuncMedian3.hpp"		//--API  median 3- ;
#include "BASE_300_API Filters.h/API_011_filterFuncMedian.hpp"		//--API  median N- ;
#include "BASE_300_API Filters.h/API_012_filterFuncRingAverage.hpp"	//--API      ;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#endif //---RT_HW_BASE_h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++