#include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									КОНСТРУКТОР
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_BASE:: RT_HW_BASE(){
//uint8_t buff;
//=================================================================================================
//								0.Создание объектов
//=================================================================================================
//#include "BASE_010_API System.h/API_100_SystemObjectCreationLink.hpp"	//--API создание объектов интерфейсов;
//=================================================================================================
//							1.Настройка общих параметров
//=================================================================================================
device.board.codeArch= RT_HW_ARCH_CODE;		//--Код архитектуры контроллера;
device.board.codeBoard=RT_HW_BOARD_CODE;	//--Код контроллера;
//=================================================================================================
//							2.Настройка диспетчера задач
//=================================================================================================
shed.cnt50=shed.cnt100=shed.cnt250=shed.gen250=0;
shed.quick.cnt=shed.fast.cnt=shed.slow.cnt=shed.back.cnt=shed.frdm.cnt=0;
shed.quick.qnt=5; 							//--Кол-во срочных   задач (период  10мс);
shed.fast.qnt=4;							//--Кол-во быстрых   задач (период  25мс);
shed.slow.qnt=4; 							//--Кол-во медленных задач (период 250мс);
shed.back.qnt=5;   							//--Кол-во фоновых   задач (период 100мс);
shed.frdm.qnt=25; 							//--Кол-во свободных задач (период loop()-когда нет вызванных задач);
shed.periodQuick=10;						//--Период оперативных задач в mc;
shed.periodBase=25;							//--Период оперативных задач в mc;
shed.run=0;									//--Флаги разрешения запусков задач(quick,fast,slow,back,frdm);
//=================================================================================================
//							3.Настройка устройств ввода/вывода
//=================================================================================================
//-------------------------------------------------------------------------------------------------
//			3.1.Настройка рабочих регистров
//-------------------------------------------------------------------------------------------------
device.depth.sys	 = readArrPGM(RT_HW_PGM_SYS_PAR_ID, 0);	//--Cистемное разрешение (8,10,12,16); 
device.depth.adc	 = readArrPGM(RT_HW_PGM_SYS_ADC_ID, 0); //--Разрешение ADC;
device.depth.drift	 = readArrPGM(RT_HW_PGM_SYS_ADC_ID,	1); //--Допустимый дрейф показаний ADC;
device.depth.vNull	 = readArrPGM(RT_HW_PGM_SYS_ADC_ID, 2); //--Допустимый дрейф нуля ADC;
device.depth.tch	 = readArrPGM(RT_HW_PGM_SYS_TCH_ID, 0);	//--Разрешение TCH (ESP32);
device.depth.pwm	 = readArrPGM(RT_HW_PGM_SYS_PWM_ID, 0);	//--Разрешение PWM; 
device.depth.dac	 = readArrPGM(RT_HW_PGM_SYS_DAC_ID, 0); //--Разрешение DAC;	
//-------------------------------------------------------------------------------------------------
//			3.2.Настройка рабочих регистров для работы с пинами
//-------------------------------------------------------------------------------------------------
device.pin.control	 = readArrPGM(RT_HW_PGM_PIN_BRD_ID, 0);	//--Пин контрольного светодиода; 
device.pin.led	 	 = readArrPGM(RT_HW_PGM_PIN_BRD_ID, 1);	//--Пин светодиода на плате;
device.pin.button	 = readArrPGM(RT_HW_PGM_PIN_BRD_ID, 2);	//--Пин кнопки на плате; 	 
device.pin.ws	     = readArrPGM(RT_HW_PGM_PIN_BRD_ID, 3);	//--Пин светодиода WS2812 на плате; 
//-------------------------------------------------------------------------------------------------
//  		3.2. ????? Настройка длины поля при выводе пинов 
//-------------------------------------------------------------------------------------------------
mess.lenPin=2;
#if   defined(RT_HW_CORE_STM32)
mess.lenPin=4;
#endif
#if   defined(RT_HW_CORE_ESP8266)
mess.lenPin=3;
#endif	
//-------------------------------------------------------------------------------------------------
//			3.3.Настройка разрядности ADC
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BLOCK_SET_RESOLUTION_ADC) 
	analogReadResolution(device.depth.adc); 
#endif 
//-------------------------------------------------------------------------------------------------
//			3.4.Настройка разрядности PWM
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BLOCK_SET_RESOLUTION_PWM)
	analogWriteResolution(device.depth.pwm); 
#endif  
//-------------------------------------------------------------------------------------------------
//			3.5.Разрешение использование выводов JTDI,JTDO,JRST(PA15,PB3,PB4) для STM32F1-103C
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_ENABLE_PIN_JTAG)	
	afio_cfg_debug_ports(AFIO_DEBUG_SW_ONLY);	
#endif
//-------------------------------------------------------------------------------------------------
//			3.6.M5Stack-Core-ESP32:: Настройка DAC чтобы избежать звуков зуммера при включении
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BOARD_M5Stack_Core_ESP32) 
dacWrite(25,0);		//--Чтобы избежать звуков зуммера при включении;
#endif 
 //=================================================================================================
//								4.Настройка UART
//=================================================================================================
//-------------------------------------------------------------------------------------------------
//			4.0. Настройка UART0 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART0)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,0),0);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,1),0);
#endif
//-------------------------------------------------------------------------------------------------
//			4.1. Настройка UART1 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART1)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,2),1);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,3),1);
#endif
//-------------------------------------------------------------------------------------------------
//			4.2. Настройка UART2 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART2)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,4),2);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,5),2);
#endif
//-------------------------------------------------------------------------------------------------
//			4.3. Настройка UART3 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART3)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,6),3);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,7),3);
#endif
//-------------------------------------------------------------------------------------------------
//			4.1. Настройка UART4 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART4)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,8),4);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,9),4);
#endif
//-------------------------------------------------------------------------------------------------
//			4.2. Настройка UART5 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART5)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,10),5);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,11),5);
#endif
//-------------------------------------------------------------------------------------------------
//			4.3. Настройка UART6 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART6)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,12),6);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,13),6);
#endif
//-------------------------------------------------------------------------------------------------
//			4.1. Настройка UART7 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART7)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,14),7);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,15),7);
#endif
//-------------------------------------------------------------------------------------------------
//			4.2. Настройка UART8 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UART8)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,16),8);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_UHS_ID,17),8);
#endif
//-------------------------------------------------------------------------------------------------
//			4.3. Настройка UARTS (программная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_UARTS)
uartSetPinRX(readArrPGM(RT_HW_PGM_PIN_USS_ID,0),9);
uartSetPinTX(readArrPGM(RT_HW_PGM_PIN_USS_ID,1),9);
#endif

//=================================================================================================
//								4.Настройка i2c
//=================================================================================================
//-------------------------------------------------------------------------------------------------
//			4.1. Настройка i2c bus0 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)								
i2cSetState(0,0);									//--bus==0: очистка state,hardware(bit.4);
i2cSetAdr(0,0);										//--bus==0: очистка adr;
i2cSetPinSDA(readArrPGM(RT_HW_PGM_PIN_I2C_ID,0),0);	//--bus==0: установка пина SDA; 
i2cSetPinSCL(readArrPGM(RT_HW_PGM_PIN_I2C_ID,1),0);	//--bus==0: установка пина SCL;
i2cSetSpeed(RT_HW_I2C_SPEED_DEFAULT * 1000UL,   0);	//--bus==0: установка частоты по умолчанию; 
i2cWriteBitState(RT_HW_I2C_BLOCK_USER_PINS,RT_HW_I2C_STATE_BLOCK_PINS,0);	//--Установка флага блок.измен.пинов;
#endif
//-------------------------------------------------------------------------------------------------
//			4.2. Настройка i2c bus1 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)
i2cSetState(0,1);									//--bus==1: очистка state,hardware(bit.4);
i2cSetAdr(0,1);										//--bus==1: очистка adr; 
i2cSetPinSDA(readArrPGM(RT_HW_PGM_PIN_I2C_ID,2),1);	//--bus==1: установка пина SDA; 
i2cSetPinSCL(readArrPGM(RT_HW_PGM_PIN_I2C_ID,3),1);	//--bus==1: установка пина SCL; 
i2cSetSpeed(RT_HW_I2C_SPEED_DEFAULT * 1000UL,   1);	//--bus==1: установка частоты по умолчанию;  
i2cWriteBitState(RT_HW_I2C_BLOCK_USER_PINS, RT_HW_I2C_STATE_BLOCK_PINS,1); //--Установка флага блок.измен.пинов;
#endif
//-------------------------------------------------------------------------------------------------
//			4.3. Настройка i2c bus2 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)
i2cSetState(0,2);									//--bus==2: очистка state,hardware(bit.4);
i2cSetAdr(0,2);										//--bus==2: очистка adr;
i2cSetPinSDA(readArrPGM(RT_HW_PGM_PIN_I2C_ID,4),2);	//--bus==2: установка пина SDA;
i2cSetPinSCL(readArrPGM(RT_HW_PGM_PIN_I2C_ID,5),2);	//--bus==2: установка пина SCL; 
i2cSetSpeed(RT_HW_I2C_SPEED_DEFAULT * 1000UL,   2);	//--bus==2: установка частоты по умолчанию;  	
i2cWriteBitState(RT_HW_I2C_BLOCK_USER_PINS, RT_HW_I2C_STATE_BLOCK_PINS,2); //--Установка флага блок.измен.пинов;
#endif
//-------------------------------------------------------------------------------------------------
//			4.2. Настройка i2c bus1 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
i2cSetState(0,0);									//--bus==8: очистка state,hardware(bit.4);
i2cSetAdr(0,0);										//--bus==8: очистка adr; 
i2cSetPinSDA(RT_HW_I2CS_SDA,0);						//--bus==8: установка пина SDA; 
i2cSetPinSCL(RT_HW_I2CS_SCL,0);					//--bus==8: установка пина SCL; 
i2cSetSpeed(RT_HW_I2C_SPEED_DEFAULT * 1000UL,0);	//--bus==8: установка частоты по умолчанию;  
i2cWriteBitState(RT_HW_I2C_BLOCK_USER_PINS, RT_HW_I2C_STATE_BLOCK_PINS,0); //--Установка флага блок.измен.пинов;
#endif
//-------------------------------------------------------------------------------------------------
//			4.3. Настройка i2c bus2 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS1)
i2cSetState(0,1);									//--bus==9: очистка state,hardware(bit.4);
i2cSetAdr(0,1);										//--bus==9: очистка adr;
i2cSetPinSDA(RT_HW_I2CS1_SDA,1);					//--bus==9: установка пина SDA;
i2cSetPinSCL(RT_HW_I2CS1_SCL,1);					//--bus==9: установка пина SCL; 
i2cSetSpeed(RT_HW_I2C_SPEED_DEFAULT * 1000UL,   1);	//--bus==9: установка частоты по умолчанию;  	
i2cWriteBitState(RT_HW_I2C_BLOCK_USER_PINS, RT_HW_I2C_STATE_BLOCK_PINS,1); //--Установка флага блок.измен.пинов;
#endif


//=================================================================================================
//								5.Настройка SPI
//=================================================================================================
//-------------------------------------------------------------------------------------------------
//			5.1. Настройка SPI bus=0 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI0)								
spiBeginFirst(0);		
#endif
//-------------------------------------------------------------------------------------------------
//			5.2. Настройка SPI1 bus=1 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1)								
spiBeginFirst(1);
#endif
//-------------------------------------------------------------------------------------------------
//			5.3. Настройка SPI2 bus=2 (аппаратная шина)
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2)								
spiBeginFirst(2);
#endif
//-------------------------------------------------------------------------------------------------
//			5.4. Настройка SSPI bus=9 (программная шина)
//-------------------------------------------------------------------------------------------------
//#if defined(RT_HW_PERMIT_SPN0)								
//spiBeginFirst(9);
//#endif
//-------------------------------------------------------------------------------------------------
//			5.5. Настройка SPN1 bus=8 (программная шина)
//-------------------------------------------------------------------------------------------------
//#if defined(RT_HW_PERMIT_SPN1)								
//spiBeginFirst(8);										//--bus==2: проверка доступности пинов sck,miso,mosi;
#//endif

//=================================================================================================
};	//--End RT_HW_BASE()	
//-------------------------------------------------------------------------------------------------		
RT_HW_BASE RT_HW_Base;									//==Создание внешнего объекта	
//=================================================================================================
