#include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							2.СОЗДАНИЕ ДОПОЛНИТЕЛЬНЫХ ОБЪЕКТОВ SPI ПОД ТИП MCU
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_ESP8266)		//--1.1.2.Объект для i2c1 & CORE ESP8266 	
#if !defined(NO_GLOBAL_INSTANCES) && !defined(NO_GLOBAL_TWOWIRE)
#define RT_HW_CREATED_WIRE1
TwoWire Wire1;
#endif
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_ESP32) 		//--1.1.3.Объект для i2c1 & CORE ESP32	
//#define RT_HW_CREATED_WIRE1
//TwoWire Wire1;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_STM32_M)		//--1.1.4.Объект для i2c1 & CORE STM32-M 	
#define RT_HW_CREATED_WIRE1
TwoWire Wire1(2,I2C_FAST_MODE);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_STM32_D)		//--1.1.5.Объект для i2c1 & CORE STM32-D
#define RT_HW_CREATED_WIRE1
TwoWire Wire1(RT_HW_I2C1_SDA, RT_HW_I2C1_SCL);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)  && defined(RT_HW_CORE_STM32_M)		//--1.2.2.Объект для i2c2 & CORE STM32-M  	
#define RT_HW_CREATED_WIRE2
TwoWire Wire2(2,I2C_FAST_MODE);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)  && defined(RT_HW_CORE_STM32_D)		//--1.2.3.Объект для i2c2 & CORE STM32-D 
#define RT_HW_CREATED_WIRE2
TwoWire Wire2(RT_HW_I2C2_SDA, RT_HW_I2C2_SCL);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS)  && defined(RT_HW_CORE_STM32_M)		//--1.8.2.Объект для i2cS & CORE STM32-M 
#define RT_HW_CREATED_WIRES
SoftWire WireS(RT_HW_I2CS_SCL, RT_HW_I2CS_SDA, 19);		//--Объект WireS;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS1) && defined(RT_HW_CORE_STM32_M)		//--1.9.2.Объект для i2cS1& CORE STM32-M 
SoftWire WireS1(RT_HW_I2CS1_SCL, RT_HW_I2CS1_SDA, 19);	//--Объект WireS1;
#endif

//=================================================================================================
// 				2.Функции проверки номера шины, адреса, управления регистром состояния                    
//=================================================================================================
bool    RT_HW_BASE:: i2cCheckBus     (uint8_t bus){								//--2.2.Проверка шины
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return 1;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return 1;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return 1;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0)  {return 1;}
#endif	
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {return 1;}
#endif
return 0;};

uint8_t	RT_HW_BASE:: i2cInitMaster   (uint8_t bus){								//--2.3.Настройка шины как Master
if( !i2cCheckBus(bus))							 {return 70;} 	//--Выход,   если недопустимый номер щины; 
if((!i2cGetBitState(RT_HW_I2C_STATE_INIT,bus))&&(!i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus))){i2cBegin(bus);} //--Настройка шины как Master;
if( !i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus)) {return 71;}	//--Выход, если шина  уже настроен как Master;
return 0;}														//--Успешный выход;
void    RT_HW_BASE:: i2cSetBitState  (        uint8_t bitState, uint8_t bus){	//--2.4.Установка  бита состояния
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {bitSet(LinkI2C0.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {bitSet(LinkI2C1.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {bitSet(LinkI2C2.state,bitState);}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {bitSet(LinkI2CS.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1){bitSet(LinkI2CS1.state,bitState);}
#endif
};

void    RT_HW_BASE:: i2cClearBitState(        uint8_t bitState, uint8_t bus){	//--2.5.Очистка    бита состояния
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {bitClear(LinkI2C0.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {bitClear(LinkI2C1.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {bitClear(LinkI2C2.state,bitState);}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {bitClear(LinkI2CS.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {bitClear(LinkI2CS1.state,bitState);}
#endif
};

void 	RT_HW_BASE:: i2cWriteBitState(bool v, uint8_t bitState, uint8_t bus){	//--2.6.Запись     бита состояния
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {bitWrite(LinkI2C0.state,bitState,v);}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {bitWrite(LinkI2C1.state,bitState,v);}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {bitWrite(LinkI2C2.state,bitState,v);}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {bitWrite(LinkI2CS.state,bitState,v);}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {bitWrite(LinkI2CS1.state,bitState,v);}
#endif
};

bool 	RT_HW_BASE:: i2cGetBitState  (        uint8_t bitState, uint8_t bus){	//--2.7.Чтение     бита состояния
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return bitRead(LinkI2C0.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return bitRead(LinkI2C1.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return bitRead(LinkI2C2.state,bitState);}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return bitRead(LinkI2CS.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {return bitRead(LinkI2CS1.state,bitState);}
#endif
return 0;};

void 	RT_HW_BASE:: i2cSetState     (uint8_t val,              uint8_t bus){	//--2.8.Запись регистра состояния 
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.state=val;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.state=val;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.state=val;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {LinkI2CS.state=val;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {LinkI2CS1.state=val;}
#endif
};

void 	RT_HW_BASE:: i2cSetStatus    (uint8_t val,              uint8_t bus){	//--2.9.Запись статуса
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.status=val;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.status=val;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.status=val;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {LinkI2CS.status=val;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {LinkI2CS1.status=val;}
#endif
};

void 	RT_HW_BASE:: i2cSetCodeErr   (uint8_t val,              uint8_t bus){	//--2.10.Запись кода ошибки;
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.codeErr=val;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.codeErr=val;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.codeErr=val;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {LinkI2CS.codeErr=val;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {LinkI2CS1.codeErr=val;}
#endif
};

uint8_t RT_HW_BASE:: i2cGetState  	 (							uint8_t bus){	//--2.11.Чтение регистра состояния
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.state;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.state;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.state;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.state;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {return LinkI2CS1.state;}
#endif
return 0;};

uint8_t RT_HW_BASE:: i2cGetStatus  	 (							uint8_t bus){	//--2.12.Чтение регистра состояния
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.status;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.status;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.status;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.status;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {return LinkI2CS1.status;}
#endif
return 0;};

uint8_t RT_HW_BASE:: i2cGetCodeErr   (							uint8_t bus){	//--2.13.Чтение кода ошибки;
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.codeErr;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.codeErr;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.status;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.status;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {return LinkI2CS1.status;}
#endif
return 0;};
//=================================================================================================
// 							3.1.Запись SCL
//=================================================================================================
void     RT_HW_BASE:: i2cSetPinSCL(uint8_t scl,    				uint8_t bus){	//--3.1.Запись номера пина SCL
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.scl=scl;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.scl=scl;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.scl=scl;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {LinkI2CS.scl=scl;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {LinkI2CS1.scl=scl;}
#endif
};
//=================================================================================================
// 							3.2.Запись SDA
//=================================================================================================
void     RT_HW_BASE:: i2cSetPinSDA(uint8_t sda,    				uint8_t bus){	//--3.2.Запись номера пина SDA
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.sda=sda;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.sda=sda;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.sda=sda;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {LinkI2CS.sda=sda;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {LinkI2CS1.sda=sda;}
#endif
};
//=================================================================================================
// 							3.3.Чтение SCL
//=================================================================================================
uint8_t  RT_HW_BASE:: i2cGetPinSCL(                				uint8_t bus){	//--3.3.Чтение номера пина SCL
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.scl;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.scl;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.scl;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.scl;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1){return LinkI2CS1.scl;}
#endif
return 0;};
//=================================================================================================
// 							3.3.Чтение SDA
//=================================================================================================
uint8_t  RT_HW_BASE:: i2cGetPinSDA(                				uint8_t bus){	//--3.4.Чтение номера пина SDA
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.sda;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.sda;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.sda;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.sda;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {return LinkI2CS1.sda;}
#endif
return 0;};
//=================================================================================================
// 							3.4.Установка addrr
//=================================================================================================
void     RT_HW_BASE:: i2cSetAdr   (uint8_t adr,    				uint8_t bus){	//--3.5.Запись Slave-адреса(=0:Master; >0:Slave)
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.adr=adr;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.adr=adr;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.adr=adr;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {LinkI2CS.adr=adr;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1) {LinkI2CS1.adr=adr;}
#endif
};
//=================================================================================================
// 							3.4.Чтение addrr
//=================================================================================================
uint8_t  RT_HW_BASE:: i2cGetAdr	  (				   				uint8_t bus){	//--3.6.Чтение Slave-адреса(=0:Master; >0:Slave)
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.adr;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.adr;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.adr;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.adr;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1){return LinkI2CS1.adr;}
#endif
return 0;};
//=================================================================================================
// 							3.5.Установка скорости
//=================================================================================================
void     RT_HW_BASE:: i2cSetSpeed (uint32_t speed, 				uint8_t bus){ 	//--3.7.Запись скорости(кГц)
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {LinkI2C0.speed=speed;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {LinkI2C1.speed=speed;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {LinkI2C2.speed=speed;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2C2S)	
if(bus==0) {LinkI2CS.speed=speed;}
#endif
#if defined(RT_HW_PERMIT_I2C2S1)	
if(bus==1) {LinkI2CS1.speed=speed;}
#endif
};
//=================================================================================================
// 							3.6.Чтение скорости
//=================================================================================================
uint32_t RT_HW_BASE:: i2cGetSpeed (				   				uint8_t bus){	//--3.8.Чтение скорости(кГц)
#if defined(RT_HW_PERMIT_I2C0)	
if(bus==0) {return LinkI2C0.speed;}
#endif
#if defined(RT_HW_PERMIT_I2C1)	
if(bus==1) {return LinkI2C1.speed;}
#endif
#if defined(RT_HW_PERMIT_I2C2)	
if(bus==2) {return LinkI2C2.speed;}
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)	
if(bus==0) {return LinkI2CS.speed;}
#endif
#if defined(RT_HW_PERMIT_I2CS1)	
if(bus==1){return LinkI2CS1.speed;}
#endif
return 0;};
//=================================================================================================
// 							3.6.Установка скорости
//=================================================================================================
void     RT_HW_BASE:: i2cSetClock (                				uint8_t bus){	//--3.9.Установка скорости (значение из регистра)
#if defined(RT_HW_PERMIT_I2C0) 
if(bus==0){Wire.setClock(i2cGetSpeed(bus));}
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){Wire1.setClock(i2cGetSpeed(bus));};
#endif
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){Wire2.setClock(i2cGetSpeed(bus));};
#endif	
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){WireS.setClock(i2cGetSpeed(bus));};
#endif
#if defined(RT_HW_PERMIT_I2CS)
if(bus==1){WireS1.setClock(i2cGetSpeed(bus));};
#endif
};
//=================================================================================================
// 							3.7.Установка скорости
//=================================================================================================
void     RT_HW_BASE:: i2cSetClockNew (uint32_t speed,          uint8_t bus){	//--3.9.Установка скорости (значение из регистра)
#if defined(RT_HW_PERMIT_I2C0) 
if(bus==0){Wire.setClock(speed);}
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){Wire1.setClock(speed);};
#endif
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){Wire2.setClock(speed);}
#endif	
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){WireS.setClock(speed);}
#endif	
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){WireS1.setClock(speed);}
#endif	
};
//=================================================================================================
//										5.Функции обмена
//=================================================================================================
void    RT_HW_BASE:: i2cBeginTransmission(uint8_t adr,uint8_t bus){
if(!i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus)) {return;};
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){Wire.beginTransmission(adr);  return;};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){Wire1.beginTransmission(adr); return;};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){Wire2.beginTransmission(adr); return;};
#endif	
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){WireS.beginTransmission(adr); return;};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){WireS1.beginTransmission(adr); return;};
#endif		
};

uint8_t RT_HW_BASE:: i2cEndTransmission  (             							uint8_t bus){	//--5.2.EndTramsmission(bus)
//if(!i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus)) {return 4;};
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){return Wire.endTransmission();};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){return Wire1.endTransmission();};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){return Wire2.endTransmission();};
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){return WireS.endTransmission();};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){return WireS1.endTransmission();};
#endif
return 4;}

void    RT_HW_BASE:: i2cFlush            (             							uint8_t bus){	//--5.3.Flush()
#if !defined(RT_HW_BLOCK_I2C_FLUSH)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){Wire.flush();}
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){Wire1.flush();}
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){Wire2.flush();}
#endif	
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){WireS.flush();}
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){WireS1.flush();}
#endif	
//-------------------------------------
#endif
}

void    RT_HW_BASE:: i2cWrite			 (uint8_t val,                       	uint8_t bus){	//--5.5.Запись байта
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){Wire.write(val);};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){Wire1.write(val);};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){Wire2.write(val);};
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){WireS.write(val);};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){WireS1.write(val);};
#endif		
}
void    RT_HW_BASE:: i2cWrite(const uint8_t *arr, uint8_t qnt,               	uint8_t bus){	//--5.6.Запись qnt байт	
 if(qnt>32){qnt=32;} for(uint8_t i=0; i<qnt; i++){i2cWrite(arr[i],bus);}};	

void    RT_HW_BASE:: i2cWrite(const char *arr,    uint8_t qnt,               	uint8_t bus){	//--5.7.Запись qnt символов
 if(qnt>32){qnt=32;} for(uint8_t i=0; i<qnt; i++){i2cWrite(arr[i],bus);}};	

uint8_t RT_HW_BASE:: i2cRequestFrom(bool sendStop,uint8_t qnt,  uint8_t adr, 	uint8_t bus){	//--5.10.Чтение qnt байт        (в буфер  i2c)
buff.vu8=sendStop; //--Для исключения предупреждений от компилятора;
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){
#if defined(RT_HW_CORE_STM32_M_F4)
return Wire.requestFrom(adr,qnt);
#else
return Wire.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){
#if defined(RT_HW_CORE_STM32_M_F4)
return Wire1.requestFrom(adr,qnt);
#else
return Wire1.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){
#if defined(RT_HW_CORE_STM32_M_F4)
return Wire2.requestFrom(adr,qnt);
#else
return Wire2.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif	
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){
#if defined(RT_HW_CORE_STM32_M_F4)
return WireS.requestFrom(adr,qnt);
#else
return WireS.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){
#if defined(RT_HW_CORE_STM32_M_F4)
return WireS1.requestFrom(adr,qnt);
#else
return WireS1.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif		
//-------------------------------------
return 0;}

uint8_t RT_HW_BASE:: i2cAvailable(											 	uint8_t bus){	//--5.11.Проверка кол-ва байт   (в буфере i2c)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){return Wire.available();};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){return Wire1.available();};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){return Wire2.available();};
#endif
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){return WireS.available();};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){return WireS1.available();};
#endif			
return 0;}
uint8_t RT_HW_BASE:: i2cRead(                                                	uint8_t bus){	//--5.12.Чтение очередного байт (из буфера i2c)
#if defined(RT_HW_PERMIT_I2C0)
if(bus==0){return Wire.read();};
#endif	
#if defined(RT_HW_PERMIT_I2C1)
if(bus==1){return Wire1.read();};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){return Wire2.read();};
#endif
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){return WireS.read();};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){return WireS1.read();};
#endif				
return 0;};

//=================================================================================================
////									6.Производные Функции обмена с устройством
//=================================================================================================
uint8_t RT_HW_BASE:: i2cSendByte (uint8_t val,                     uint8_t adr, uint8_t bus){	//--5.1.Запись байта; 
i2cBeginTransmission(adr,bus); i2cWrite(val,bus); return i2cEndTransmission(bus);}; 
uint8_t RT_HW_BASE:: i2cSendBytes(const uint8_t *arr, uint8_t qnt, uint8_t adr, uint8_t bus){	//--5.2.Запись qnt   байт из arr[];
if(qnt>32) {qnt=32;}; 
i2cBeginTransmission(adr,bus);  
for(uint8_t i=0; i<qnt; i++){i2cWrite(arr[i],bus);} 
return i2cEndTransmission(bus);}
uint8_t RT_HW_BASE:: i2cGetBytes (bool sendStop,      uint8_t qnt, uint8_t adr, uint8_t bus){	//--5.3.Чтение qnt   байт в буфер i2c;
if(qnt>32) {qnt=32;}; 
uint8_t i2cErrCode=0;												//--Очистка кода ошибки;	
uint8_t cnt=i2cRequestFrom(sendStop,qnt,adr,bus);					//--Запрос qnt байтов в буфер; 	
if(cnt!=qnt) {return 5;}											//--Выход, ошибка запроса;
uint32_t timeOut=micros()+150*qnt;	cnt=0;							//--Тайм-аут на получение запрошенных данных;
do{cnt=i2cAvailable(bus); 											//--Чтение 
   if(cnt>=qnt){break;}												//--Ожидание  заполнения буфера
   if(getPastMcs(timeOut)>150*qnt) {i2cErrCode=6; break;}}while(1);	//запрошенными байтами; 
   return i2cErrCode; 												//--Нормальный выход;
};
uint8_t RT_HW_BASE:: i2cGetByte  (                                 uint8_t adr, uint8_t bus){	//--5.4.Чтение байта в буфер i2c;
return i2cGetBytes(1,1,adr, bus);}	   
uint8_t RT_HW_BASE:: i2cReadRegs (uint8_t reg,        uint8_t qnt, uint8_t adr, uint8_t bus){	//--5.5.Чтение qnt байт начиная регистра=reg в буфер i2c;
	uint8_t i2cErrCode;
	i2cErrCode=i2cSendByte(reg,adr,bus); if(i2cErrCode) {return i2cErrCode;}
	i2cErrCode=i2cGetBytes(1,qnt,adr,bus); if(i2cErrCode) {return i2cErrCode;}		
return 0;}

//=================================================================================================
//										7.Сервисные функции
//=================================================================================================
uint8_t RT_HW_BASE:: i2cFindAdr      (uint32_t &timeDelay, uint16_t &custom, uint8_t okMax,  	//--6.1.Поиск устройства комплексное;
                                uint8_t period, uint16_t periodMax, uint8_t adr, uint8_t bus){			
// Вход: рабочие регистры: uint32_t timeDelay, uint8_t custom, uint8_t errCnt, uint8_t okCnt;
//		 передаваемые параметры: uint8_t adr - адрес устройства,uint8_t bus - номер шины i2c;
//		 настроечные  параметры: uint8_t okMax - количество успешных повторов (по умолчанию=3),
//		 						 uint8_t period - период повторов (по умолчанию=50), 
//								 uint16_t periodMax - максимальный период повторов при ошибках((по умолчанию=2000);
// Алгоритм: перед началом работы следует установить custom=0. После подряд (okMax-кол-во) поиска, возвращается значение custom=1;
uint8_t step=custom & 0x0F; uint8_t cntOk=(custom>>4)&0x0F; uint8_t cntErr=(custom>>8)&0xFF;
//-------------------------------------------------------------------------------------------------
if(step==0) { 
i2cBegin(bus); if(i2cGetStatus(bus)==0){return 0;}
//if(!i2cCheckBus(bus)){return 0;} //--Проверка на шинy;
//if( i2cGetBitState(RT_HW_I2C_STATE_SLAVE, bus)){return 0;}
//if(!i2cGetBitState(RT_HW_I2C_STATE_INIT,  bus)){i2cBegin(bus);}
//if(!i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus)){return 0;}
step++;}
//-------------------------------------------------------------------------------------------------
//								Успешные транзакции
//-------------------------------------------------------------------------------------------------
if(step==1) {timeDelay=millis();
i2cBeginTransmission(adr,bus);  
if(i2cEndTransmission(bus)==0) {cntErr=0; if(++cntOk >=okMax){custom=0; return 1;} else{ step=2;}} //--При okMax удачных транзакций; 
else						   {cntOk=0;                                                 step=3;}} //--При ошибке;
if(step==2)	{if(getPastMs(timeDelay)>=period){											 step=1;}} //--Задержка для следующей успешной транзакции; 	 
//-------------------------------------------------------------------------------------------------
//								Задержки при не успешных транзакциях 
//-------------------------------------------------------------------------------------------------
if(step==3) {cntOk=0; cntErr+=2;  if((cntErr*100) > periodMax) {cntErr-=2;}; timeDelay=millis();  step=4;}
if(step==4)	{if(getPastMs(timeDelay)>=cntErr*100) {                                               step=1;}}	
//-------------------------------------------------------------------------------------------------
custom=(cntErr<<8) & 0xFF00; custom|=(cntOk & 0x0F)<<4; custom|=step & 0x0F;
return 0;};
uint8_t RT_HW_BASE:: i2cFindAdr(uint32_t &timeDelay, uint16_t &custom,uint8_t adr,uint8_t bus){ //--6.2.Поиск устройства adr(c фиксированными параметрами 3,20,2000);	
//#define RT_HW_I2C_FIND_QNT    	3   	//--Кол-во повторений при поиске адреса;
//#define RT_HW_I2C_FIND_PERIOD   	20   	//--Штатный период(ms) при нормальном поиске адреса;
//#define RT_HW_I2C_FIND_PERIOD_MAX 2000    //--Кол-во повторений при поиске адреса;
return i2cFindAdr(timeDelay,custom,RT_HW_I2C_FIND_QNT,RT_HW_I2C_FIND_PERIOD_CUR,RT_HW_I2C_FIND_PERIOD_MAX,adr,bus);}

void    RT_HW_BASE:: i2cHeadInterface(uint8_t bus){											//--6.3.Вывод заголовка по интерфейсу;								
if(!i2cCheckBus(bus))			{return;}	//--Проверка наличия шины;
consoleBegin();	if(!console.ok)	{return;} 	//--Настройка консоли с параметрами по умолчанию и ожидание готовности;
mess.alig='R'; mess.blank='G'; mess.modePin='A'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
uint8_t arr[]={i2cGetPinSDA(bus),i2cGetPinSCL(bus)}; 
consoleVar(String(F("I2C"))); consoleVar(bus);
consoleVar(String(F(" bus="))); consoleVar(bus,':');
consoleVar(String(F(" SDA,SCL="))); consoleArrVar(arr,';',0,'P',2); consoleBlank(15);
uint8_t status=i2cGetStatus(bus);
     if(status==1){consoleVar(String(F("  Master")),';');}
else if(status==2){consoleVar(String(F("   Slave")),';');}
else			  {consoleVar(String(F(" No init")),';');}
//consoleVar(String(F(" state=")));              		  consoleVar(i2cGetState(bus),':',0,'H');	 consoleVar(i2cGetState(bus),';',0,'B');
consoleVar(String(F(" speed(kHz)="))); consoleVar((uint32_t)(i2cGetSpeed(bus)/1000),';');
consoleCR();}

void    RT_HW_BASE:: i2cScanBus(uint8_t bus){													//--6.4.Сканирование шины i2c;							
if(!i2cCheckBus(bus))			{return;}	//--Проверка наличия шины;
consoleBegin();	if(!console.ok)	{return;} 	//--Настройка консоли с параметрами по умолчанию и ожидание готовности;
if(!i2cGetBitState(RT_HW_I2C_STATE_INIT,bus)){i2cBegin(bus); i2cHeadInterface(bus);}
mess.alig='R'; mess.blank='G';  
uint8_t arr[]={i2cGetPinSDA(bus),i2cGetPinSCL(bus)}; 
	 if(bus==9){consoleVar(String(F("ICS0")));}
else if(bus==8){consoleVar(String(F("ICS1")));}
else 		   {consoleVar(String(F("I2C"))); consoleVar(bus);}
consoleVar(String(F(" bus="))); consoleVar(bus,':');
consoleVar(String(F(" SDA,SCL="))); consoleArrVar(arr,';',0,'P',2); 
consoleVar(String(F(" scan->")));
     if( i2cGetBitState(RT_HW_I2C_STATE_SLAVE, bus)) {consoleVar(String(F("Slave")),';');} 
else if( i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus)) {;}
else 										     	 {consoleVar(String(F("No init")),';');}
if(i2cGetBitState(RT_HW_I2C_STATE_MASTER, bus)){uint8_t qnt=0;	 
for(uint8_t i=10; i<=127; i++){uint8_t code=1;
i2cBeginTransmission(i,bus); code=i2cEndTransmission(bus); 
if(code==0){if(qnt>0){consoleVar(',');} qnt++; consoleVar(i,'~',0,'A');}
} 
if(qnt>0){consoleChar(';');} consoleVar(String(F(" qnt="))); consoleVar(qnt,';');}		
consoleCR();}
//=================================================================================================
//						20.2.Настройка шины как Master
//=================================================================================================
void    RT_HW_BASE:: i2cBegin(uint8_t bus){
//-------------------------------------------------------------------------------------------------
if(!i2cCheckBus(bus))			 			{return;}	//--return if error num bus;
if( i2cGetStatus(bus))						{return;}	//--return if status is set;;			  
if( i2cGetCodeErr(bus))						{return;}	//--return if codeErr!=0;
//if(i2cGetBitState(RT_HW_I2C_STATE_MASTER,bus)) {return;};	//--Выход, если уже настроен как Master;
//-------------------------------------------------------------------------------------------------
//								5.1.0. i2c0->Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C0)								//==Инициализация bus=0 как Master;
if(bus==0){									
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_AVR) || defined(RT_HW_CORE_SAM) || defined(RT_HW_CORE_SAMD)
Wire.begin();  										//--Инициализация как master
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход;
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if  defined(RT_HW_CORE_ESP8266)
Wire.begin(i2cGetPinSDA(bus),i2cGetPinSCL(bus));  	//--Инициализация как master
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
Wire.setClockStretchLimit(260);						//--Ограничение лимита по времени;
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP32) 													
Wire.setPins(i2cGetPinSDA(bus),i2cGetPinSCL(bus));
Wire.begin();										//--Инициализация как master (SDA,SCL;
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
Wire.setTimeOut(50); 								//--По умолчанию  тайм-аут на транзакцию =50ms;	
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_M)
Wire.begin();										//--Инициализация как master;	
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход;		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif		
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) 									
Wire.setSDA(i2cGetPinSDA(bus));						//--Аппаратная настройка пина SDA;	
Wire.setSCL(i2cGetPinSCL(bus));						//--Аппаратная настройка пина SCL;		
Wire.begin(); 										//--Инициализация как master; 
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c; 
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_SEEED) 									
Wire.setSDA(i2cGetPinSDA(bus));						//--Аппаратная настройка пина SDA;	
Wire.setSCL(i2cGetPinSCL(bus));						//--Аппаратная настройка пина SCL;		
Wire.begin(); 										//--Инициализация как master; 
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c; 
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif	
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_PI_PICO) 									
Wire.setSDA(i2cGetPinSDA(bus));						//--Аппаратная настройка пина SDA;	
Wire.setSCL(i2cGetPinSCL(bus));						//--Аппаратная настройка пина SCL;		
Wire.begin(); 										//--Инициализация как master; 
Wire.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c; 
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
i2cSetStatus(0,bus); i2cSetCodeErr(68,bus);  return;
#endif
//-------------------------------------------------------------------------------------------------
i2cSetStatus(0,bus); i2cSetCodeErr(69,bus);	return;	//--errot init bus=0;
//-------------------------------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_PERMIT_I2C0)

//-------------------------------------------------------------------------------------------------
//								5.1.1. i2c1->Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)								//==Инициализация bus=0 как Master;
if(bus==1){									
//-------------------------------------------------------------------------------------------------
#if  defined(RT_HW_CORE_ESP8266)
Wire1.begin(D6,D5);  	//--Инициализация как master
Wire1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
Wire1.setClockStretchLimit(260);					//--Ограничение лимита по времени;
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP32) 													
Wire1.setPins(i2cGetPinSDA(bus),i2cGetPinSCL(bus));	//--Инициализация пинов SDA,SCL;
Wire1.begin();										//--Инициализация как master;
Wire1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
Wire1.setTimeOut(50); 								//--По умолчанию  тайм-аут на транзакцию =50ms;	
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_M)	
Wire1.begin();										//--Инициализация как master;
Wire1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход;			
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif		
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) 				 					
Wire1.setSDA(i2cGetPinSDA(bus));					//--Аппаратная настройка пина SDA;	
Wire1.setSCL(i2cGetPinSCL(bus));					//--Аппаратная настройка пина SCL;		
Wire1.begin(); 										//--Инициализация как master; 
Wire1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c; 
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_SEEED) 									
Wire1.setSDA(i2cGetPinSDA(bus));					//--Аппаратная настройка пина SDA;	
Wire1.setSCL(i2cGetPinSCL(bus));					//--Аппаратная настройка пина SCL;		
Wire1.begin(); 										//--Инициализация как master; 
Wire1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c; 
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif	
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_PI_PICO) 									
Wire1.setSDA(i2cGetPinSDA(bus));					//--Аппаратная настройка пина SDA;	
Wire1.setSCL(i2cGetPinSCL(bus));					//--Аппаратная настройка пина SCL;		
Wire1.begin(); 										//--Инициализация как master; 
Wire1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c; 
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход; 		
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus); spiSetCodeErr(68,bus);  return;
#endif
//-------------------------------------------------------------------------------------------------
i2cSetStatus(0,bus); i2cSetCodeErr(69,bus);	return;	//--errot init bus=0;
//-------------------------------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_PERMIT_I2C1)
//-------------------------------------------------------------------------------------------------
//								5.1.2. i2c2->Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)								//==Инициализация bus=0 как Master;
if(bus==2){									
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
i2cSetStatus(0,bus); i2cSetCodeErr(68,bus);  return;
#endif
//-------------------------------------------------------------------------------------------------
i2cSetStatus(0,bus); i2cSetCodeErr(69,bus);	return;	//--errot init bus=0;
//-------------------------------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_PERMIT_I2C2)
//-------------------------------------------------------------------------------------------------
//								5.1.8. i2cS->Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS)								//==Инициализация bus=0 как Master;
if(bus==0){									
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_M)
WireS.begin();  										//--Инициализация как master
WireS.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход;
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
i2cSetStatus(0,bus); i2cSetCodeErr(68,bus);  return;
#endif	
//-------------------------------------------------------------------------------------------------
i2cSetStatus(0,bus); i2cSetCodeErr(69,bus);	return;	//--errot init bus=0;
//-------------------------------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_PERMIT_I2CS)
//-------------------------------------------------------------------------------------------------
//								5.1.9. i2cS->Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS1)								//==Инициализация bus=0 как Master;
if(bus==1){								
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_M_F1) || defined(RT_HW_CORE_STM32_M_F4)
WireS1.begin();										//--Инициализация как master;	;  										//--Инициализация как master
WireS1.setClock(i2cGetSpeed(bus));					//--Установка частоты шины i2c;	
i2cSetBitState(RT_HW_I2C_STATE_MASTER,bus);			//--Установка флага MASTER; 
i2cSetBitState(RT_HW_I2C_STATE_INIT,  bus);			//--Установка флага INIT и выход;
i2cSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
i2cSetStatus(0,bus); i2cSetCodeErr(68,bus);  return;
#endif	
//-------------------------------------------------------------------------------------------------
i2cSetStatus(0,bus); i2cSetCodeErr(69,bus);	return;	//--errot init bus=0;
//-------------------------------------------------------------------------------------------------
}
//-------------------------------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_PERMIT_I2C1)
//-------------------------------------------------------------------------------------------------

}; //--END i2cBegin()
//=================================================================================================
//						20.3.Настройка шины как Slave
//=================================================================================================
void    RT_HW_BASE:: i2cBeginSlave(uint8_t bus){
if(!i2cGetBitState(RT_HW_I2C_STATE_SLAVE,bus)) {return;};
};
//#################################################################################################
//=================================================================================================
//										10.Настройка шины
//=================================================================================================
//void    RT_HW_BASE:: i2cBegin(uint8_t bus){							//==Инициализация шины i2c общая;
//if( i2cGetBitState(RT_HW_I2C_STATE_INIT,bus)) {return;};	//--Выход, если шина инициализирована;
//if((i2cGetPinSCL(bus)>=254) || (i2cGetPinSCL(bus)>=254) || (i2cGetPinSCL(bus)==i2cGetPinSDA(bus))) {return;}
//if( i2cGetAdr(bus)==0){i2cBeginMaster(bus);} else {i2cBeginSlave(bus);}}	//--Вызов инициализации Master или Slave;