 #include "RT_HW_BASE.h"
/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								1.СОЗДАНИЕ ОБЪЕКТОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_SPI0)										//==1.0.1.Определение структуры для шины SPI0			  
RT_HW_STRUCT_SPI 	LinkSPI0;
#endif	
#if defined(RT_HW_PERMIT_SPI1)										//==1.1.1.Определение для SPI1			  
RT_HW_STRUCT_SPI 	LinkSPI1;
#endif	
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_ESP32)			//==1.1.2.Создание объекта для SPI1 для ESP32
SPIClass SPI1(HSPI);
#endif 
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_M)		//==1.1.3.Создание объекта для SPI1 для STM32(M)	
SPIClass SPI1(1);
#endif
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_D)		//==1.1.4.Создание объекта для SPI1 для STM32(D)	
SPIClass SPI1(1);
#endif
#if defined(RT_HW_PERMIT_SPI2)										//==1.2.1.Определение структуры для шины SPI2			  
RT_HW_STRUCT_SPI 	LinkSPI2;						
#endif 
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_M)		//==1.2.2.Создание объекта для SPI1 для STM32(M)	
SPIClass SPI2(2);
#endif
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_D)		//==1.3.3.Создание объекта для SPI1 для STM32(D)	
SPIClass SPI2(1);
#endif
*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							2.СОЗДАНИЕ ДОПОЛНИТЕЛЬНЫХ ОБЪЕКТОВ SPI ПОД ТИП MCU
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_ESP32)			//==1.1.2.Создание объекта для SPI1 для ESP32
SPIClass SPI1(HSPI);
#endif 
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_M)		//==1.1.3.Создание объекта для SPI1 для STM32(M)	
SPIClass SPI1(1);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_D)		//==1.1.4.Создание объекта для SPI1 для STM32(D)	
SPIClass SPI1(1);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_M)		//==1.2.2.Создание объекта для SPI1 для STM32(M)	
SPIClass SPI2(2);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_D)		//==1.3.3.Создание объекта для SPI1 для STM32(D)	
SPIClass SPI2(1);
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Функции проверки номера шины, управления регистром состояния
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool 	RT_HW_BASE:: spiCheckBus(uint8_t bus){									//==2.1.Проверка номера шины
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return 1;}
#endif	
return 0;};
void    RT_HW_BASE:: spiSetBitState (uint8_t bitState, uint8_t bus){			//==2.2.Установка бита состояния
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {bitSet(LinkSPI0.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {bitSet(LinkSPI1.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {bitSet(LinkSPI2.state,bitState);}
#endif
}
void    RT_HW_BASE:: spiClearBitState(uint8_t bitState, uint8_t bus){			//==2.3.Очистка бита состояния 
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0)         {bitClear(LinkSPI0.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1)         {bitClear(LinkSPI1.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2)         {bitClear(LinkSPI2.state,bitState);}
#endif
}
void    RT_HW_BASE:: spiWriteBitState(bool val, uint8_t bitState, uint8_t bus){	//==2.4.Запись бита состояния	
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {bitWrite(LinkSPI0.state,bitState,val);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {bitWrite(LinkSPI1.state,bitState,val);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {bitWrite(LinkSPI2.state,bitState,val);}
#endif
}
void    RT_HW_BASE:: spiSetState(uint8_t val,uint8_t bus){						//==2.5.Запись регистра состояния
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.state=val;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.state=val;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.state=val;}
#endif
}
void    RT_HW_BASE:: spiSetStatus(uint8_t val,uint8_t bus){						//==2.6.Запись статуса
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.status=val;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.status=val;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.status=val;}
#endif
}
void    RT_HW_BASE:: spiSetCodeErr(uint8_t val,uint8_t bus){				    //==2.7.Запись кода ошибки
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.codeErr=val;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.codeErr=val;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.codeErr=val;}
#endif
} 
bool    RT_HW_BASE:: spiGetBitState(uint8_t bitState, uint8_t bus){				//==2.8.Чтение бита состояния
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return bitRead(LinkSPI0.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return bitRead(LinkSPI1.state,bitState);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return bitRead(LinkSPI2.state,bitState);}
#endif
return 0;}
uint8_t RT_HW_BASE:: spiGetState(uint8_t bus){									//==2.9.Чтение регистра состояния
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.state;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.state;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.state;}
#endif
return 0;};
uint8_t RT_HW_BASE:: spiGetStatus(uint8_t bus){									//==2.10.Чтение статуса
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.status;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.status;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.status;}
#endif
return 0;};
uint8_t RT_HW_BASE:: spiGetCodeErr(uint8_t bus){								//==2.11.Чтение кода ошибки
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.codeErr;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.codeErr;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.codeErr;}
#endif
return 0;};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Функции для установки номеров пинов 
//		(для sck,miso,mosi по разрешению бита слова состояния RT_HW_SPI_STATE_BLOCK_PINS=0)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void 	RT_HW_BASE:: spiSetPinSCK(uint8_t sck, uint8_t bus){		//==3.1.Запись номера пина sck 
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.sck=sck;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.sck=sck;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.sck=sck;}
#endif
};
void 	RT_HW_BASE:: spiSetPinMISO(uint8_t miso, uint8_t bus){		//==3.2.Запись номера пина miso
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.miso=miso;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.miso=miso;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.miso=miso;}
#endif
};
void 	RT_HW_BASE:: spiSetPinMOSI(uint8_t mosi, uint8_t bus){		//==3.3.Запись номера пина mosi
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.mosi=mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.mosi=mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.mosi=mosi;}
#endif
};
void 	RT_HW_BASE:: spiSetPinSS(uint8_t ss, uint8_t bus){			//==3.4.Запись номера пина ss
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.ss=ss;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.ss=ss;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.ss=ss;}
#endif
};
uint8_t RT_HW_BASE:: spiGetPinSCK(uint8_t bus){						//==3.5.Чтение номера пина sck
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.sck;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.sck;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.sck;}
#endif
return 0;};
uint8_t RT_HW_BASE:: spiGetPinMISO(uint8_t bus){					//==3.6.Чтение номера пина miso
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.miso;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.miso;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.miso;}
#endif
return 0;};
uint8_t RT_HW_BASE:: spiGetPinMOSI(uint8_t bus){					//==3.7.Чтение номера пина mosi
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.mosi;}
#endif
return 0;};
uint8_t RT_HW_BASE:: spiGetPinSS(uint8_t bus){						//==3.8.Чтение номера пина ss
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.ss;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.ss;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.ss;}
#endif
return 0;};
void 	RT_HW_BASE:: spiBeginFirst(uint8_t bus){					//==3.9.Первичная инициализация пинов
#if defined(RT_HW_PERMIT_SPI0)
if(bus==0) {LinkSPI0.state=LinkSPI0.codeErr=0;					//--clear state,codeErr;
			LinkSPI0.sck  =readArrPGM(RT_HW_PGM_PIN_SPI_ID,0);	//--set pin SCK; 
			LinkSPI0.miso =readArrPGM(RT_HW_PGM_PIN_SPI_ID,1);	//--set pin MISO;
			LinkSPI0.mosi =readArrPGM(RT_HW_PGM_PIN_SPI_ID,2);	//--set pin MOSI; 
			LinkSPI0.ss   =readArrPGM(RT_HW_PGM_PIN_SPI_ID,3);	//--set pin SS;
			LinkSPI0.speed=RT_HW_SPI_SPEED*1000UL;}            	//--set speed;
#endif
#if defined(RT_HW_PERMIT_SPI1)
if(bus==1) {LinkSPI1.state=LinkSPI1.codeErr=0;					//--clear state,codeErr;
			LinkSPI1.sck  =readArrPGM(RT_HW_PGM_PIN_SPI_ID,4);	//--set pin SCK; 
			LinkSPI1.miso =readArrPGM(RT_HW_PGM_PIN_SPI_ID,5);	//--set pin MISO;
			LinkSPI1.mosi =readArrPGM(RT_HW_PGM_PIN_SPI_ID,6);	//--set pin MOSI; 
			LinkSPI1.ss   =readArrPGM(RT_HW_PGM_PIN_SPI_ID,7);	//--set pin SS;
			LinkSPI1.speed=RT_HW_SPI_SPEED*1000UL;}				//--set speed;			
#endif
#if defined(RT_HW_PERMIT_SPI2)
if(bus==2) {LinkSPI2.state=LinkSPI2.codeErr=0;					//--clear state,codeErr;
			LinkSPI2.sck  =readArrPGM(RT_HW_PGM_PIN_SPI_ID,8);	//--set pin SCK; 
			LinkSPI2.miso =readArrPGM(RT_HW_PGM_PIN_SPI_ID,9);	//--set pin MISO;
			LinkSPI2.mosi =readArrPGM(RT_HW_PGM_PIN_SPI_ID,10);	//--set pin MOSI; 
			LinkSPI2.ss   =readArrPGM(RT_HW_PGM_PIN_SPI_ID,11);	//--set pin SS;
			LinkSPI2.speed=RT_HW_SPI_SPEED*1000UL;}				//--set speed;
#endif
}	
uint8_t RT_HW_BASE:: spiInitCS(uint8_t cs){							//==3.10.Физическая настройка пина CS[err->60];;
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,cs))    	{return 60;} 	//--Выход, если не допустимый номер пина cs;
else {digitalWrite(cs,1); pinMode(cs,OUTPUT); 	 return 0;}}	//--Настройка пина на выход;
uint8_t RT_HW_BASE:: spiInitDevice(uint8_t cs,uint8_t bus){			//==3.11.Проверка bus, настройка cs, инициализация SPI-err=60,61,62;
if(!spiCheckBus(bus))										{return 60;}	//--Check bus;
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,cs))   				{return 61;} 	//--Check cs;
spiBegin(bus); 																//--Init SPI;
if(!spiGetBitState(RT_HW_SPI_STATE_MASTER,bus))				{return 62;}	//--Check SPI as Master;
pinMode(cs,OUTPUT); digitalWrite(cs,1); pinMode(cs,OUTPUT);	 return  0;}	//--Init pin cs as OUTPUT;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Функции записи параметров транзакций
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void 	RT_HW_BASE:: spiSetSpeed(uint32_t speed, uint8_t bus){		//==4.1.Запись speed/delaySPN
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.speed=speed;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.speed=speed;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.speed=speed;}
#endif
};
void 	RT_HW_BASE:: spiSetBitOrder(uint8_t bitOrder, uint8_t bus){	//==4.2.Запись bitOrder
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.bitOrder=bitOrder;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.bitOrder=bitOrder;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.bitOrder=bitOrder;}
#endif
};
void 	RT_HW_BASE:: spiSetDataMode(uint8_t dataMode, uint8_t bus){	//==4.3.Запись dataOrder
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.dataMode=dataMode;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.dataMode=dataMode;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.dataMode=dataMode;}
#endif
};
uint8_t RT_HW_BASE:: spiGetBitOrder(uint8_t bus){					//==4.4.Чтение bitOrder
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.bitOrder;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.bitOrder;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return inkSPI2.bitOrder;}
#endif
return 0;};
uint8_t RT_HW_BASE:: spiGetDataMode(uint8_t bus){					//==4.5.Чтение dataMode
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.dataMode;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.dataMode;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.dataMode;}
#endif
return 0;};
uint32_t RT_HW_BASE::spiGetSpeed(uint8_t bus){						//==4.6.Чтение speed/delaySPN
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.speed;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.speed;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.speed;}
#endif
return 400000UL;};
void	RT_HW_BASE:: spiSetSetting      (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t bus){	//==4.7.Групповая установка speed,bitOrder,dataMode
spiSetSpeed(speed,bus); spiSetBitOrder(bitOrder,bus); spiSetDataMode(dataMode,bus);} 
void 	RT_HW_BASE:: spiBeginTransaction(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t bus){	//==4.8.Инициализация параметров транзакции с задаваемыми параметрами;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {if(bitOrder){SPI.beginTransaction (SPISettings(speed,MSBFIRST,dataMode));}
            else        {SPI.beginTransaction (SPISettings(speed,LSBFIRST,dataMode));}}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {if(bitOrder){SPI1.beginTransaction(SPISettings(speed,MSBFIRST,dataMode));}
            else        {SPI1.beginTransaction(SPISettings(speed,LSBFIRST,dataMode));}}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {if(bitOrder){SPI2.beginTransaction(SPISettings(speed,MSBFIRST,dataMode));}
            else        {SPI2.beginTransaction(SPISettings(speed,LSBFIRST,dataMode));}}
#endif
}	//++++++END i2cGetBusState()
void 	RT_HW_BASE:: spiBeginTransaction(uint8_t bus){				//==4.9.Инициализация параметров транзакции с установленными параметрами;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {if(LinkSPI0.bitOrder){SPI.beginTransaction (SPISettings(LinkSPI0.speed,MSBFIRST,LinkSPI0.dataMode));}
            else                 {SPI.beginTransaction (SPISettings(LinkSPI0.speed,LSBFIRST,LinkSPI0.dataMode));}}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {if(LinkSPI1.bitOrder){SPI1.beginTransaction(SPISettings(LinkSPI1.speed,MSBFIRST,LinkSPI1.dataMode));}
            else                 {SPI1.beginTransaction(SPISettings(LinkSPI1.speed,LSBFIRST,LinkSPI1.dataMode));}}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {if(LinkSPI2.bitOrder){SPI2.beginTransaction(SPISettings(LinkSPI2.speed,MSBFIRST,LinkSPI2.dataMode));}
            else                 {SPI2.beginTransaction(SPISettings(LinkSPI2.speed,LSBFIRST,LinkSPI2.dataMode));}}
#endif
}	//++++++END i2cGetBusState()	
void 	RT_HW_BASE:: spiEndTransaction(uint8_t bus){				//==4.10.Закрытие транзакции;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {SPI.endTransaction();}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {SPI.endTransaction();}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {SPI.endTransaction();}
#endif
}	//++++++END i2cGetBusState()	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Функции обмена
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t	 RT_HW_BASE:: spiTransfer   (uint8_t  val, 							 uint8_t bus){	//--Отправка/прием байта;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return SPI1.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return SPI2.transfer(val);}
#endif
return 0;};
uint16_t RT_HW_BASE:: spiTransfer16 (uint16_t val, 							 uint8_t bus){	//--Отправка/прием слова;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer16(val);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return SPI1.transfer16(val);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return SPI2.transfer16(val);}
#endif
return 0;};
void     RT_HW_BASE:: spiTransferArr(uint8_t  *tx, uint8_t *rx, uint8_t qnt, uint8_t bus){	//--Обмен qnt байтами;
for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(tx[i],bus);}} 
void     RT_HW_BASE:: spiWrite      (uint8_t  val, 							 uint8_t bus){ 	//--Отправка байта;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {SPI.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {SPI1.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {SPI2.transfer(val);}
#endif
};
void     RT_HW_BASE:: spiWrite16    (uint16_t val, 							 uint8_t bus){ 	//--Отправка слова;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {SPI.transfer16(val);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {SPI1.transfer16(val);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {SPI2.transfer16(val);}
#endif
};
void     RT_HW_BASE:: spiWriteArr   (uint8_t  *tx, 				uint8_t qnt, uint8_t bus){	//--Отправка qnt байт;
for(uint8_t i=0; i<qnt; i++){spiWrite(tx[i],bus);}} 
uint8_t  RT_HW_BASE:: spiRead       (uint8_t  bus){											//--Прием байта;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer(0);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return SPI1.transfer(0);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return SPI2.transfer(0);}
#endif
return 0;};
uint16_t RT_HW_BASE:: spiRead16     (uint8_t  bus){											//--Прием слова;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer16(0);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return SPI1.transfer16(0);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return SPI2.transfer16(0);}
#endif
return 0;};
void  	 RT_HW_BASE:: spiReadArr    (			   uint8_t *rx, uint8_t qnt, uint8_t bus){	//--Прием qnt байт;
for(uint8_t i=0; i<qnt; i++){rx[i]=spiRead(bus);}} 	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						6.Функции обмена комплексные
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t	 RT_HW_BASE:: SPItransfer   (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  val,                           uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	uint8_t in;
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); in=spiTransfer(val,bus);   RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);
return in;}
uint16_t RT_HW_BASE:: SPItransfer16	(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint16_t val,                           uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	uint16_t in;
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); in=spiTransfer16(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);
return in;}
void     RT_HW_BASE:: SPItransferArr(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  *tx, uint8_t *rx, uint8_t qnt, uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(tx[i],bus);} RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);}
void	 RT_HW_BASE:: SPIwrite      (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  val, 						  	 uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); spiTransfer(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);
}
void	 RT_HW_BASE:: SPIwrite16    (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint16_t val, 			 			  	 uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); spiTransfer16(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);
}
void     RT_HW_BASE:: SPIwriteArr   (uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t  *tx, 			 	uint8_t qnt, uint8_t cs, uint8_t bus){
if(qnt==0) {return;}  
RT_HW_PIN_DIR_ID idPinCS;   RT_HW_PIN_DIR_SET_ID(idPinCS,cs); 	 //--Настройка idCS;						
//-------------------------------------------------------------------------------------------------;
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){uint8_t k; if(bitOrder) {k=qnt-i-1;} else{k=i;}     
spiTransfer(tx[k],bus);} 
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);}
uint8_t	 RT_HW_BASE:: SPIread   	(uint32_t speed, uint8_t bitOrder, uint8_t dataMode,               							 uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	uint8_t in;
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); in=spiTransfer(0,bus);   RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);
return in;}
uint16_t RT_HW_BASE:: SPIread16	    (uint32_t speed, uint8_t bitOrder, uint8_t dataMode,               							 uint8_t cs, uint8_t bus){
return SPItransfer16(speed, bitOrder, dataMode, 0,cs, bus);}
void     RT_HW_BASE:: SPIreadArr    (uint32_t speed, uint8_t bitOrder, uint8_t dataMode,       		   uint8_t *rx, uint8_t qnt, uint8_t cs, uint8_t bus){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(0,bus);} RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
spiEndTransaction(bus);
}

//=================================================================================================
//							10.1. Инициализация шины SPI как Master
//=================================================================================================
void RT_HW_BASE:: spiBegin(uint8_t bus){
//-------------------------------------------------------------------------------------------------
if(!spiCheckBus(bus))			 			{return;}	//--return if error num bus;
if( spiGetStatus(bus))						{return;}	//--return if status is set;;			  
if( spiGetCodeErr(bus))						{return;}	//--return if codeErr!=0;
//-------------------------------------------------------------------------------------------------
//							10.1.0. Настройка шины 0 как Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0){											//--check bus=0;				
#if defined(RT_HW_CORE_AVR) || defined(RT_HW_CORE_SAM) || defined(RT_HW_CORE_SAMD) || defined(RT_HW_CORE_SEED)
SPI.begin(); 
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER;
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266) 
if(!SPI.pins((int8_t)spiGetPinSCK(bus),(int8_t)spiGetPinMISO(bus),(int8_t)spiGetPinMOSI(bus),0)){spiSetCodeErr(61); return;};								
SPI.begin();										//--init SPI;
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP32) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{spiSetCodeErr(61); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{spiSetCodeErr(62); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{spiSetCodeErr(63); return;}
SPI.begin(spiGetPinSCK(bus),spiGetPinMISO(bus),spiGetPinMOSI(bus));
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_M) 
SPI.begin();
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{spiSetCodeErr(61); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{spiSetCodeErr(62); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{spiSetCodeErr(63); return;}
SPI.setSCLK(spiGetPinSCK (bus));
SPI.setMISO(spiGetPinMISO(bus));
SPI.setMOSI(spiGetPinMOSI(bus));
SPI.begin();
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------	
#if defined(RT_HW_CORE_PI_PICO) 
if(!SPI.setSCK(spiGetPinSCK (bus))) {spiSetCodeErr(1,bus); return;};							
if(!SPI.setRX (spiGetPinMISO(bus))) {spiSetCodeErr(2,bus); return;};	
if(!SPI.setTX (spiGetPinMOSI(bus))) {spiSetCodeErr(3,bus); return;};	
SPI.begin();										//--init SPI;
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER;	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus); spiSetCodeErr(68,bus);  return;
#endif
//-------------------------------------------------------------------------------------------------	
spiSetStatus(0,bus); spiSetCodeErr(69,bus);	return;}//--errot init bus=0;
//-------------------------------------------------------------------------------------------------	
#endif    //--#if defined(RT_HW_PERMIT_SPI0)	
//-------------------------------------------------------------------------------------------------
//							10.1.1. Настройка шины 1 как Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1){											//--check bus=1;				
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP32) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{spiSetCodeErr(61); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{spiSetCodeErr(62); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{spiSetCodeErr(63); return;}
SPI1.begin(spiGetPinSCK(bus),spiGetPinMISO(bus),spiGetPinMOSI(bus));
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_M) 
SPI1.begin();
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{spiSetCodeErr(61); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{spiSetCodeErr(62); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{spiSetCodeErr(63); return;}
SPI.setSCLK(spiGetPinSCK (bus));
SPI.setMISO(spiGetPinMISO(bus));
SPI.setMOSI(spiGetPinMOSI(bus));
SPI.begin();
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//-------------------------------------------------------------------------------------------------	
#if defined(RT_HW_CORE_PI_PICO) 
if(!SPI1.setSCK(spiGetPinSCK (bus))) {spiSetCodeErr(1,bus); return;};							
if(!SPI1.setRX (spiGetPinMISO(bus))) {spiSetCodeErr(2,bus); return;};	
if(!SPI1.setTX (spiGetPinMOSI(bus))) {spiSetCodeErr(3,bus); return;};	
SPI1.begin();										//--init SPI;
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER;	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus); spiSetCodeErr(68,bus);  return;
#endif
//-------------------------------------------------------------------------------------------------	
spiSetStatus(0,bus); spiSetCodeErr(69,bus);	return;}//--errot init bus=1;
//-------------------------------------------------------------------------------------------------	 		
#endif
//-------------------------------------------------------------------------------------------------
//							10.1.2. Настройка шины 2 как Master
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2){												//--check bus=1;				
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{spiSetCodeErr(61); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{spiSetCodeErr(62); return;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{spiSetCodeErr(63); return;}
SPI2.setSCLK(spiGetPinSCK (bus));
SPI2.setMISO(spiGetPinMISO(bus));
SPI2.setMOSI(spiGetPinMOSI(bus));
SPI2.begin();
spiSetBitState(RT_HW_SPI_STATE_INIT, bus); 			//--set flag.permit.INIT;
spiSetBitState(RT_HW_SPI_STATE_MASTER,bus);			//--set flag.permit.MASTER; 	
spiSetStatus(1,bus); return;						//--Set status=Master;
#endif
//--------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus); spiSetCodeErr(68,bus);  return;
#endif
//-------------------------------------------------------------------------------------------------
spiSetStatus(0,bus); spiSetCodeErr(69,bus);	return;}	//--errot init bus=0;
#endif	
//=================================================================================================  	
return;}       //++++++END spiBegin()




//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								4.ФУНКЦИИ ИНИЦИАЛИЗАЦИИ И ЗАВЕРШЕНИЯ ТРАНЗАКЦИИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								5.ФУНКЦИИ ОБМЕНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//							5.1. Запись байта
//=================================================================================================

//=================================================================================================
//							5.2. Чтение байта
//=================================================================================================

//=================================================================================================
//							5.3. Отправка и прием байта
//=================================================================================================
/*uint8_t RT_HW_BASE:: spiTransfer(uint8_t val, uint8_t bus){
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return SPI1.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return SPI2.transfer(val);}
#endif
#if defined(RT_HW_PERMIT_SPN0)	
if(bus==9) {
//=================================================================================================
uint8_t dataMode=LinkSPN0.dataMode;											//--Сохранение параметра формата обмена;
uint8_t time=LinkSPN0.delaySPN;											//--Сохранение времени задержки;
uint8_t tx=val; if(LinkSPN0.bitOrder==LSBFIRST){tx=changeBitByte(tx);}		//--Сохранение передавемых данных с учетом параметра bitOrder;
uint8_t rx=0;																//--Очистка регистра для чтения;
RT_HW_PIN_DIR_ID idPinSCK;  RT_HW_PIN_DIR_SET_ID(idPinSCK, LinkSPN0.sck); 	//--Настройка ID на пин sck;
RT_HW_PIN_DIR_ID idPinMOSI; RT_HW_PIN_DIR_SET_ID(idPinMOSI,LinkSPN0.mosi);	//--Настройка ID на пин mosi;													
RT_HW_PIN_DIR_ID idPinMISO; RT_HW_PIN_DIR_SET_ID(idPinMISO,LinkSPN0.miso);	//--Настройка ID на пин mosi;	
//================================================================================================-
if(bitRead(LinkSPN0.state,RT_HW_SPI_STATE_MOSI)) {RT_HW_PIN_DIR_MODE_OUTPUT(idPinMOSI);}	//--Настройка пина mosi на вывод;
if(bitRead(LinkSPN0.state,RT_HW_SPI_STATE_MISO)) {RT_HW_PIN_DIR_MODE_PULLUP(idPinMISO);}	//--Настройка пина miso на ввод;
//=================================================================================================
     if(dataMode==SPI_MODE0){RT_HW_PIN_DIR_WRITE_LOW(idPinSCK); RT_HW_PIN_DIR_MODE_OUTPUT(idPinSCK);	//--0->sck,OUTPUT;
for(uint8_t i=0;i<8; i++)   {																			//--Последовательная обработка 8 бит;
if(bitRead(LinkSPN0.state,RT_HW_SPI_STATE_MOSI)) {   RT_HW_PIN_DIR_WRITE(idPinMOSI,(tx & 1<<(7-i)));}	//--bit(7-i)->mosi;
RT_HW_PIN_DIR_WRITE_HIGH(idPinSCK);																		//--1->sck;
if(bitRead(LinkSPN0.state,RT_HW_SPI_STATE_MISO)) {if(RT_HW_PIN_DIR_READ(idPinMISO)){rx|=1<<(7-i);}}	//--read(bit(7-i));
RT_HW_DELAY(time); RT_HW_PIN_DIR_WRITE_LOW(idPinSCK);}} 												//--delay; 0->sck;
//=================================================================================================																		//--Очистка пина mosi;
if(LinkSPN0.bitOrder==LSBFIRST){rx=changeBitByte(rx);}//--Сохранение передавемых данных с учетом параметра bitOrder;
return rx;}
//=================================================================================================	
#endif
return 0;};
*/
//=================================================================================================