/*** FLProg ************** Библиотека RT_HW_HD44780 ver2.1 для Arduino ***************
  Вывод на несколько LCD типа HD44780 переменных String, char, int16_t, float в указанное место указанного дисплея.
  Если задана длина (len) выводимого сообщения, то вывод осуществляется в пределах указанной длины или до конца  строки.
  Если len=0, то вывод осуществляется до конца строк. 
  Сообщение может быть отформатировано(alig) в пределах заданной длины  влево ('L'), по центру ('C'), право ('R').
    При этом к сообщению добавляются пробелы или оно обрезается. Если alig='N' (или другой отличный символ 
	кроме 'L','C','R'), то форматирование не осуществляется. При этом надо иметь ввиду что более короткое сообщение
	не затрет предыдущее более длинное сообщение. Поэтому рекомендуется явно задавать вид форматирования или использовать
    форматирование по умолчанию, которое в библиотеке ='L' (влево).
  Имеется функция вывода мерцающего символа по указанному адресу.	
	
  Библиотеки  разрабатываются с учетом особенностей использования в системе визуального программирования FLProg.
  ecoins@mail.ru 29.09.2019г.
  Обновление 03.07.21 Добавлен режим 40 колонок х 4 строки; 
**************************************************************************************************/
//#################################################################################################
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_HD44780_h
#define RT_HW_HD44780_h
#define RT_HW_HD44780_VER 		 18							//--Номер версии библиотеки;
//#define RT_HW_HD44780_EXT_GEN_RUS							//--Внешний генератор русских символов (В РАЗРАБОТКЕ);
#include "RT_HW_BASE.h"										//--Подключение базовой библиотеки;
#include "EXT_010_HD44780/HD44780_01_defined.hpp"			//--defined,enum,константы в PROGMEM;
#include "EXT_010_HD44780/HD44780_02_struct.hpp"			//--структуры данных;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     КЛАСС УПРАВЛЕНИЯ LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_HD44780{
public:
//-------1.0.Создание объектов и конструктор-------------------------------------------------------
RT_HW_HD44780_HIVE 		hive;								//--Общие данные для работы библиотеки;
RT_HW_HD44780_DEVICE_ID *ptr[RT_HW_HD44780_MAX_DEVICE+1];	//--Массив указателей на данные со структурой устройств				
RT_HW_HD44780_DEVICE_ID zN;									//--Данные для копирования в не инициализированные указатели;
RT_HW_HD44780(); 

//-------1.1.Функции настройки и управления устройством (Main.cpp)--------------------------------
#include "EXT_010_HD44780/HD44780_10_Main_h.hpp"			//--API: управление основным блоком;
#include "EXT_010_HD44780/HD44780_11_Send_h.hpp"			//--API: отправка данных/инструкций в Lcd;
#include "EXT_010_HD44780/HD44780_12_InitBus_h.hpp"			//--API: инициализация шин и i2c,SPI,BUS4,BUS8;
#include "EXT_010_HD44780/HD44780_13_InitLcd_h.hpp"			//--API: инициализация шин и Lcd;
#include "EXT_010_HD44780/HD44780_30_extBlockSetParam_h.hpp"//--API: инициализация шин и Lcd;
#include "EXT_010_HD44780/HD44780_31_extBlockGenerator_h.hpp"//--API: инициализация шин и Lcd;
#include "EXT_010_HD44780/HD44780_40_extBlockForWrite_h.hpp"//--API: функций форматированного вывода в Lcd;
#include "EXT_010_HD44780/HD44780_41_extBlockWrite_h.hpp"	//--API: функций форматированного вывода в Lcd;
#include "EXT_010_HD44780/HD44780_50_Utilities_h.hpp"		//--API функций отправки данных/инструкций в Lcd;															//--Установка адреса указателя;
};//==============  Конец класса ==================================================================
extern RT_HW_HD44780 RT_HW_hd44780; //--Создание объекта LCD типа HD44780
#endif
//=================================================================================================
