#include "RT_HW_NEXT.h"
//=================================================================================================
//						Constructor												
//=================================================================================================
RT_HW_NEXT:: RT_HW_NEXT(){
for(int8_t i=0; i<=RT_HW_NEXT_MAX_DEVICE;i++){								//--Заполнение указателей ссылкой на непустое устройство;
 ptr[i]=&zN; 																//--Запись указателя;
 ptr[i]->custom=0; ptr[i]->num=0;  ptr[i]->ready=0;  ptr[i]->uart=255;		//--Запись параметров;
 ptr[i]->lenArrByte=sizeof(hive.arrByte)/1; ptr[i]->ptrArrByte=hive.arrByte;//--Начальная запись параметров массива v8;
 ptr[i]->lenArrWord=sizeof(hive.arrWord)/2; ptr[i]->ptrArrWord=hive.arrWord;//--Начальная запись параметров массива v16;   
 ptr[i]->lenArrLong=sizeof(hive.arrLong)/4; ptr[i]->ptrArrLong=hive.arrLong;//--Начальная запись параметров массива v32;
} hive.set=0x00; hive.qnt=0;};
//=================================================================================================
//						Настройка устройства ID блока управления								
//=================================================================================================
void RT_HW_NEXT:: setID(RT_HW_STRUCT_NEXT_DEVICE &z, uint8_t *arrByte,  uint16_t *arrWord,   uint32_t *arrLong, 
                                                     uint8_t lenArrByte,uint8_t  lenArrWord, uint8_t lenArrLong){
if(z.custom==0) {													//--to avoid re-initialization;
z.num=z.dir=z.blink=z.ready=z.readyRead=0;							//--clear registers;
if(!RT_HW_Base.uartCheckNum(z.uart)) {z.custom=90; return;}			//--check allow num UART;
z.num=RT_HW_Base.setFistFreeDevice(hive.set,RT_HW_NEXT_MAX_DEVICE);	//--getting number free device;
if(z.num==0) 		                 {z.custom=91; return;}			//--check number getting free device;
ptr[z.num]=&z;														//--reservation pointer ID;
z.ptrArrByte=arrByte; 												//--reservation pointer byte array;  
z.ptrArrWord=arrWord; 												//--reservation pointer word array;    
z.ptrArrLong=arrLong; 												//--reservation pointer long array; 
z.lenArrByte=lenArrByte; 											//--reservation size    byte array;  
z.lenArrWord=lenArrWord;											//--reservation size    word массива;    
z.lenArrLong=lenArrLong;											//--reservation size    long массива; 
//z.periodPack=10;								    				//--timeout for read one byte;
z.cntGetPackAll=z.cntGetPackOk=0;
//z.cntWatchDogBusy=
z.busy=0;
z.durationByte=((1000000UL/z.speed)+1)*8;							//--Длительность приема/передачи одного байта;
z.custom=1;}};
//=================================================================================================
//					Тактирующий генератор для блока управления												
//if(z.busy){z.cntWatchDogBusy++; if(z.cntWatchDogBusy>RT_HW_HD44780_WATCH_DOG_BUSY){z.cntWatchDogBusy=0; z.busy=0;}}
//=================================================================================================
//void RT_HW_NEXT:: generator(RT_HW_STRUCT_NEXT_DEVICE &z){					//==generator tick;
//-------------------------------------------------------------------------------------------------
//if(z.stepSendGen==0){if(z.busy) {z.delaySendGen=(z.durationByte*z.lenSendPack)*1.5;    z.stepSendGen++;}}
//if(z.stepSendGen==1){if(RT_HW_Base.getPastMcs(z.timeSendGen)>z.delaySendGen){z.busy=0; z.stepSendGen=0;}}
//z.busy=0;
//-------------------------------------------------------------------------------------------------
//if(z.cntPack>0){
//   if(RT_HW_Base.getPastMcs(z.timePack)>z.periodPack) {z.cntPack--; z.timePack=micros();}} //--Уменьшение счетчика транзакций с периодичностью=f(speed UART);
//-------------------------------------------------------------------------------------------------
//z.event=0;
//if(RT_HW_Base.periodMs(z.timeStart, RT_HW_NEXT_PERIOD_BLINK)){
//   if(z.busy){z.cntWatchDogBusy++; if(z.cntWatchDogBusy>RT_HW_NEXT_WATCH_DOG_BUSY){z.cntWatchDogBusy=0; z.busy=0;}} //--Контроль
//   z.blink=!z.blink;  z.event=1; 
   //if(z.cntPack==0){z.timePack=micros();}
	//if(++z.cntReboot>20){z.blinkReboot=!z.blinkReboot; z.eventReboot=1; z.cntReboot=1;}
	//}
//};
//=================================================================================================
//				Проверка и управления флагом занятости устройством										
//=================================================================================================
bool RT_HW_NEXT:: checkBusy   	(uint8_t num)      {return ptr[num]->busy;}
void RT_HW_NEXT:: setBusy     	(uint8_t num)             {ptr[num]->busy=1; ptr[num]->timeSendGen=micros();}
void RT_HW_NEXT:: setLenSendPack(uint8_t num, uint8_t len){ptr[num]->lenSendPack=len;}

//=================================================================================================
//				Управления устройством										
//=================================================================================================
void RT_HW_NEXT:: direct   (RT_HW_STRUCT_NEXT_DEVICE &z){					//==direct Nextion;
//-------------------------------------------------------------------------------------------------
if(z.stepSendGen==0){if(z.busy) {z.delaySendGen=(z.durationByte*z.lenSendPack)*1.5;    z.stepSendGen++;}}
if(z.stepSendGen==1){if(RT_HW_Base.getPastMcs(z.timeSendGen)>z.delaySendGen){z.busy=0; z.stepSendGen=0;}}
//-------------------------------------------------------------------------------------------------
if(z.dir==0) {if(z.custom==0) {return;} z.dir++;}				//--wait custom ID;
if(z.dir==1) {RT_HW_Base.uartBegin(z.uart); z.dir++;} 	//--init UART;		  
if(z.dir==2) {if(!RT_HW_Base.uartSerial(z.uart)){return;}		//--wair ready UART;
			  z.ready=1; z.step=0; z.dir=10;}					//--goto to work; 
if(z.dir==10){getFromNxt(z);   return;}							//--get packer from Nextion          
}
//=================================================================================================
//				Прием транзакций из Nextion в фоновом режиме
//=================================================================================================
void RT_HW_NEXT:: getFromNxt(RT_HW_STRUCT_NEXT_DEVICE &z){
//-------------------------------------------------------------------------------------------------
//				Очистка параметов 
//-------------------------------------------------------------------------------------------------
if(z.step==0) {z.index=z.codeErr=z.step=0;	 
               for(uint8_t i=0; i<RT_HW_NEXT_BUFF_REG_SIZE; i++){z.buff[i]=0;}	//--Clearing buff;
			   z.step++; return;}												//--goto next step;
//-------------------------------------------------------------------------------------------------
//				Ожидание заголовка принимаемой транзакции
//-------------------------------------------------------------------------------------------------
if(z.step==1) {if(!RT_HW_Base.uartAvailable(z.uart)){return;}	//--waiting first code head;
			   uint8_t vRX=RT_HW_Base.uartRead(z.uart);
	z.codeErr=0;
	//RT_HW_Base.consoleCR();
	//RT_HW_Base.consoleVar(String(F("head="))); RT_HW_Base.consoleVar(vRX,':',0,'H');
	
z.index=0;
               if(vRX!=0x3A){return;}	//--check first code head(==0x3A);
			   z.buff[z.index]=0x3A; z.index++;					//--store first code head;
			   z.head=0x3A;  
               z.timeGet=millis(); z.step++;}
//-------------------------------------------------------------------------------------------------
//				Обработка заголовка принимаемой транзакции (func,qnt,qntByte)
//-------------------------------------------------------------------------------------------------
if(z.step==2) {do{
			   if(RT_HW_Base.uartAvailable(z.uart)){
			      z.buff[z.index]=RT_HW_Base.uartRead(z.uart); z.timeGet=millis();	
	//RT_HW_Base.consoleVar(z.index,'_');RT_HW_Base.consoleVar(z.buff[z.index],',',0,'H');
				  if(z.index==1) {z.func=z.buff[z.index]; 
				                  if((z.func!=0x06)&&(z.func!=0x16)&&(z.func!=0x26)) {z.codeErr=51; z.step=0;  return;}} //--check code func;	
				  if(z.index==2) {z.adr=z.buff[z.index];}
				  if(z.index==3) {z.qnt=z.buff[z.index];}
				  if(z.index==4) {z.qntByte=z.buff[z.index];
								  if(z.func==0x06){if(z.qntByte!=z.qnt) 	{z.codeErr=60;} else {if((z.adr+z.qnt)> z.lenArrByte) {z.codeErr=61;}}}
                                  if(z.func==0x16){if(z.qntByte!=(z.qnt*2)) {z.codeErr=62;} else {if((z.adr+z.qnt)> z.lenArrWord) {z.codeErr=63;}}}	
	                              if(z.func==0x26){if(z.qntByte!=(z.qnt*4)) {z.codeErr=64;} else {if((z.adr+z.qnt)> z.lenArrLong) {z.codeErr=65;}}}
	                              if(z.codeErr!=0){z.step=0; return;}
	                              if(z.qntByte>32){z.step=0; return;}}
                                  z.index++;
								  if(z.index>4){z.step++; break;}}
				  if(RT_HW_Base.getPastMs(z.timeGet)>z.timeOutGetByte)      {z.codeErr=70; z.step=0; return;}
				 } while(1);}
//-------------------------------------------------------------------------------------------------
//				Обработка данных транзакций + crc + end
//-------------------------------------------------------------------------------------------------
if(z.step==3) {do{	
               if(RT_HW_Base.uartAvailable(z.uart)){
		          z.buff[z.index]=RT_HW_Base.uartRead(z.uart); z.timeGet=millis();
				  if(z.index==z.qntByte+5) {z.crc=z.buff[z.index];}
		          z.index++;
		          if(z.index>(z.qntByte+5)){z.step++; break;}}
		          if(RT_HW_Base.getPastMs(z.timeGet)>z.timeOutGetByte) 		{z.codeErr=71; z.step=0; return;}	//--check time-out transaction;	
				 } while(1);
				 // RT_HW_Base.consoleCR();
				 
				 }   
//-------------------------------------------------------------------------------------------------
//				Обработка целостности транзакций
//-------------------------------------------------------------------------------------------------
if(z.step==4) {z.crcCalc=0; z.readyRead=1; z.cntGetPackAll++;
			   //RT_HW_Base.consoleVar(String(F("Next ->send n="))); RT_HW_Base.consoleVar((z.qntByte+4+1),'_');
			   for(uint8_t i=0;i<=(z.qntByte+4); i++){z.crcCalc=z.crcCalc+z.buff[i];}			   
			   //for(uint8_t i=0;i<=(z.qntByte+5); i++){RT_HW_Base.consoleVar(z.buff[i],',',0,'H');}
			   z.crcCalc=z.crcCalc&0xFF;
               z.crcCalc=0xFF-z.crcCalc;	
			   z.crcCalc++;
			   //RT_HW_Base.consoleVar((uint8_t)z.crcCalc,'E',0,'H');
               if(z.crcCalc!=z.crc)  {z.codeErr=85; z.step=0; return;} 
			   for(uint8_t i=0; i<z.qnt;i++){
			       if(z.func==0x06) {uint8_t  bf= z.buff[i+5]; 					     	   setValArr(z.num,'B',(z.adr+i),bf);}
	               if(z.func==0x16) {uint16_t bf=(z.buff[i*2+1+5]<<8)+z.buff[i*2+5]; i+=1; setValArr(z.num,'W',(z.adr+i),bf);}
                   if(z.func==0x26) {uint32_t bf=(z.buff[i*4+1+5]<<8)+z.buff[i*4+5]; i+=3; setValArr(z.num,'L',(z.adr+i),bf);}}	
               z.cntGetPackOk++; z.codeErr=0; z.step=0; return;}
//---------------------------------------------------------------------------------------------------    	
}
//=================================================================================================
//				Настройка для блока отправки транзакций в Nextion 
//=================================================================================================
void RT_HW_NEXT:: setValID (RT_HW_STRUCT_NEXT_WRITE_VAL &id){
if(id.custom==0){if(!checkNum(id.num)) {return;}				//--Выход, если недопустимый номер устройства;
			     id.agoBlink=ptr[id.num]->blink;				//--Синхронизация с тактирующим генератором;
				 id.dir=0;			 
				 id.run=1;
				 id.custom=1;}};
//=================================================================================================
//							Отправка данных  в формате "in"+"адрес"="val"
//=================================================================================================
void RT_HW_NEXT:: sendVal(RT_HW_STRUCT_NEXT_WRITE_VAL &id, uint8_t adr, int32_t val){	//==sending value to Nextion;
if(id.dir==0) {if(id.custom==0) 		{return;} id.dir++;}		//--wait custom ID; 
if(id.dir==1) {if(id.run==0)    		{return;} id.dir++;}		//--check готовности переменной для вывода;
if(id.dir==2) {if(checkBusy(id.num))	{return;} setBusy(id.num);	uint8_t len=0; String str;
			   str="in";        	RT_HW_Base.uartPrint(ptr[id.num]->uart,str); 		len+=str.length();			
			   str=String(adr);	    RT_HW_Base.uartPrint(ptr[id.num]->uart,str); 		len+=str.length();
									RT_HW_Base.uartWrite(ptr[id.num]->uart,0x3D);		len+=1;
			   str=String(val);   	RT_HW_Base.uartPrint(ptr[id.num]->uart,str);		len+=str.length();			
			   for(uint8_t i=0;i<3;i++){RT_HW_Base.uartWrite(ptr[id.num]->uart,0XFF);}	len+=6;	
			   setLenSendPack(id.num,len); id.run=0; id.dir=0; return;}
}; //--END sendVal() 
//=================================================================================================
//							Отправка данных  в формате "name"="val"
//=================================================================================================
void RT_HW_NEXT:: sendNameVal (RT_HW_STRUCT_NEXT_WRITE_VAL &id, String name, int32_t val){	//==sending value to Nextion;
if(id.dir==0) {if(id.custom==0) 		{return;} id.dir++;}		//--wait custom ID; 
if(id.dir==1) {if(id.run==0)    		{return;} id.dir++;}		//--check готовности переменной для вывода;
if(id.dir==2) {if(checkBusy(id.num))	{return;} setBusy(id.num);	uint8_t len=0; String str;
									RT_HW_Base.uartPrint(ptr[id.num]->uart,name); 		len+=name.length();				
			   						RT_HW_Base.uartWrite(ptr[id.num]->uart,0x3D);		len+=1;
			   str=String(val);   	RT_HW_Base.uartPrint(ptr[id.num]->uart,str);		len+=str.length();					
			   for(uint8_t i=0;i<3;i++){RT_HW_Base.uartWrite(ptr[id.num]->uart,0XFF);}	len+=6;	
			   setLenSendPack(id.num,len); id.run=0; id.dir=0; return;}
}; //--END sendVal() 
//=================================================================================================
//							Отправка данных  в формате "inst"
//=================================================================================================
void RT_HW_NEXT:: sendInst (RT_HW_STRUCT_NEXT_WRITE_VAL &id, String inst){	//==sending value to Nextion;
if(id.dir==0) {if(id.custom==0) 		{return;} id.dir++;}		//--wait custom ID; 
if(id.dir==1) {if(id.run==0)    		{return;} id.dir++;}		//--check готовности переменной для вывода;
if(id.dir==2) {if(checkBusy(id.num))	{return;} setBusy(id.num);	uint8_t len=0; String str;
									RT_HW_Base.uartPrint(ptr[id.num]->uart,inst); 		len+=inst.length();									
			   for(uint8_t i=0;i<3;i++){RT_HW_Base.uartWrite(ptr[id.num]->uart,0XFF);}	len+=6;	
			   setLenSendPack(id.num,len); id.run=0; id.dir=0; return;}
}; //--END sendVal()
//=================================================================================================
//								Функции для работы с массивами 		
//================================================================================================= 
bool 	 RT_HW_NEXT:: checkNum	(uint8_t num){						//==check доступности устройства с номером num;
 if((num==0) || (num>RT_HW_NEXT_MAX_DEVICE)){return 0;} else {return 1;}}
//-------------------------------------------------------------------------------------------------
uint32_t RT_HW_NEXT:: getPtrArr (uint8_t num, char mode){			//==getting address pointer array; 
if(checkNum(num)){
if(mode=='B'){return (uint32_t)ptr[num]->ptrArrByte;}
if(mode=='W'){return (uint32_t)ptr[num]->ptrArrWord;}
if(mode=='L'){return (uint32_t)ptr[num]->ptrArrLong;}
if(mode=='Z'){return (uint32_t)ptr[num];}} 
              return (uint32_t)ptr[0]->ptrArrLong;}	
//-------------------------------------------------------------------------------------------------
uint8_t  RT_HW_NEXT:: getLenArr (uint8_t num, char mode){ 			//==getting len array;
if(checkNum(num)){
if((num==0) || (num>RT_HW_NEXT_MAX_DEVICE)){return 0;} 	
if(mode=='B'){return ptr[num]->lenArrByte;}
if(mode=='W'){return ptr[num]->lenArrWord;}
if(mode=='L'){return ptr[num]->lenArrLong;}
if(mode=='Z'){return ptr[num]->lenArrLong;}} return 0;}
//-------------------------------------------------------------------------------------------------
uint32_t RT_HW_NEXT:: getValArr (uint8_t num, char mode, uint8_t index){ //==getting value from array;
if(checkNum(num)){
if(mode=='B'){if(index>=getLenArr(num,'B')) {return 0;} else {uint8_t  *arr=ptr[num]->ptrArrByte; return arr[index];}}
if(mode=='W'){if(index>=getLenArr(num,'W')) {return 0;} else {uint16_t *arr=ptr[num]->ptrArrWord; return arr[index];}}
if(mode=='L'){if(index>=getLenArr(num,'L')) {return 0;} else {uint32_t *arr=ptr[num]->ptrArrLong; return arr[index];}}} return 0;}
//-------------------------------------------------------------------------------------------------
void     RT_HW_NEXT:: setValArr (uint8_t num, char mode, uint8_t index, uint32_t val){ //==setting value to array;
if(checkNum(num)){
if(mode=='B'){if(index>=getLenArr(num,'B')) {return;} else {uint8_t  *arr=ptr[num]->ptrArrByte; arr[index]= (uint8_t)val;}}
if(mode=='W'){if(index>=getLenArr(num,'W')) {return;} else {uint16_t *arr=ptr[num]->ptrArrWord; arr[index]=(uint16_t)val;}}
if(mode=='L'){if(index>=getLenArr(num,'L')) {return;} else {uint32_t *arr=ptr[num]->ptrArrLong; arr[index]=(uint32_t)val;}}}}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
RT_HW_NEXT RT_HW_Next;	//Создание внешнего объекта	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
